unit MyParams;

interface
uses windows;

function GetCommandLine: PChar; stdcall; external 'kernel32.dll' name 'GetCommandLineA';
function GetModuleFileName(Module: Integer; Filename: PChar;
         Size: Integer): Integer; stdcall;
         external 'kernel32.dll' name 'GetModuleFileNameA';
function GetParamStr(P: PChar; var Param: string): PChar;
function ParamCount: Integer;
function ParamStr(Index: Integer): string;

function DivFullPath(FullPath : string; PathTrueNameFalse : boolean) : string;
function GetFileNameNoExt(FileName : string) : string;

implementation

function GetParamStr(P: PChar; var Param: string): PChar;
var
  Len: Integer;
  Buffer: array[Byte] of Char;
begin
  while True do
  begin
    while (P[0] <> #0) and (P[0] <= ' ') do Inc(P);
    if (P[0] = '"') and (P[1] = '"') then Inc(P, 2) else Break;
  end;
  Len := 0;
  while P[0] > ' ' do
    if P[0] = '"' then
    begin
      Inc(P);
      while (P[0] <> #0) and (P[0] <> '"') do
      begin
        Buffer[Len] := P[0];
        Inc(Len);
        Inc(P);
      end;
      if P[0] <> #0 then Inc(P);
    end else
    begin
      Buffer[Len] := P[0];
      Inc(Len);
      Inc(P);
    end;
  SetString(Param, Buffer, Len);
  Result := P;
end;

function ParamCount: Integer;
var
  P: PChar;
  S: string;
begin
  P := GetParamStr(GetCommandLine, S);
  Result := 0;
  while True do
  begin
    P := GetParamStr(P, S);
    if S = '' then Break;
    Inc(Result);
  end;
end;

function ParamStr(Index: Integer): string;
var
  P: PChar;
  Buffer: array[0..260] of Char;
begin
  if Index = 0 then
    SetString(Result, Buffer, GetModuleFileName(0, Buffer, SizeOf(Buffer)))
  else
  begin
    P := GetCommandLine;
    while True do
    begin
      P := GetParamStr(P, Result);
      if (Index = 0) or (Result = '') then Break;
      Dec(Index);
    end;
  end;
end;

function DivFullPath(FullPath : string; PathTrueNameFalse : boolean) : string;
var
  l, f, i : dword;
begin
result := FullPath;
l := length(result);

if (l = 0) or (l > MAX_PATH + 1) then
begin
if PathTrueNameFalse then result := 'c:\error.err\' else result := 'error.err';
exit;
end; {end if}

for f := l downto 1 do begin
   i := f;
   if (result[f] = '\') or (result[f] = '/') then break;
end; {next f}

if PathTrueNameFalse then
SetLength(result, i)
else result := copy(FullPath, i + 1, l - i);
end;

function GetFileNameNoExt(FileName : string) : string;
var  l, f, i : dword;
begin result := FileName;

l := length(result);
if l = 0 then begin result := 'error'; exit; end;

for f := l downto 1 do begin
   i := f;
   if result[f] = '.' then begin dec(i); SetLength(result, i); break; end;
end; {next f}

end;

end.
