unit MyThread;

interface

uses Windows;

////////////////////////////////////////////////////////////////////////////////
// TLiteThread
// _____________________________________________________________________________
//  
////////////////////////////////////////////////////////////////////////////////
type
  TThread = class(TObject)
  private
    FThrCallback: Pointer;
    FThrHandle  : THandle;
    FThrIdent   : DWord;
    function    ThreadCallback(Param: Pointer): DWord; stdcall;
  protected
    function    ThreadProcedure: DWord; virtual;
  public
    property    ThrHandle: THandle read FThrHandle;
    property    ThrIdent: DWord read FThrIdent;
  public
    constructor Create; virtual;
    destructor  Destroy; override;
  end;

implementation

////////////////////////////////////////////////////////////////////////////////
// TLiteThread
// _____________________________________________________________________________
//  / 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
constructor TThread.Create;
begin
  inherited Create;
  //      
  FThrCallback := VirtualAlloc(nil, 12, MEM_RESERVE OR MEM_COMMIT, PAGE_EXECUTE_READWRITE);
  //    
  asm
    mov  EAX, Self
    mov  ECX, [EAX].TThread.FThrCallback
    mov  word  ptr [ECX+0], $6858               // pop  EAX
    mov  dword ptr [ECX+2], EAX                 // push _Self_
    mov  word  ptr [ECX+6], $E950               // push EAX
    mov  EAX, OFFSET(TThread.ThreadCallback)
    sub  EAX, ECX
    sub  EAX, 12
    mov  dword ptr [ECX+8], EAX                 // jmp  TLiteThread.ThreadCallback
  end;
  //  
  FThrHandle := CreateThread(nil, 0, FThrCallback, nil, CREATE_SUSPENDED, FThrIdent);
end;

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
destructor TThread.Destroy;
begin
  //  
  CloseHandle(FThrHandle);
  //     
  VirtualFree(FThrCallback, 0, MEM_RELEASE);
  //   
  inherited;
end;

////////////////////////////////////////////////////////////////////////////////
// TLiteThread
// _____________________________________________________________________________
//  
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
function TThread.ThreadCallback(Param: Pointer): DWord;
begin
  //    
  Result := ThreadProcedure;
end;

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
function TThread.ThreadProcedure: DWord;
begin
  //   
  Result := 0;
end;

end.
