unit MyFButt;

interface

uses Windows, Messages, MyUtils, dbg;

////////////////////////////////////////////////////////////////////////////
   function EbutCreate(hwnd, happ: THandle; caption : string;
                       left, top, width, height: integer;
                       flat, fas : boolean) : THandle;
////////////////////////////////////////////////////////////////////////////
   function EBmpCreate(hwnd, happ: THandle; resnam : string;
                       left, top : integer ; fas : boolean) : THandle;
////////////////////////////////////////////////////////////////////////////
   function EIconCreate(hwnd, happ: THandle; resnam : string;
                    left, top : integer ; fas : boolean) : THandle;
////////////////////////////////////////////////////////////////////////////
type MyComboBox = object
protected
   function  GetText(hwnd : THandle) : string;
   procedure SetText(hwnd : THandle; Value : string);
   function  GetSelect(hwnd : THandle) : longint;
   procedure SetSelect(hwnd : THandle; Value : longint);
   procedure SetVisible(hwnd : THandle; Value : boolean);
   function  GetVisible(hwnd : THandle) : boolean;
   procedure SetEnable(hwnd : THandle; Value : boolean);
   function  GetEnable(hwnd : THandle) : boolean;
public
   function  Create(hwnd, happ: THandle; caption : string;
                   left, top, width, height: integer;
                   list, ronly, ucas, lcas, sort, usersize : boolean;
                   MaxLengthDef0 : dword) : THandle;

   procedure Add(hwnd : THandle; s : string);
   procedure Insert(hwnd : THandle; item : dword; s : string);
   procedure Clear(hwnd : THandle);

   function  GetItemText(hwnd : THandle; item : longint) : string;

   function  Count(hwnd : THandle) : longint;

   function  FileSave(hwnd : THandle; fn : string; overwrite, fix : boolean; LineCount : dword) : boolean;
   function  FileLoad(hwnd : THandle; fn : string; TrueForceFalseMaxCount : boolean; LineCount : dword) : boolean;
   property  Text[hwnd : THandle] : string read GetText write SetText;
   property  Select[hwnd : THandle] : longint read GetSelect write SetSelect;
   property  Visible[hwnd : THandle] : boolean read GetVisible write SetVisible;
   property  Enable[hwnd : THandle] : boolean read GetEnable write SetEnable;

end; var ComboBox : MyComboBox;
////////////////////////////////////////////////////////////////////////////
type MyListBox = object
protected
   function  GetSelect(hwnd : THandle) : longint;
   procedure SetSelect(hwnd : THandle; Value : longint);
   function  ItemGetSel(hwnd : THandle; i : longint) : boolean;
   procedure ItemSetSel(hwnd : THandle; i : longint; Value : boolean);
   procedure SetVisible(hwnd : THandle; Value : boolean);
   function  GetVisible(hwnd : THandle) : boolean;
   procedure SetEnable(hwnd : THandle; Value : boolean);
   function  GetEnable(hwnd : THandle) : boolean;
public
   function  Create(hwnd, happ: THandle; caption : string;
                   left, top, width, height: integer;
                   extsel, multic, multisel, usetab, sort, usersize, fas : boolean) : THandle;
   procedure Add(hwnd : THandle; s : string);
   property  Select[hwnd : THandle] : longint read GetSelect write SetSelect;
   property  ItemSelect[hwnd : THandle; i : longint] : boolean read ItemGetSel write ItemSetSel;
   procedure FileList(hwnd : THandle; a_ronly, a_archive, a_noattr, a_system, a_hidden, exlusive : boolean; s : string);
   procedure MyFileList(hwnd : THandle; path, mask : string);
   procedure MyFileListFullName(hwnd : THandle; path, mask : string);
   property  Visible[hwnd : THandle] : boolean read GetVisible write SetVisible;
   property  Enable[hwnd : THandle] : boolean read GetEnable write SetEnable;
   procedure Clear(hwnd : THandle);
   function  GetItemText(hwnd : THandle; i : longint) : string;
   function  Count(hwnd : THandle) : longint;   
end; var ListBox : MyListBox;
/////////////////////////////////////s///////////////////////////////////////
function EEditCreate(hwnd, happ: THandle; caption : string;
                     left, top, width, height : integer;
                     left0right1center2 : byte;
                     fas, multiline,
                     readonly : boolean;
                     MaxLengthDef0 : dword) : THandle;
////////////////////////////////////////////////////////////////////////////
{function ETxtCreate(hwnd, happ: THandle; caption : string;
                     left, top, width, height: integer;
                     fas : boolean) : THandle;}

type MyStaticText = object
protected
   procedure SetVisible(hwnd : THandle; Value : boolean);
   function  GetVisible(hwnd : THandle) : boolean;
private

public
   function          Create(hwnd, happ: THandle; caption : string;
                     left, top, width, height: integer;
                     fas : boolean) : THandle;
   property Visible[hwnd : THandle] : boolean read GetVisible write SetVisible;
end; var StaticText : MyStaticText;
////////////////////////////////////////////////////////////////////////////
type MyCheckButton = object

protected
   procedure SetChecked(hwnd : THandle; Value : boolean);
   function  GetChecked(hwnd : THandle) : boolean;
   procedure SetVisible(hwnd : THandle; Value : boolean);
   function  GetVisible(hwnd : THandle) : boolean;
   procedure SetEnable(hwnd : THandle; Value : boolean);
   function  GetEnable(hwnd : THandle) : boolean;
private

public
   function Create(hwnd, happ : THandle;
                  caption : string; left, top, width, height : integer;
                  fas, flat : boolean) : THandle;
   property Check[hwnd : THandle] : boolean read GetChecked write SetChecked;
   property Visible[hwnd : THandle] : boolean read GetVisible write SetVisible;
   property Enable[hwnd : THandle] : boolean read GetEnable write SetEnable;
end; var CheckButton : MyCheckButton;
////////////////////////////////////////////////////////////////////////////

implementation

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
function EBmpCreate(hwnd, happ: THandle; resnam : string;
                     left, top : integer ; fas : boolean) : THandle;
var
 tmpex : dword;
begin
 if fas then tmpex := WS_EX_OVERLAPPEDWINDOW else tmpex := 0;
 result :=  CreateWindowEx(tmpex , 'STATIC', PCHar(resnam), WS_CHILD {or WS_OVERLAPPED}
 or WS_VISIBLE or SS_BITMAP, left, top, 10,
 10, hwnd, 0, happ, nil);
end;
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
function EIconCreate(hwnd, happ: THandle; resnam : string;
                     left, top : integer ; fas : boolean) : THandle;
var
 tmpex : dword;
begin
 if fas then tmpex := WS_EX_OVERLAPPEDWINDOW else tmpex := 0;
 result :=  CreateWindowEx(tmpex , 'STATIC', PCHar(resnam), WS_CHILD {or WS_OVERLAPPED}
 or WS_VISIBLE or SS_ICON, left, top, 10,
 10, hwnd, 0, happ, nil);
end;
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
function EbutCreate(hwnd, happ: THandle; caption : string;
                     left, top, width, height: integer;
                     flat, fas : boolean) : THandle;
var
 tmp, tmpex : dword;
begin
 if flat then tmp := BS_FLAT else tmp := BS_PUSHBUTTON;
 if fas then tmpex := WS_EX_OVERLAPPEDWINDOW else tmpex := 0;
 result :=  CreateWindowEx(tmpex, 'BUTTON', PCHar(caption), WS_CHILD {or WS_OVERLAPPED}
 or WS_VISIBLE or tmp, left, top, width,
 height, hwnd, 0, happ, nil);
end;
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
function MyComboBox.Create(hwnd, happ: THandle; caption : string;
                       left, top, width, height: integer;
                       list, ronly, ucas, lcas, sort, usersize : boolean;
                       MaxLengthDef0 : dword) : THandle;
{const
 p : PCHar = ('O*KEY');}
var
 tmp, tmpex : dword;
{ pc         : PCHar;
 pr : prrr;}
begin
 tmpex := 0;
 tmp := CBS_AUTOHSCROLL;
 if list then tmp := tmp or CBS_SIMPLE else tmp := tmp or CBS_DROPDOWN;
 if ronly then tmp := tmp or CBS_DROPDOWNLIST;
 if sort  then tmp := tmp or CBS_SORT;
 if lcas and not(ucas) then tmp := tmp or CBS_LOWERCASE;
 if ucas and not(lcas) then tmp := tmp or CBS_UPPERCASE;
 if usersize then tmp := tmp or CBS_NOINTEGRALHEIGHT;

 tmp := tmp or WS_VSCROLL;

 result :=  CreateWindowEx(tmpex, 'COMBOBOX', PCHar(caption), WS_CHILD {or WS_OVERLAPPED}
 or WS_VISIBLE or tmp, left, top, width,
 height, hwnd, 0, happ, nil);
 SendMessage(result, CB_LIMITTEXT, MaxLengthDef0, 0);

{ SendMessage(result, CB_ADDSTRING, 0, integer(p));
 SendMessage(result, CB_ADDSTRING, 0, integer(p));
 SendMessage(result, CB_ADDSTRING, 0, integer(p));
 SendMessage(result, CB_SETCURSEL, 1, 0);
 SendMessage(result, CB_GETLBTEXT, 1, longint(pc));
 SendMessage(result, CB_ADDSTRING, 0, longint(pc));}

end;


procedure MyComboBox.Add(hwnd : THandle; s : string); begin   SendMessage(hwnd, CB_ADDSTRING, 0, Integer(PCHar(s))); end;
procedure MyComboBox.Insert; begin SendMessage(hwnd, CB_INSERTSTRING, item, Longint(PCHar(s))); end;
procedure MyComboBox.Clear(hwnd : THandle); begin SendMessage(hwnd, CB_RESETCONTENT, 0, 0); end;

function  MyComboBox.GetText(hwnd : THandle) : string;
  var     p : PCHar; l : longint;
begin l := GetWindowTextLength(hwnd) + 1;
result := '';
if l > 1 then begin
GetMem(p, l);
SendMessage(hwnd, WM_GETTEXT, l, Integer(p)); result := String(p);
FreeMem(p);
end; {end if}
end;

procedure MyComboBox.SetText(hwnd : THandle; Value : string);
begin SetWindowText(hwnd, PCHar(value)); end;


function  MyComboBox.GetSelect(hwnd : THandle) : longint;
begin  result := SendMessage(hwnd, CB_GETCURSEL, 0, 0); if result = CB_ERR then result := (-1);
end;
procedure MyComboBox.SetSelect(hwnd : THandle; Value : longint);
begin SendMessage(hwnd, CB_SETCURSEL, Value, 0); end;

procedure MyComboBox.SetVisible; begin if value then ShowWindow(hwnd, SW_SHOW) else ShowWindow(hwnd, SW_HIDE); end;
function  MyComboBox.GetVisible; begin result := isWindowVisible(hwnd); end;
procedure MyComboBox.SetEnable;  begin  EnableWindow(hwnd, value); end;
function  MyComboBox.GetEnable;  begin result := isWindowEnabled(hwnd); end;

function  MyComboBox.Count; begin result := SendMessage(hwnd, CB_GETCOUNT, 0, 0); if result = CB_ERR then result := 0; end;

function  MyComboBox.GetItemText;
 var      p : PCHar;
begin GetMem(p, SendMessage(hwnd, CB_GETLBTEXTLEN, item, 0) + 1);
SendMessage(hwnd, CB_GETLBTEXT, item, LongInt(p));
result := String(p); FreeMem(p);
end;

function  MyComboBox.FileSave;
 var
   f, cnt, l : longint;
   fp        : TextFile;
   s         : string;
begin
result := false; cnt := 0;
if (not overwrite) and FileExists(fn) then exit;

FileSetAttr(fn, FaArchive);

l := Count(hwnd);

if fix then cnt := LineCount else if LineCount = 0 then cnt := l else cnt := LineCount;
if cnt = 0 then exit;

assignfile(fp, fn);

{$I-}
rewrite(fp);
{$I+}  if IOResult <> 0 then begin result := true; exit; end;

for f := 0 to cnt - 1 do begin
 if f > (l - 1) then begin
  if fix then begin s := ''; end else begin break; end;
 end else begin
     s := GetItemText(hwnd, f); end; {end if}
{$I-}
  if f <> (cnt - 1) then writeln(fp, s) else write(fp, s);
{$I+} if IOResult <> 0 then begin result := true; break; end;
end; {nextt f}

{$I-}
closefile(fp);
{$I+} if IOResult <> 0 then result := true;
end;

function  MyComboBox.FileLoad(hwnd : THandle; fn : string; TrueForceFalseMaxCount : boolean; LineCount : dword) : boolean;
 var
   f, cnt : longint;
   fp     : TextFile;
   s      : string;
   er     : boolean;
begin
result := false; er := false; cnt := 0;
       ComboBox.Clear(hwnd);
assignfile(fp, fn);
{$I-}
 reset(fp);
{$I+} if IOResult <> 0 then begin result := true; exit; end;
if TrueForceFalseMaxCount then begin
 if LineCount > 0 then
  for f := 1 to LineCount do begin
  s := '';
  if not er then begin
  {$I-}
   readln(fp, s);
  {$I+} if IOResult <> 0 then begin result := true; er := true; end;
  end; {end if}
   ComboBox.Add(hwnd, s);
  end; {next f}
end else begin
  while not
  {$I-}
  EOF(fp)
   do begin
  {$I+} IOResult;
  {$I-}
   readln(fp, s);
  {$I+} if IOResult <> 0 then begin result := true; break; end;
  ComboBox.Add(hwnd, s);
  inc(cnt); if LineCount > 0 then if cnt = LineCount then break;
  end; {wend}
end; {end if}

{$I-}
closefile(fp);
{$I+} if IOResult <> 0 then result := true;
end;

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
function  MyListBox.Create(hwnd, happ: THandle; caption : string;
                   left, top, width, height: integer;
                   extsel, multic, multisel, usetab, sort, usersize, fas : boolean) : THandle;
 var
   tmp, tmpex : dword;
begin tmpex := 0; tmp := tmpex;

 if fas then tmpex := WS_EX_CLIENTEDGE;
 if extsel then tmp := LBS_EXTENDEDSEL;
 if multic then tmp := tmp or LBS_MULTICOLUMN;
 if multisel then tmp := tmp or LBS_MULTIPLESEL;
 if usetab then tmp := tmp or LBS_USETABSTOPS;
 if sort then tmp := tmp or LBS_SORT;
 if usersize then tmp := tmp or LBS_NOINTEGRALHEIGHT;

 tmp := tmp or WS_VSCROLL;

 result :=  CreateWindowEx(tmpex, 'LISTBOX', PCHar(caption), WS_CHILD {or WS_OVERLAPPED}
 or WS_VISIBLE or tmp or LBS_NOTIFY {or LBS_DISABLENOSCROLL} or WS_HSCROLL or WS_VSCROLL, left, top, width,
 height, hwnd, 0, happ, nil);

end;

procedure MyListBox.Add(hwnd : THandle; s : string); begin SendMessage(hwnd, LB_ADDSTRING, 0, Integer(PCHar(s))); end;
function  MyListBox.GetSelect(hwnd : THandle) : longint;
begin  result := SendMessage(hwnd, LB_GETCURSEL, 0, 0); if result = LB_ERR then result := (-1);
end;
procedure MyListBox.SetSelect(hwnd : THandle; Value : longint);
begin SendMessage(hwnd, LB_SETCURSEL, Value, 0); end;

procedure MyListBox.ItemSetSel(hwnd : THandle; i : longint; Value : boolean);
begin SendMessage(hwnd, LB_SETSEL, integer(Value), i); end;
function  MyListBox.ItemGetSel(hwnd : THandle; i : integer) : boolean;
begin  result := SendMessage(hwnd, LB_GETSEL, i, 0) > 0; end;

procedure MyListBox.FileList;
 var
   tmp : dword;
begin
tmp := 0;
if a_hidden   then tmp := DDL_HIDDEN;
if a_archive  then tmp := tmp or DDL_ARCHIVE;
if a_ronly    then tmp := tmp or DDL_READONLY;
if a_system   then tmp := tmp or DDL_SYSTEM;
if a_noattr   then tmp := tmp or DDL_READWRITE;
if exlusive   then tmp := tmp or DDL_EXCLUSIVE;
 SendMessage(hwnd, LB_DIR, tmp, Integer(PCHar(s)));
end;
procedure MyListBox.MyFileList;
  var
    r : TSearchRec;
    found, attr : Integer;
    l : Longint;
    s : string;
    p : Pointer;
begin
attr := faArchive;
clear(hwnd);
   found := FindFirst(path + mask, Attr, r);
   while found = 0 do begin
//...........................................

    s := path + r.FindData.cFileName;
//    MessageBox(0, PCHar(s), '', 0);
    l := Length(s);
  //  New(p);
    GetMem(p, 259);
    PCHar(p) := PCHar(s);
    GetShortPathName(p, p, l);
    Add(hwnd, AUpperCase(ExtractFileNameNoExt(String(PCHar(p)))));

//...........................................
   Found := FindNext(r);
   end; {wend}
   FindClose(r);
end;
procedure MyListBox.MyFileListFullName;
  var
    r : TSearchRec;
    found, attr : Integer;
    s : string;
begin
attr := faArchive;
clear(hwnd);
   found := FindFirst(path + mask, Attr, r);
   while found = 0 do begin
//...........................................
    s := path + r.FindData.cFileName;
    Add(hwnd, AUpperCase(ExtractFileNameNoExt(s)));
//...........................................
   Found := FindNext(r);
   end; {wend}
   FindClose(r);
end;

procedure MyListBox.SetVisible; begin if value then ShowWindow(hwnd, SW_SHOW) else ShowWindow(hwnd, SW_HIDE); end;
function  MyListBox.GetVisible; begin result := isWindowVisible(hwnd); end;
procedure MyListBox.SetEnable;  begin EnableWindow(hwnd, value); end;
function  MyListBox.GetEnable;  begin result := isWindowEnabled(hwnd); end;

procedure MyListBox.Clear; begin SendMessage(hwnd, LB_RESETCONTENT, 0, 0); end;

function  MyListBox.GetItemText(hwnd : THandle; i : longint) : string;
  var
    p : Pointer;
begin
  GetMem(p, SendMessage(hwnd, LB_GETTEXTLEN, i, 0) + 1);
  SendMessage(hwnd, LB_GETTEXT, i, Longint(p));
  result := String(PCHar(p));
  FreeMem(p);
end;

function  MyListBox.Count(hwnd : THandle) : longint;
begin
  result := SendMessage(hwnd, LB_GETCOUNT, 0, 0);
end;

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
function EEditCreate(hwnd, happ: THandle; caption : string;
                     left, top, width, height : integer;
                     left0right1center2 : byte;
                     fas, multiline,
                     readonly : boolean;
                     MaxLengthDef0 : dword) : THandle;
var
 tmp, tmpex : dword;
begin
 if fas then tmpex := WS_EX_OVERLAPPEDWINDOW else tmpex := 0;

 case left0right1center2 of
  0 : tmp := ES_LEFT;
  1 : tmp := ES_RIGHT;
  2 : tmp := ES_CENTER;
 end; {end select}

 tmp := tmp or ES_NOHIDESEL;
 tmp := tmp or ES_AUTOHSCROLL or ES_AUTOVSCROLL;
 tmp := tmp or {WS_HSCROLL or }WS_VSCROLL;
 if readonly then tmp := tmp or ES_READONLY;
 if multiline then tmp := tmp or ES_MULTILINE or ES_WANTRETURN;

{ tmp := tmp or}

 result :=  CreateWindowEx(tmpex , 'EDIT', PCHar(caption), WS_CHILD {or WS_OVERLAPPED}
 or WS_VISIBLE or tmp, left, top, width,
 height, hwnd, 0, happ, nil);

 SendMessage(result, EM_LIMITTEXT, MaxLengthDef0, 0);

end;
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
function MyStaticText.Create(hwnd, happ: THandle; caption : string;
                     left, top, width, height: integer;
                     fas : boolean) : THandle;
var
 tmp, tmpex : dword;
begin
 if fas then tmpex := WS_EX_OVERLAPPEDWINDOW else tmpex := 0;
 tmp := {SS_SIMPLE}SS_CENTER;
 result :=  CreateWindowEx(tmpex, 'STATIC', PCHar(caption), WS_CHILD {or WS_OVERLAPPED}
 or WS_VISIBLE or tmp, left, top, width,
 height, hwnd, 0, happ, nil);
end;

procedure MyStaticText.SetVisible; begin if value then ShowWindow(hwnd, SW_SHOW) else ShowWindow(hwnd, SW_HIDE); end;
function  MyStaticText.GetVisible; begin result := isWindowVisible(hwnd); end;
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
function MyCheckButton.Create(hwnd, happ : THandle;
                  caption : string; left, top, width, height : integer;
                  fas, flat : boolean) : THandle;
var
 tmp, tmpex : dword;
begin
 if fas then tmpex := WS_EX_OVERLAPPEDWINDOW else tmpex := 0;
  if flat then tmp := BS_FLAT else tmp := 0;
 result :=  CreateWindowEx(tmpex, 'BUTTON', PCHar(caption), WS_CHILD
 or BS_RADIOBUTTON or WS_VISIBLE or tmp, left, top, width,
 height, hwnd, 0, happ, nil);
end;
function MyCheckButton.GetChecked;
begin result := SendMessage(hwnd, BM_GETCHECK, 0, 0) <> 0; end;

procedure MyCheckButton.SetChecked;
var l : longint;
begin if Value then l := 2 else l := 0;
 SendMessage(hwnd, BM_SETCHECK, l, 0);
end;

procedure MyCheckButton.SetVisible; begin if value then ShowWindow(hwnd, SW_SHOW) else ShowWindow(hwnd, SW_HIDE); end;
function  MycheckButton.GetVisible; begin result := isWindowVisible(hwnd); end;
procedure MyCheckButton.SetEnable;  begin  EnableWindow(hwnd, value); end;
function  MyCheckButton.GetEnable;  begin result := isWindowEnabled(hwnd); end;

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

end.
