unit MyForms;

interface

uses Windows, Messages, MyUtils;

type
    TDecodeKey = record
    virt                : dword;     // Virtual key (VK_)
    usercount           : word;      // Count one moment press
    scancode            : byte;      // Scancode
    extended,downbefore : boolean;   // Extended key pressed, This key be pressed
    end;

    function DecodeKey(w, l : dword) : TDecodeKey; assembler;

////////////////////////////////////////////////////////////////////////////////
// TLiteFrame
// _____________________________________________________________________________
//     TLiteWindow, TLiteDialog, TLiteDialogBox
////////////////////////////////////////////////////////////////////////////////
type
  TLiteFrame = class(TObject)
    DC         : THandle;
  private
    FWndCallback: Pointer;
    FWndHandle  : THandle;
    FWndParent  : THandle;
    function    WindowCallback(hWnd: HWnd; Msg, WParam, LParam: Longint): Longint; stdcall;
  protected
    procedure   WindowProcedure(var Msg: TMessage); virtual;
  public
    property    Hwnd: THandle read FWndHandle;
    property    HwndParent : THandle read FWndParent;
    property    WndCallback: Pointer read FWndCallback;
  public
    constructor Create(AWndParent: THandle); virtual;
    destructor  Destroy; override;
  end;

////////////////////////////////////////////////////////////////////////////////
// TLiteWindow
// _____________________________________________________________________________
//  
////////////////////////////////////////////////////////////////////////////////
type
  TLiteWindow = class(TLiteFrame)
    Fleft        : Integer;
    Ftop         : Integer;
    FWidth       : Integer;
    FHeight      : Integer;
    FCWidth      : Integer;
    FCHeight     : Integer;
    FCaption     : PCHar;
    FStyle       : DWord;
    FExStyle     : DWord;
    FWndMenu     : THandle;
    FParam       : Pointer;
//    WindowClass  : TWndClass;
    WindowClassEx: TWndClassEx;
    FWndSubclass : Pointer;
    WndClassName : string;
  private
  protected
    procedure     SetCaption(Value : string);
    function      GetCaption : string;
  public
    procedure     Full; virtual;
    procedure     AfterCreate; virtual;
    procedure     DefaultHandler(var Msg); override;
    constructor   Create(AWndParent: THandle); override;
    constructor   CreateSubclassed(AWnd: THandle); virtual;
    destructor    Destroy; override;
    property      Caption: string read GetCaption write SetCaption;
    procedure     MemPosChange;
    procedure     ApplyPosChange;
  end;

implementation


////////////////////////////////////////////////////////////////////////////////
// TLiteFrame
// _____________________________________________________________________________
//  / 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
constructor TLiteFrame.Create(AWndParent: THandle);
begin
  inherited Create;
  //    
  FWndParent := AWndParent;
  //      
  FWndCallback := VirtualAlloc(nil, 12, MEM_RESERVE OR MEM_COMMIT, PAGE_EXECUTE_READWRITE);
  //    
  asm
    mov  EAX, Self
    mov  ECX, [EAX].TLiteFrame.FWndCallback
    mov  word  ptr [ECX+0], $6858               // pop  EAX
    mov  dword ptr [ECX+2], EAX                 // push _Self_
    mov  word  ptr [ECX+6], $E950               // push EAX
    mov  EAX, OFFSET(TLiteFrame.WindowCallback)
    sub  EAX, ECX
    sub  EAX, 12
    mov  dword ptr [ECX+8], EAX                 // jmp  TLiteFrame.WindowCallback
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
destructor TLiteFrame.Destroy;
begin
  //     
  VirtualFree(FWndCallback, 0, MEM_RELEASE);
  //   
  inherited;
end;

////////////////////////////////////////////////////////////////////////////////
// TLiteFrame
// _____________________________________________________________________________
//   
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//       
////////////////////////////////////////////////////////////////////////////////
function TLiteFrame.WindowCallback(hWnd: HWnd; Msg, WParam, LParam: Integer): Longint;
var
  WindowMsg : TMessage;
begin
  //   ,      
  if FWndHandle = 0 then FWndHandle := hWnd;
  //  
  WindowMsg.Msg    := Msg;
  WindowMsg.WParam := WParam;
  WindowMsg.LParam := LParam;
  //  
  WindowProcedure(WindowMsg);
  //    
  Result := WindowMsg.Result;
end;

////////////////////////////////////////////////////////////////////////////////
//      
////////////////////////////////////////////////////////////////////////////////
procedure TLiteFrame.WindowProcedure(var Msg: TMessage);
begin
  //    
  Dispatch(Msg);
end;

////////////////////////////////////////////////////////////////////////////////
// TLiteWindow
// _____________________________________________________________________________
//  / 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
constructor TLiteWindow.Create(AWndParent: THandle);
var
   f : dword;
begin
  inherited;
  //   
  full;
  //   
  for f := 0 to 1000 do begin
    if RegisterClassEx(WindowClassEx) <> 0 then break;
    if f > 998 then begin
    MessageBox(GetDesktopWindow, 'Microsoft Windows (c) Error','Not System Resources',16);
    halt;
    end; {end if}
  end; {next f}

      //  
  FWndHandle := CreateWindowEx(FExStyle, WindowClassEx.lpszClassName, FCaption,
      FStyle, Fleft, Ftop, FWidth, FHeight,
      FWndParent, FWndMenu, WindowClassEx.hInstance, FParam
    );

 aftercreate;
end;
procedure TLiteWindow.AfterCreate; begin end;
////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
constructor TLiteWindow.CreateSubclassed(AWnd: THandle);
begin
  inherited Create(GetParent(AWnd));
  //   
  FWndSubclass := Pointer(GetWindowLong(AWnd, GWL_WNDPROC));
  //   
  FWndHandle   := AWnd;
  //    
  SetWindowLong(FWndHandle, GWL_WNDPROC, DWord(WndCallback));
end;

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
destructor TLiteWindow.Destroy;
begin
  //   -   ?
  if FWndSubclass = nil then
  begin
    //  
    if IsWindow(FWndHandle) then DestroyWindow(FWndHandle);
    //   
    UnregisterClass(WindowClassEx.lpszClassName, hInstance);
  end
  else
    //    
    SetWindowLong(FWndHandle, GWL_WNDPROC, DWord(FWndSubclass));
  //   
  inherited;
end;

////////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////////
procedure TLiteWindow.Full;
begin
  //   
  Str(DWord(Self), WndClassName);
  WndClassName := ClassName+':'+WndClassName;
  //     
  with WindowClassEx do begin
  style           := CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS;
  lpfnWndProc     := WndCallback;
  cbClsExtra      := 0;
  cbWndExtra      := 0;
  hInstance       := 0;
  hIcon           := LoadIcon(0, IDI_APPLICATION);
  hCursor         := LoadCursor(0, IDC_ARROW);
  hbrBackground   := COLOR_BTNFACE + 1;
  lpszMenuName    := nil;
  lpszClassName   := PChar(WndClassName);
  hIconSm         := 0;
  cbSize          := sizeof(WindowClassEx);
  end;
  //    
    FCaption   := 'Source Window';
    FStyle     := WS_OVERLAPPEDWINDOW or WS_VISIBLE;
    FExStyle   := 0;
    Fleft      := Integer(CW_USEDEFAULT);
    Ftop       := Integer(CW_USEDEFAULT);
    FWidth     := Integer(CW_USEDEFAULT);
    FHeight    := Integer(CW_USEDEFAULT);
    FWndMenu   := 0;
    FParam     := nil;
end;
////////////////////////////////////////////////////////////////////////////////
//    CAPTION
//  ___________________
////////////////////////////////////////////////////////////////////////////////
function   TLiteWindow.GetCaption : string;
begin GetWindowText(hwnd, FCaption, GetWindowTextLength(hwnd) + 1);
 result := String(FCaption); end;
procedure  TLiteWindow.SetCaption;
begin  FCaption := PCHar(value); SetWindowText(hwnd, FCaption); end;
////////////////////////////////////////////////////////////////////////////////
//     
//  ____________________
////////////////////////////////////////////////////////////////////////////////
procedure TLiteWindow.MemPosChange;
var r : trect;
begin GetWindowRect(hwnd, r);
   FLeft     := r.Left;
   FTop      := r.Top;
   FWidth    := r.BottomRight.x - r.TopLeft.x;
   FHeight   := r.BottomRight.y - r.TopLeft.y;
      GetClientRect(hwnd, r);
   FCHeight  := r.BottomRight.y - r.TopLeft.y;
   FCWidth   := r.BottomRight.x - r.TopLeft.x;
end;
////////////////////////////////////////////////////////////////////////////////
//     
//  ____________________
////////////////////////////////////////////////////////////////////////////////
procedure TLiteWindow.ApplyPosChange;
begin     SetWindowPos(hwnd, hwnd, Fleft, Ftop,
                       Fleft + Fwidth, Ftop + Fheight,
                       SWP_NOACTIVATE or SWP_NOZORDER);
end;
////////////////////////////////////////////////////////////////////////////////
// TLiteWindow
// _____________________________________________________________________________
//   
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
procedure TLiteWindow.DefaultHandler(var Msg);
begin
  //   -   ?
  if FWndSubclass = nil then
    //     
    with TMessage(Msg) do Result := DefWindowProc(FWndHandle, Msg, WParam, LParam)
  else
    //      
    with TMessage(Msg) do Result := CallWindowProc(FWndSubclass, FWndHandle, Msg, WParam, LParam);
end;

function DecodeKey(w, l : dword) : TDecodeKey; assembler;
asm
     push eax;
     mov  eax, w;
     mov  result.virt, eax;
     mov  eax, l;
     mov  result.usercount, ax;
     shr  eax, 16;
     mov  result.scancode, al;
     mov  al, ah;
     and  al, 1;
     mov  result.extended, al;
     and  ah, 64;
     mov  result.downbefore, ah;
     pop  eax;
end;

end.
