unit UHelp;

interface
           uses windows, messages, myforms, myutils, dbg, application,
           myfbutt, myconst;

           const
                 w_w = 520; w_h = 400;

type
     MyHelpWindow = class(TLiteWindow)
     h_lb, h_edit, h_closbut, h_onlinehelp : THandle;
     vstr, file_name : string;
     protected
     procedure   OnCommand(Var Msg: TWMCommand); message WM_COMMAND;
     procedure   OnClose(Var Msg : TMessage); message    WM_CLOSE;
     procedure   OnEUREKA(Var Msg : TMessage); message   WM_EUREKA;
     procedure   WindowProcedure(var Msg : TMessage);    override;
     procedure   OnLstCol(var Msg:  TMessage); message   WM_CTLCOLORLISTBOX;
     procedure   OnStCol(var Msg:  TMessage); message    WM_CTLCOLORSTATIC;
     private

     public
     constructor Create;
     procedure   Full; override;
     procedure   Aftercreate; override;
     procedure   LoadHelp(a : byte; fn : string);
     procedure   Close;
     end;


     var
       HelpWindow : MyHelpWindow;

implementation

uses actions;

constructor MyHelpWindow.Create;
begin
   efHelp := true;
inherited Create(hDesktopWindow);
end;

procedure MyHelpWindow.full;
  var
    capsiz : integer;
begin inherited;
capsiz := GetSystemMetrics(SM_CYCAPTION);
self.FWidth  := w_w; self.FHeight := w_h + capsiz;
self.Ftop    := app.sc_h div 2 - self.FHeight div 2;
self.Fleft   := app.sc_w div 2 - self.FWidth  div 2;
{createwindow}  {createwindowex}
FStyle := WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX;
FExStyle := WS_EX_APPWINDOW;
WindowClassEx.hInstance := app.hinstance;
FCaption := PCHar(help_caption);
WindowClassEx.hIcon := app.hi_question;
// WindowClassEx.hbrBackground := CreateSolidBrush(colr_my);
end;

procedure MyHelpWindow.aftercreate;
begin
h_lb   := ListBox.Create(hwnd, app.hinstance, '', 0, 0, w_w - 4, 120, false, false, false, false, false, true, true);
          SendMessage(h_lb, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));
          SendMessage(h_lb, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
h_edit := EEditCreate(hwnd, app.hinstance, '', 0, 121, w_w - 4, 234, 0, true, true, true, 0);
          SendMessage(h_edit, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
h_closbut    := EButCreate(hwnd, app.hinstance, str_close, 350, 360, 160, 30, false, true);
          SendMessage(h_closbut, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
h_onlinehelp := EButCreate(hwnd, app.hinstance, help_butt_on_line, 4, 360, 160, 30, false, true);
          SendMessage(h_onlinehelp, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
end;

procedure MyHelpWindow.OnClose; begin close; end;
procedure MyHelpWindow.Close; begin efHelp := false; destroy; end;

procedure MyHelpWindow.OnCommand;
  var
    s      : string;
begin
if msg.Ctl = 0 then exit;

if msg.Ctl = h_closbut then close;
if msg.Ctl = h_onlinehelp then begin
    if Shell(PCHar(h_dir + 'index.htm'{'onlhelp.url'}), '', SW_SHOWMAXIMIZED) then
    app.JumpToHomePage;
end;

case msg.NotifyCode of
     CBN_SELCHANGE  : begin
     if msg.Ctl = h_lb then LoadHelp(1, file_name);
                      end;
     CBN_EDITCHANGE : begin

                      end;
     LBN_DBLCLK     : begin

                      end;
end; {end select}
end;

procedure   MyHelpWindow.OnEUREKA(Var Msg : TMessage);
const
   f_ext = '.txt';
begin
case msg.LParam of
0: file_name := 'w_setup'; // setup
1: file_name := 'w_dal'; // dal
2: file_name := 'w_eedit'; // ee
3: file_name := 'w_meswin'; // msw
4: file_name := 'w_noteb'; // notebook
5: file_name := 'w_pdlg'; // pdlg
6: file_name := 'w_odlg'; // odlg
7: file_name := 'w_flash'; // flash
else
     exit;
end; {end select}
file_name := h_dir + file_name + f_ext;
 LoadHelp(0, file_name);
 SetFocus(h_lb);
end;

procedure MyHelpWindow.LoadHelp(a : byte; fn : string);
  var
    fp  : textfile;
    tm  : string;
    fnd : boolean;
    l   : integer;
begin vstr := '';
fnd := false;
if not fileexists(fn) then exit;
 if a = 0 then ListBox.Clear(h_lb);
assignfile(fp, fn);
SetWindowText(h_edit, '');
{$I-}
reset(fp);
while not eof(fp) do begin
  readln(fp, tm);
l := length(tm);
if 1 > l then continue;
case a of
  0: if tm[1] = '=' then
     begin
      if l > 1 then tm := copy(tm,2,l);
      ListBox.Add(h_lb, tm);
     end;
  1: begin
if fnd and (tm[1] = '=') then fnd := false;
if fnd then vstr := vstr + tm + #13#10;
if '=' + ListBox.GetItemText(h_lb, ListBox.Select[h_lb]) = tm then fnd := true;
     end;
end; {end select}
end; {wend}
closefile(fp);
{$I+}
 if a = 1 then SetWindowText(h_edit, PCHar(vstr));
end;

procedure MyHelpWindow.WindowProcedure(var Msg : TMessage);
  var d : TDecodeKey; ctrl, shift : boolean;
begin
case msg.Msg of
     WM_KEYDOWN: begin
      d := DecodeKey(msg.WParam, msg.LParam);
       ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
       shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;
  //    msg.result := 1;
      case d.virt of
       VK_RETURN : msg.result := 1;
       VK_ESCAPE : begin close; msg.Result := 1; end;
       9         : msg.result := 1;
      else
          msg.result := 0;
      end; {end select}

     end;
     WM_KEYUP: begin
      d := DecodeKey(msg.WParam, msg.LParam);
       ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
       shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;
//      msg.Result := 1;
      case d.virt of
           9    : begin if GetFocus = h_lb then SetFocus(h_edit) else SetFocus(h_lb); msg.Result := 1; end;
           VK_RETURN : close;
      else
          msg.result := 0;
      end; {end select d.virt}
     end; {ku}
else
    Dispatch(msg);
end; {end select msg.msg}
end;

procedure MyHelpWindow.OnLstCol;
begin
msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
SetTextColor(msg.WParam, colr_rd);
// SetBkColor(msg.WParam, colr_lyl);
// msg.Result := hb_lyl;
end;

procedure MyHelpWindow.OnStCol;
begin
 SetBkColor(msg.WParam, colr_lyl);
 SetTextColor(msg.WParam, colr_bl);
 msg.Result := hb_lyl;
end;

end.
