unit USetup;

interface
          uses windows, messages, myforms, myutils, dbg, cdialogs,
               mycc, myconst, application, commctrl, actions,
               myfbutt, spkpl, mypan, mysetup;

           const set_w = 600; set_h = 335;
                 tab_count = 39;

type
     MySetupWindow = class(TLiteWindow)
     tab_number : integer;
     h_font : THandle;
     hlb : THandle;
     pans : array[0..setup_hd_max + 1] of MyPanel;
     h_close,
     h_help,
     h_www, h_mailto_autor, {h_register,}
     h_del_sfil,
     h_ar_on, h_ar_off, h_unin,
     h_un_del_pf, h_un_del_hf, h_un_del_sf, h_un_del_bf,
     h_un_del_mf, h_un_del_uf, h_un_del, h_un_del_znchf,
     h_lib_list, h_mel_list,
     h_mus_sync, h_snd_sync,
     h_mus_play, h_mus_stop, h_mus_plus_lib, h_mus_minus_lib, h_mus_ok,
     h_pwroff_forc, h_reb_forc, h_pwroff_poff,
     h_hotkey_lb, h_hotkey_key, h_hotkey_shift, h_hotkey_ctrl,
     h_hotkey_alt, h_hotkey_on, h_hotkey_appl,
     h_default_action, h_list_znch_lib, h_znch_sel,
     h_am_hour_fmt, h_am_calend_fmt,
     h_pan_fmt,
     h_pan_size_but_inc, h_pan_size_but_dec,
     h_pan_size
     : THandle;
     protected
     procedure  OnCommand(Var Msg: TWMCommand); message WM_COMMAND;
     procedure  OnClose(Var Msg : TMessage); message    WM_CLOSE;
     procedure  OnBtnCol(var Msg:  TMessage); message WM_CTLCOLORBTN;
     procedure  OnLstCol(var Msg:  TMessage); message   WM_CTLCOLORLISTBOX;
     procedure  WindowProcedure(var Msg : TMessage); override;
     private
     public
     constructor Create;
     procedure  Full; override;
     procedure  Aftercreate; override;
     procedure  SetForceReboot(b : boolean);
     procedure  SetForceOFF(b : boolean);
     procedure  SetPowerOFF(b : boolean);
     procedure  SetSyncSnd (b : boolean);
     procedure  SetSyncMus (b : boolean);
     procedure  SetViewPage(w : word);
     procedure  LdO;
     procedure  ListLib;
     procedure  ListLibZnch;
     procedure  ListMus;
     procedure  SetViewHotKey;
     procedure  MemHotKey;
     procedure  ApplHotKeys;
     function   Tab : boolean;
     procedure  PlusTab;
     procedure  MinusTab;
     procedure  Close;
     procedure  UUUUUninstall;
     procedure  DelSoundFiles;
     procedure  SetEngHourFmt(b : boolean);
     procedure  SetEngCalFmt(b : boolean);
     procedure  SetPanFmtStrButtonTxt;
     procedure  SetPanSize;
     end;

  var
    SetupWindow : MySetupWindow;

implementation

uses inbx, mymnwin;

  var
       fProcessCommand : boolean;

constructor MySetupWindow.Create;
begin
   efSetup := true;
inherited Create(hDesktopWindow);
end;

procedure MySetupWindow.full;
  var
    capsiz : integer;
begin inherited;
capsiz := GetSystemMetrics(SM_CYCAPTION);
self.FWidth  := set_w; self.FHeight := set_h + capsiz;
self.Ftop    := app.sc_h div 2 - self.FHeight div 2;
self.Fleft   := app.sc_w div 2 - self.FWidth  div 2;
{createwindow}  {createwindowex}
FStyle := WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX;
FExStyle := WS_EX_APPWINDOW;
WindowClassEx.hInstance := app.hinstance;
FCaption := PCHar(setup_capt);
// WindowClassEx.hbrBackground := CreateHatchBrush(HS_DIAGCROSS, GetSysColor(COLOR_3DFACE)); //CreateSolidBrush(colr_my);

// h_font := CreateFont(-10, 0, 0, 0, 400, Longint(false){it}, Longint(false){ul}, Longint(false), DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS or PROOF_QUALITY, DEFAULT_PITCH, FF_SWISS, 'MS Sans Serif');
h_font := CreateFont(-11, 0, 0, 0, 500, Longint(false){it}, Longint(false){ul}, Longint(false), DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_DEFAULT_PRECIS or PROOF_QUALITY, DEFAULT_PITCH, FF_SWISS, {''}'Arial');
// h_font := CreateFont(-12, 0, 0, 0, 800{800}, Integer(false), Integer(false), Integer(false), DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS{OUT_DEFAULT_PRECIS} , CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH or FF_MODERN, 'Courier New');
end;

procedure MySetupWindow.aftercreate;
  var
    f, ff  : longint;
begin // h_register := 0;

hlb := ListBox.Create(hwnd, app.hinstance, '', 4, 4, 210, 320, false, false, false, false, false, true, true);
SendMessage(hlb, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));
for f := 0 to setup_hd_max do begin
    pans[f] := MyPanel.Create(hwnd, app.hinstance, 218, 4, 370, 284, colr_my, false);
    ListBox.Add(hlb, setup_hd[f]);
    if f = 0 then pans[f].SetStaticColorAndFont(h_font, 0) else pans[f].SetStaticColorAndFont(hf_my, 0);
    case f of
     0:        begin  // About
               EBmpCreate(pans[f].hwnd, app.hinstance, 'LOGOTYPE', 60, 108, false);
               StaticText.Create(pans[f].hwnd, app.hinstance, app_ver_str + app_step_str + app_step + ' ' + app_assembled_str + app_assembled, 10, 10, 340, 30, false);
               h_www          := EButCreate(pans[f].hwnd, app.hinstance, setup_www_home, 10, 40, 350, 20, true, false);
               h_mailto_autor := EButCreate(pans[f].hwnd, app.hinstance, setup_mail_autor, 10, 220, 350, 20, true, false);
               StaticText.Create(pans[f].hwnd, app.hinstance, 'AGPLv3', 0, 254, 370{145}, 30, false);
     end;
     1:        begin  // setup
     h_ar_on        := EButCreate(pans[f].hwnd, app.hinstance, setup_ar_on, 10, 10, 170, 30, false, true);
     h_ar_off       := EButCreate(pans[f].hwnd, app.hinstance, setup_ar_off, 190, 10, 170, 30, false, true);
     h_unin         := EButCreate(pans[f].hwnd, app.hinstance, setup_unin, 10, 180, 350, 30, false, true);
     end;
     2:        begin  // music
     h_mus_sync     := CheckButton.Create(pans[f].hwnd, app.hinstance, setup_mus_sync, 10, 10, 350, 30, true, false);
     h_lib_list     := ListBox.Create(pans[f].hwnd, app.hinstance, '', 10, 40, 174, 200, false, false, false, false, false, true, true);
                    SendMessage(h_lib_list, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));
     h_mel_list     := ListBox.Create(pans[f].hwnd, app.hinstance, '', 185, 40, 174, 200, false, false, false, false, false, true, true);
                    SendMessage(h_mel_list, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));
     h_mus_play     := EButCreate(pans[f].hwnd, app.hinstance, '>', 320, 241, 40, 30, false, true);
     h_mus_stop     := EButCreate(pans[f].hwnd, app.hinstance, '#', 280, 241, 40, 30, false, true);
     h_mus_plus_lib := EButCreate(pans[f].hwnd, app.hinstance, '+', 10, 241, 40, 30, false, true);
     h_mus_minus_lib := EButCreate(pans[f].hwnd, app.hinstance, '-', 50, 241, 40, 30, false, true);
     h_mus_ok       := EButCreate(pans[f].hwnd, app.hinstance, setup_mus_sel_lib, 100, 241, 170, 30, false, true);
     end;
     3:        begin  // sound
     h_snd_sync     := CheckButton.Create(pans[f].hwnd, app.hinstance, setup_snd_sync, 10, 10, 346, 30, true, false);
     h_del_sfil     := EButCreate(pans[f].hwnd, app.hinstance, setup_del_nou_snd, 10, 50, 346, 30, false, true);
     end;
     4:        begin  // win offreb
     h_reb_forc     := CheckButton.Create(pans[f].hwnd, app.hinstance, setup_reb_forc, 10, 10, 350, 30, true, false);
     h_pwroff_forc  := CheckButton.Create(pans[f].hwnd, app.hinstance, setup_pwr_forc, 10, 200, 350, 30, true, false);
     h_pwroff_poff  := CheckButton.Create(pans[f].hwnd, app.hinstance, setup_pwr_pwroff, 10, 240, 350, 30, true, false);
     end;
     5:        begin  //  hot keys
     h_hotkey_shift  := CheckButton.Create(pans[f].hwnd, app.hinstance, 'Shift', 102, 210, 60, 24, true, false);
     h_hotkey_ctrl   := CheckButton.Create(pans[f].hwnd, app.hinstance, 'Ctrl', 163, 210, 53, 24, true, false);
     h_hotkey_alt    := CheckButton.Create(pans[f].hwnd, app.hinstance, 'Alt', 216, 210, 49, 24, true, false);
     h_hotkey_on     := CheckButton.Create(pans[f].hwnd, app.hinstance, setup_hk_on, 265, 210, 90, 24, true, false);
     h_hotkey_key    := ComboBox.Create(pans[f].hwnd, app.hinstance, '', 10, 210, 90, 200, false, true, false, false, false, true, 0);
     SendMessage(h_hotkey_key, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
     h_hotkey_lb     := ListBox.Create(pans[f].hwnd, app.hinstance, '', 10, 10, 345, 184, false, false, false, false, false, true, true);
                     SendMessage(h_hotkey_lb, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));
     h_hotkey_appl   := EButCreate(pans[f].hwnd, app.hinstance, setup_hk_appl, 10, 244, 345, 30, false, true);
                     for ff := 0 to max_hot_keys - 21 do ListBox.Add(h_hotkey_lb, hot_key_action_namws[ff]);
                     for ff := 0 to 255 do ComboBox.Add(h_hotkey_key, VkToStr(ff));
     EnableWindow(h_hotkey_shift, false);
     EnableWindow(h_hotkey_ctrl, false);
     EnableWindow(h_hotkey_alt, false);
     EnableWindow(h_hotkey_on, false);
     EnableWindow(h_hotkey_key, false);
     EnableWindow(h_hotkey_appl, false);
     end;
     6:        begin  // music
     h_list_znch_lib := ListBox.Create(pans[f].hwnd, app.hinstance, '', 10, 10, 345, 220, false, false, false, false, false, true, true);
                     SendMessage(h_list_znch_lib, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));
     h_znch_sel      := EButCreate(pans[f].hwnd, app.hinstance, setup_mus_sel_lib, 10, 241, 346, 30, false, true);
     end;
     7:        begin
     StaticText.Create(pans[f].hwnd, app.hinstance, setup_def_act, 10, 10, 350, 21, true);
     h_default_action := ComboBox.Create(pans[f].hwnd, app.hinstance, '', 10, 37, 350, 320, false, true, false, false, false, true, 0);
     for ff := 0 to 9 do ComboBox.Add(h_default_action, action_name1[ff]);
     for ff := 10 to action_max do ComboBox.Add(h_default_action, action_name[ff]);
     ComboBox.Select[h_default_action] := app.tun.al_dlg_mem_action;
     SendMessage(h_default_action, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));

     h_am_hour_fmt    := CheckButton.Create(pans[f].hwnd, app.hinstance, setup_am_h_f, 10, 70, 350, 30, true, false);
     h_am_calend_fmt  := CheckButton.Create(pans[f].hwnd, app.hinstance, setup_am_c_f, 10, 105, 350, 30, true, false);

     StaticText.Create(pans[f].hwnd, app.hinstance, setup_fmt_pan, 10, 215, 350, 21, true);
     h_pan_fmt        := EButCreate(pans[f].hwnd, app.hinstance, '', 10, 241, 350, 30, false, true);
     SetPanFmtStrButtonTxt;

     StaticText.Create(pans[f].hwnd, app.hinstance, setup_siz_pan, 10, 150, 350, 21, true);
     h_pan_size_but_inc := EButCreate(pans[f].hwnd, app.hinstance, '+', 290, 180, 70, 30, false, true);
     h_pan_size_but_dec := EButCreate(pans[f].hwnd, app.hinstance, '-', 10, 180, 70, 30, false, true);
     h_pan_size         := StaticText.Create(pans[f].hwnd, app.hinstance, '----', 80, 180, 209, 30, true);

     SetPanSize;

     end;
    end; {end select}
end; {next f}
  h_close := EButCreate(hwnd, app.hinstance, str_close, 450, 294, 140, 30, false, true);
  h_help := EButCreate(hwnd, app.hinstance, '?', 218, 294, 140, 30, false, true);

  pans[setup_hd_max + 1] := MyPanel.Create(hwnd, app.hinstance, 218, 4, 370, 284, colr_rd, false);

  h_un_del_pf := CheckButton.Create(pans[setup_hd_max + 1].hwnd, app.hinstance, setup_un_del_pf, 10, 10, 340, 21, true, false);
  h_un_del_hf := CheckButton.Create(pans[setup_hd_max + 1].hwnd, app.hinstance, setup_un_del_hf, 10, 35, 340, 21, true, false);
  h_un_del_sf := CheckButton.Create(pans[setup_hd_max + 1].hwnd, app.hinstance, setup_un_del_sf, 10, 60, 340, 21, true, false);
  h_un_del_bf := CheckButton.Create(pans[setup_hd_max + 1].hwnd, app.hinstance, setup_un_del_bf, 10, 85, 340, 21, true, false);
  h_un_del_mf := CheckButton.Create(pans[setup_hd_max + 1].hwnd, app.hinstance, setup_un_del_mf, 10, 110, 340, 21, true, false);
  h_un_del_uf := CheckButton.Create(pans[setup_hd_max + 1].hwnd, app.hinstance, setup_un_del_uf, 10, 135, 340, 21, true, false);
  h_un_del_znchf := CheckButton.Create(pans[setup_hd_max + 1].hwnd, app.hinstance, setup_un_del_znchf, 10, 160, 340, 21, true, false);
  h_un_del    := EButCreate(pans[setup_hd_max + 1].hwnd, app.hinstance, setup_un_del, 108, 210, 140, 30, false, true);

  SendMessage(h_un_del_pf, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
  SendMessage(h_un_del_hf, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
  SendMessage(h_un_del_sf, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
  SendMessage(h_un_del_bf, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
  SendMessage(h_un_del_mf, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
  SendMessage(h_un_del_uf, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
  SendMessage(h_un_del_znchf, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
  SendMessage(h_un_del, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));

  ListBox.Select[hlb] := 0; SetViewPage(0);
LdO;
ListLib;
ListLibZnch;
tab_number := 36;
PlusTab;
end;

procedure MySetupWindow.OnCommand;
label eexit;
  var
    s      : string;
    fdlg   : MyFileDlg;
begin if fProcessCommand then exit;
fProcessCommand := true;

if msg.Ctl = 0 then goto eexit;

if msg.Ctl = h_close then close;
if msg.Ctl = h_del_sfil then DelSoundFiles;

if
(msg.Ctl = h_un_del_pf) or
(msg.Ctl = h_un_del_hf) or
(msg.Ctl = h_un_del_sf) or
(msg.Ctl = h_un_del_bf) or
(msg.Ctl = h_un_del_mf) or
(msg.Ctl = h_un_del_uf) or
(msg.Ctl = h_un_del_znchf)
then CheckButton.Check[msg.Ctl] := not CheckButton.Check[msg.Ctl];
     
if msg.Ctl = h_ar_on       then Autorun(true);
if msg.Ctl = h_ar_off      then Autorun(false);
if msg.Ctl = h_pwroff_forc then SetForceOFF(not app.stun.f_force_off);
if msg.Ctl = h_reb_forc    then SetForceReboot(not app.stun.f_force_reboot);
if msg.Ctl = h_pwroff_poff then SetPowerOFF(not app.stun.f_pwr_off);
if msg.Ctl = h_mus_sync    then SetSyncMus(not app.tun.sync_mus);
if msg.Ctl = h_snd_sync    then SetSyncSnd(not app.tun.sync_snd);
if msg.Ctl = h_am_hour_fmt then SetEngHourFmt(not app.tun.engtrue_hour_fmt);
if msg.Ctl = h_am_calend_fmt then SetEngCalFmt(not app.tun.engtrue_calend_fmt);


if msg.Ctl = h_mus_minus_lib then begin
 if ListBox.Select[h_lib_list] < 0 then goto eexit;
 s := m_dir + ListBox.GetItemText(h_lib_list, ListBox.Select[h_lib_list]) + '.mus';
 if MessageBox(hwnd, PCHar(conf_del_fil + s), conf_capt_del_fil, bit5 or bit6 or bit3) = idYes then begin
 Windows.DeleteFile(PCHar(s));
 ListLib;
 end; {end if}
exit;
end; {end if}
if msg.Ctl = h_mus_plus_lib then begin
          fdlg := MyFileDlg.Create;
  if fdlg.GetFileName(hwnd, app.hinstance, 'Speaker Music Library'#0'*.mus'#0, 0, 'MUS', 'c:\', false, '')
                             then begin
     s := ExtractFileName(fdlg.FileName);
      if FileExists(m_dir + s) then begin
        if MessageBox(hwnd, PCHar(conf_ovw_fil), conf_capt_ovw_fil, bit5 or bit6 or bit3) = idYes then
           windows.CopyFile(PCHar(fdlg.FileName), PCHar(m_dir + s), false)
      end else windows.CopyFile(PCHar(fdlg.FileName), PCHar(m_dir + s), true); {end if}
                             end; {end if}
          fdlg.Free;
      ListLib;
goto eexit;
end; {end if}
if msg.Ctl = h_mus_play then begin
 s := m_dir + ListBox.GetItemText(h_lib_list, ListBox.Select[h_lib_list]) + '.mus';
 if ListBox.Select[h_mel_list] < 0 then goto eexit;
 PlayMusic(s, ListBox.Select[h_mel_list], false, app.nt);
goto eexit;
end; {end if}
if msg.Ctl = h_mus_stop then begin
     StopSnd;
goto eexit;
end; {end if}
if msg.Ctl = h_mus_ok then begin
 if ListBox.Select[h_lib_list] < 0 then goto eexit;
if not windows.CopyFile(PCHar(m_dir + ListBox.GetItemText(h_lib_list, ListBox.Select[h_lib_list]) + '.mus'), PCHar(app.path + 'music.dll'), false) then MessageBox(hwnd, setup_nocopylib, PCHar(app_name), bit5)
else app.GetMusicLibNames;
goto eexit;
end; {end if}

if msg.Ctl = h_znch_sel then begin
 if ListBox.Select[h_list_znch_lib] < 0 then goto eexit;
if not windows.CopyFile(PCHar(z_dir + ListBox.GetItemText(h_list_znch_lib, ListBox.Select[h_list_znch_lib]) + '.dll'), PCHar(icn_fn), false) then MessageBox(hwnd, setup_nocopylib, PCHar(app_name), bit5);
goto eexit;
end; {end if}

if (msg.Ctl = h_mailto_autor) then app.MailToAutor;
if (msg.Ctl = h_www) then app.JumpToHomePage;
//if (msg.Ctl = h_register) then begin
//s := '';
//if GetUserStrExecute(hwnd, app_name, setup_reg_capt, str_oc[true], str_oc[false], 255, 1, s)
//   then begin app.tun.reg_str := s; PostMessage(hwnd, WM_CLOSE, 0, 0); end; {end if}
//end; {end if}

if (msg.Ctl = h_un_del) then uuuuuninstall;

if (msg.Ctl = h_hotkey_key) or (msg.Ctl = h_hotkey_shift) or
(msg.Ctl = h_hotkey_ctrl) or (msg.Ctl = h_hotkey_alt) or
(msg.Ctl = h_hotkey_on) then begin
if msg.Ctl <> h_hotkey_key then CheckButton.Check[msg.Ctl] := not CheckButton.Check[msg.Ctl];
MemHotKey;
goto eexit;
end; {end if}
if msg.Ctl = h_hotkey_appl then begin
ApplHotKeys;
goto eexit;
end;

if msg.Ctl = h_unin then if MessageBox(hwnd, setup_conf_un, PCHar(app_name), bit3 or bit5 or bit6) = ID_YES then begin SetViewPage(setup_hd_max + 1); end;
if msg.Ctl = h_help then begin app.ShowHelp(0); end;

if msg.Ctl = h_pan_fmt then begin
if GetUserStrExecute(hwnd, app_name, '', str_oc[true], str_oc[false], 255, 0, app.fmt_clock)
   then begin
       SetPanFmtStrButtonTxt;
       mymnwin.SaveFmtStr(app.fmt_clock);
   end; {end if}
end; {end if}

if msg.Ctl = h_pan_size_but_inc then begin
 if app.stun.siz_clock < (app.sc_w - 10)
    then app.stun.siz_clock := app.stun.siz_clock + 10 else app.stun.siz_clock := app.sc_w;
SetPanSize;
end; {end if}
if msg.Ctl = h_pan_size_but_dec then begin
 if app.stun.siz_clock > 20
    then app.stun.siz_clock := app.stun.siz_clock - 10 else app.stun.siz_clock := 20;
SetPanSize;
end; {end if}

case msg.NotifyCode of
     CBN_SELCHANGE  : begin
     if msg.Ctl = hlb then SetViewPage(ListBox.Select[hlb]);
     if msg.Ctl = h_lib_list then ListMus;
     if msg.Ctl = h_hotkey_lb then begin
      SetViewHotKey;
        if not isWindowEnabled(h_hotkey_key) then begin
        EnableWindow(h_hotkey_shift, true);
        EnableWindow(h_hotkey_ctrl, true);
        EnableWindow(h_hotkey_alt, true);
        EnableWindow(h_hotkey_on, true);
        EnableWindow(h_hotkey_key, true);
        EnableWindow(h_hotkey_appl, true);
        end; {end if}
     end; {end if}
     if msg.Ctl = h_default_action then  app.tun.al_dlg_mem_action := ComboBox.Select[h_default_action];
                      end;
{     CBN_EDITCHANGE : begin

                      end; }
{     LBN_DBLCLK     : begin

                      end; }
end; {end select}

eexit:
fProcessCommand := false;
end;

procedure MySetupWindow.SetViewPage;
  var
    f : longint;
begin
for f := 0 to setup_hd_max + 1 do
if w = f then begin
  if not isWindowVisible(pans[f].hwnd) then ShowWindow(pans[f].hwnd, SW_SHOW)
 end else begin
  if isWindowVisible(pans[f].hwnd) then ShowWindow(pans[f].hwnd, SW_HIDE);
 end; {end if}
end;

procedure MySetupWindow.OnClose; begin close; end;
procedure MySetupWindow.Close; begin DeleteObject(h_font); efSetup := false; destroy; end;

procedure MySetupWindow.OnLstCol;
{WM_CTLCOLORLISTBOX}
begin
{-!-}  SelectObject(msg.WParam, hf_my);
msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
if (msg.LParam = hlb) then begin
//  SetTextColor(msg.WParam, colr_bl);
  SetBkColor(msg.WParam, colr_my);
  msg.Result := app.hb_my;
  exit;
end else begin {end if hlb}
//  SetBkColor(msg.WParam, colr_my);
//  msg.Result := app.hb_my;
//  exit;
end; {end if not hlb}

{else}
//msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
end;

procedure  MySetupWindow.SetForceReboot(b : boolean);
begin
   CheckButton.Check[h_reb_forc] := b;
   app.stun.f_force_reboot := b;
end;
procedure  MySetupWindow.SetForceOFF(b : boolean);
begin
   CheckButton.Check[h_pwroff_forc] := b;
   app.stun.f_force_off := b;
end;
procedure  MySetupWindow.SetPowerOFF(b : boolean);
begin
   CheckButton.Check[h_pwroff_poff] := b;
   app.stun.f_pwr_off := b;
end;
procedure  MySetupWindow.SetSyncSnd;
begin
   CheckButton.Check[h_snd_sync] := b;
   app.tun.sync_snd := b;
end;
procedure  MySetupWindow.SetSyncMus;
begin
   CheckButton.Check[h_mus_sync] := b;
   app.tun.sync_mus := b;
end;
procedure  MySetupWindow.SetEngHourFmt(b : boolean);
begin
   CheckButton.Check[h_am_hour_fmt] := b;
   app.tun.engtrue_hour_fmt := b;
end;
procedure  MySetupWindow.SetEngCalFmt(b : boolean);
begin
   CheckButton.Check[h_am_calend_fmt] := b;
   app.tun.engtrue_calend_fmt := b;
end;
procedure  MySetupWindow.LdO;
begin
CheckButton.Check[h_pwroff_poff] := app.stun.f_pwr_off;
CheckButton.Check[h_reb_forc]    := app.stun.f_force_reboot;
CheckButton.Check[h_pwroff_forc] := app.stun.f_force_off;
CheckButton.Check[h_mus_sync]    := app.tun.sync_mus;
CheckButton.Check[h_snd_sync]    := app.tun.sync_snd;
CheckButton.Check[h_am_hour_fmt]    := app.tun.engtrue_hour_fmt;
CheckButton.Check[h_am_calend_fmt]  := app.tun.engtrue_calend_fmt;
end;

procedure MySetupWindow.ListMus;
  var
    f : word;
    GetMusicName : TGetMusicName;
    h : THandle;
begin
ListBox.Clear(h_mel_list);
h := LoadLibrary(PCHar(m_dir +  ListBox.GetItemText(h_lib_list, ListBox.Select[h_lib_list]) + '.mus'));
 @GetMusicName := GetProcAddress(h, 'GetMusicName');
 if @GetMusicName = nil then exit;
    for f := 0 to 9 do begin
     ListBox.Add(h_mel_list, String(GetMusicName(f)));
    end; {next f}
FreeLibrary(h);
end;
procedure MySetupWindow.ListLib;
begin
ListBox.Clear(h_mel_list);
ListBox.MyFileListFullName(h_lib_list, m_dir, '*.mus');
end;

procedure MySetupWindow.ListLibZnch;
begin
ListBox.Clear(h_list_znch_lib);
ListBox.MyFileListFullName(h_list_znch_lib, z_dir, '*.dll');
end;

procedure MySetupWindow.SetViewHotKey;
  var
    tmp : longint;
begin
     tmp := ListBox.Select[h_hotkey_lb];
     if tmp < 0 then exit;
     CheckButton.Check[h_hotkey_shift] := app.tun.HotKeys[tmp].shift;
     CheckButton.Check[h_hotkey_ctrl] := app.tun.HotKeys[tmp].ctrl;
     CheckButton.Check[h_hotkey_alt] := app.tun.HotKeys[tmp].alt;
     CheckButton.Check[h_hotkey_on] := app.tun.HotKeys[tmp].active;
     ComboBox.Select[h_hotkey_key] := app.tun.HotKeys[tmp].key;
end;

procedure MySetupWindow.MemHotKey;
  var
    tmp : longint;
begin
    tmp := ListBox.Select[h_hotkey_lb];
    if tmp < 0 then exit;
app.tun.HotKeys[tmp].shift  := CheckButton.Check[h_hotkey_shift];
app.tun.HotKeys[tmp].ctrl   := CheckButton.Check[h_hotkey_ctrl];
app.tun.HotKeys[tmp].alt    := CheckButton.Check[h_hotkey_alt];
app.tun.HotKeys[tmp].active := CheckButton.Check[h_hotkey_on];
app.tun.HotKeys[tmp].key    := ComboBox.Select[h_hotkey_key];
end;

procedure MySetupWindow.ApplHotKeys;
begin
app.UnRegisterHotKeys;
app.RegisterHotKeys;
SetViewHotKey;
end;

function  MySetupWindow.Tab;
  var
    tmp : THandle;
begin
result := false;
case tab_number of
0:   tmp := h_default_action;
1:   tmp := h_www;
2:   tmp := h_mailto_autor;
//3:   tmp := h_register;
4:   tmp := h_del_sfil;
5:   tmp := h_ar_on;
6:   tmp := h_ar_off;
7:   tmp := h_unin;
8:   tmp := h_un_del_pf;
9:   tmp := h_un_del_hf;
10:  tmp := h_un_del_sf;
11:  tmp := h_un_del_bf;
12:  tmp := h_un_del_mf;
13:  tmp := h_un_del_uf;
14:  tmp := h_un_del_znchf;
15:  tmp := h_un_del;
16:  tmp := h_lib_list;
17:  tmp := h_mel_list;
18:  tmp := h_mus_sync;
19:  tmp := h_mus_play;
20:  tmp := h_mus_stop;
21:  tmp := h_mus_plus_lib;
22:  tmp := h_mus_minus_lib;
23:  tmp := h_mus_ok;
24:  tmp := h_snd_sync;
25:  tmp := h_pwroff_forc;
26:  tmp := h_reb_forc;
27:  tmp := h_pwroff_poff;
28:  tmp := h_hotkey_lb;
29:  tmp := h_hotkey_key;
30:  tmp := h_hotkey_shift;
31:  tmp := h_hotkey_ctrl;
32:  tmp := h_hotkey_alt;
33:  tmp := h_hotkey_on;
34:  tmp := h_hotkey_appl;
35:  tmp := h_list_znch_lib;
36:  tmp := h_znch_sel;
37:  tmp := hlb;
38:  tmp := h_am_hour_fmt;
39:  tmp := h_am_calend_fmt;
else
 tab_number := 0;
 tab;
end; {end select}

if (tmp = 0) or (not isWindowVisible(tmp)) or (not isWindowEnabled(tmp)) then begin result := true; exit; end;

fProcessCommand := true;
 SetFocus(tmp);
fProcessCommand := false;
end;

procedure MySetupWindow.PlusTab;
begin
  inc(tab_number);
  if tab_number > tab_count then tab_number := 0;
  while tab do inc(tab_number);
end;
procedure MySetupWindow.MinusTab;
begin
  dec(tab_number);
  if tab_number < 0 then tab_number := tab_count;
  while tab do dec(tab_number);
end;

procedure MySetupWindow.WindowProcedure(var Msg : TMessage);
  var d : TDecodeKey; begin
case msg.Msg of
     WM_KEYDOWN: begin
      d := DecodeKey(msg.WParam, msg.LParam);
      case d.virt of
       9         : msg.result := 1;
       VK_ESCAPE : begin close; msg.Result := 1; end;
      else
          msg.result := 0;
      end; {end select}
     end;
     WM_KEYUP: begin
      d := DecodeKey(msg.WParam, msg.LParam);
      case d.virt of
           9    : begin Plustab; msg.Result := 1; end;
      VK_ESCAPE : begin msg.Result := 1; end;
      VK_F1     : begin app.ShowHelp(0); end;
      else
          msg.result := 0;
      end; {end select d.virt}
     end;
else
    Dispatch(msg);
end; {end select msg.msg}
end;

procedure  MySetupWindow.UUUUUninstall;
const
 del_tree = 'deltree /y "';
  var
    bh, bu, bs, bm, bi, bp, bb, ball, bnone : boolean;
    s : string;
    tmp : array[0..MAX_PATH] of char;
begin s := '';
bh := CheckButton.Check[h_un_del_hf];
bu := CheckButton.Check[h_un_del_uf];
bs := CheckButton.Check[h_un_del_sf];
bm := CheckButton.Check[h_un_del_mf];
bi := CheckButton.Check[h_un_del_znchf];
bp := CheckButton.Check[h_un_del_pf];
bb := CheckButton.Check[h_un_del_bf];

bnone := (not bh) and (not bu) and (not bs) and (not bm) and (not bi) and (not bp) and (not bb);
if bnone then exit;

if bp then begin
 CharToOEM(PCHar(app.path), @tmp);
 s := s + 'del "' + tmp + '*.tun' + '"'#13#10;
 CharToOEM(PCHar(stfn), @tmp);
 s := s + 'del "' + tmp + '"'#13#10;
// MessageBox(hwnd, PCHar(s), 'c', 0);
end; {end if}

ball  := bh and bu and bs and bm and bi and bp and bb;
if ball then begin Uninstall(s, true, true); exit; end;

if bp and (not bu) then app.org.WorkGorgFile(true);

if bh then begin
 CharToOEM(PCHar(h_dir), @tmp);
 s := del_tree + tmp + '"'#13#10;
end; {end if}
if bu then begin
 CharToOEM(PCHar(u_dir), @tmp);
 s := s + del_tree + tmp + '"'#13#10;
end; {end if}
if bs then begin
 CharToOEM(PCHar(s_dir), @tmp);
 s := s + del_tree + tmp + '"'#13#10;
end; {end if}
if bm then begin
 CharToOEM(PCHar(m_dir), @tmp);
 s := s + del_tree + tmp + '"'#13#10;
end; {end if}
if bi then begin
 CharToOEM(PCHar(z_dir), @tmp);
 s := s + del_tree + tmp + '"'#13#10;
end; {end if}
if bb then begin
 CharToOEM(PCHar(b_dir), @tmp);
 s := s + del_tree + tmp + '"'#13#10;
end; {end if}
if bp then begin
 CharToOEM(PCHar(app.path), @tmp);
 s := s + 'del "' + tmp + '*.dll' + '"'#13#10;
 s := s + 'del "' + tmp + '*.bat' + '"'#13#10;
 s := s + 'del "' + tmp + 'deltree.exe' + '"'#13#10;
end; {end if}
//  MessageBox(hwnd, PCHar(s), '', 0);
 Uninstall(s, bp, false);
 PostMessage(hwnd, WM_CLOSE, 0, 0);
end;

procedure  MySetupWindow.DelSoundFiles;
begin
 if MessageBox(hwnd, setup_del_snd, PCHar(app_name), bit6 or bit3) <> ID_YES then exit;
 app.fNeedDelSndFil := true;
end;

procedure  MySetupWindow.SetPanFmtStrButtonTxt;
begin
SendMessage(h_pan_fmt, WM_SETTEXT, 0, Longint(PCHar(app.fmt_clock)));
end;

procedure  MySetupWindow.SetPanSize;
begin
SendMessage(h_pan_size, WM_SETTEXT, 0, Longint(PCHar(String(IntToStr(app.stun.siz_clock)))));
main.SetRegion;
end;

procedure  MySetupWindow.OnBtnCol(var Msg:  TMessage);
begin
 SelectObject(msg.WParam, hf_my);
 msg.Result := WindowClassEx.hbrBackground;
end;

initialization

fProcessCommand := false;

finalization

end.
