unit actions;

interface

   uses windows, messages, algor, myconst, myforms, myutils, myfbutt, spkpl, application;

type
     MyEndWin = class(TLiteWindow)

     ht, hbct, hbut, hfnt1, hfnt2 : THandle;
     fcoff                        : boolean;
     counter                      : longint;

     protected
     procedure   OnStCol(var Msg:  TMessage); message       WM_CTLCOLORSTATIC;
     procedure   OnClose(Var Msg : TMessage); message       WM_CLOSE;
     procedure   OnEUREKA(Var Msg : TMessage); message      WM_EUREKA;
     procedure   OnCommand(Var Msg: TWMCommand); message    WM_COMMAND;
     private

     public
     constructor Create(hwnd : THandle; cofftrue : boolean);
     procedure   Full; override;
     procedure   Aftercreate; override;
     procedure   Close;
     end;

 Function ShellExecute (hwnd : Longint; lpOperation : String;
 lpFile : String; lpParameters : String;
 lpDirectory : String; nShowCmd : Longint) : integer; stdcall; external 'shell32.dll' name 'ShellExecuteA';
function shell(runline : PCHar; comline : PCHar; wstat:longint): boolean;
function PlaySound(pszSound: PChar; hmod: THandle; fdwSound: dword) : Longint; stdcall; external 'winmm.dll' name 'PlaySoundA';
procedure PlayWaveFile(FileName : string; SynchTrue : boolean);
{ flag values for wFlags parameter }
const
  SND_SYNC            = $0000;  { play synchronously (default) }
  SND_ASYNC           = $0001;  { play asynchronously }
  SND_NODEFAULT       = $0002;  { don't use default sound }
  SND_MEMORY          = $0004;  { lpszSoundName points to a memory file }
  SND_LOOP            = $0008;  { loop the sound until next sndPlaySound }
  SND_NOSTOP          = $0010;  { don't stop any currently playing sound }

  SND_NOWAIT          = $00002000;  { don't wait if the driver is busy }
  SND_ALIAS           = $00010000;  { name is a registry alias }
  SND_ALIAS_ID        = $00110000;  { alias is a predefined ID }
  SND_FILENAME        = $00020000;  { name is file name }
  SND_RESOURCE        = $00040004;  { name is resource name or atom }
  SND_PURGE           = $0040;      { purge non-static events for task }
  SND_APPLICATION     = $0080;      { look for application specific association }

procedure Run(m : myevent; test : boolean);
procedure StopSnd;
procedure PlaySpk(b : byte; sync : boolean);
procedure StopSpk;

  var
    EndWindows : MyEndWin;

implementation

function shell(runline : PCHar; comline : PCHar; wstat : longint) : boolean; begin result := shellexecute(app.hwnd,'',runline, comline,'',wstat) < 32; end;{end shell}

{    (' ', ' ',
    ' Audio-CD','',
    ' *.BAT ','. ',
    '. ');}
procedure Run(m : myevent; test : boolean);
begin
  if app.tun.NoAct then exit;
   case m.action of
   0..9 : if not app.tun.Mute then if test then PlaySpk(m.action, false) else PlaySpk(m.action, app.tun.sync_mus);
   10   : if not app.tun.Mute then beep;
   12   : if not app.tun.Mute then if shell('cdplayer.exe','-play',2) then MessageBox(app.hwnd, PCHar(app_msg_errcd), PCHar(app_name), 16);
   13   : if not app.tun.Mute then if test then PlayWaveFile(s_dir + m.filn + '.wav', false) else PlayWaveFile(s_dir + m.filn + '.wav', app.tun.sync_snd);
   14   : shell(PCHar(b_dir + m.filn + '.bat'), '', SW_MINIMIZE);
   15   : PostMessage(app.hwnd, WM_INITEXITWINDOWS, 0, 0);
   16   : PostMessage(app.hwnd, WM_INITEXITWINDOWS, 1, 0);
   end; {end select}
end;

procedure PlayWaveFile(FileName : string; SynchTrue : boolean);
  var     w  : dword;
begin
 // if processmusic then exit;
  if SynchTrue then w := SND_SYNC else w := SND_ASYNC;
  w := w or SND_NODEFAULT or SND_NOWAIT or SND_FILENAME;
  SendMessage(app.hwnd, WM_PLAYWAVE, w, Longint(PCHar(FileName)));
end;
procedure StopSnd; begin PlaySound(nil, 0,  SND_PURGE); StopSpk; end;

constructor MyEndWin.Create;
begin fcoff := cofftrue; counter := 9;
inherited Create(hwnd);
efExit := true;
end;
procedure MyEndWin.Full;
begin  inherited;
self.FLeft := 0; self.FTop  := 0; self.FWidth := 100; self.FHeight := 100;
self.Caption := ''; self.FStyle   := 0; self.FExStyle := 0;
self.WindowClassEx.hInstance := app.hinstance;
WindowClassEx.hbrBackground := CreateSolidBrush(colr_rd);
hfnt1 := CreateFont(-20, 0, 0, 0, 800, Integer(false), Integer(false), Integer(false), DEFAULT_CHARSET, OUT_DEFAULT_PRECIS , CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH or FF_SWISS, '');
hfnt2 := CreateFont(-30, 0, 0, 0, 800, Integer(false), Integer(false), Integer(false), DEFAULT_CHARSET, OUT_DEFAULT_PRECIS , CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH or FF_SWISS, '');
end;
procedure MyEndWin.Aftercreate;
  var     s : string;
begin s := '';
   SetWindowLong(hwnd, GWL_STYLE, GetWindowLong(hwnd, GWL_STYLE) and (not WS_CAPTION));
   ShowWindow(hwnd, SW_MAXIMIZE);

 if fcoff then s := pwr_disp_off else s := pwr_disp_reb;
 ht   := StaticText.Create(hwnd, app.hinstance, s, 0, app.sc_h div 4, app.sc_w, 25, false);
 hbct := StaticText.Create(hwnd, app.hinstance, '9', app.sc_w div 2 - 17, app.sc_h div 2, 34, 34, false);
 hbut := EButCreate(hwnd, app.hinstance, AUpperCase(str_oc[false]), app.sc_w div 2 - 50, app.sc_h div 2 + app.sc_h div 4, 100, 40, false, false);
 SetFocus(hbut);
end;
procedure MyEndWin.OnClose; begin close; end;
procedure MyEndWin.Close; begin DeleteObject(hfnt1); DeleteObject(hfnt2); efExit := false; destroy; end;
procedure MyEndWin.OnStCol;
begin
SetBkColor(msg.WParam, colr_db);
SetTextColor(msg.WParam, colr_yl);
if msg.LParam <> hbct then SelectObject(msg.WParam, hfnt1) else SelectObject(msg.WParam, hfnt2);
msg.Result := hb_db;
end;

procedure MyEndWin.OnEUREKA;
begin
 dec(counter);
 SetWindowText(hbct, PCHar(inttostr(counter)));
 if counter = 0 then begin
   if fcoff then app.fNeedOFF := true else app.fNeedReboot := true;
 close; end; {end if}
end;
procedure MyEndWin.OnCommand; begin if msg.Ctl = hbut then close; end;
procedure PlaySpk;
begin
    PlayMusic(app.path + 'music.dll', b, sync, app.nt);
end;
procedure StopSpk;
begin
    stop := true;
if not app.nt then spkoff;
end;

end.
