unit algor;

interface

uses windows, myutils, myconst, dbg;

type
      TMonth = 1..12;
      TDay = 1..31;
      TTick = 0..59;
      THour = 0..23;
      TWeekDayRu = 1..7;

const
     monlen : array [TMonth] of byte =(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31); // len months

/////////////////////////////////
type
    MyRect = record
    left, top, width, height : integer;
    end;

    MyQuad = record
    a : dword;
    r : MyRect;
    enable : boolean;
    s_help : string;
    end;

/////////////////////////////////
type
    MyDate   = packed Object
    year     : word;
    month    : byte;
    day      : byte;
    public
             function  weekday : byte;
             function  TryPutData(yr, mn, dt : longint) : boolean;
    end;

    MyDT      = packed object(MyDate)
    hour      : byte;
    minute    : byte;
    protected
    function  GetHrMn : word;
    procedure SetHrMn(Value : word);
    public
    property  HrMn : word read GetHrMn write SetHrMn;
    function  TryPutTime(hr, min : longint) : boolean;
    function  TryPutDataAndTime(yr, mn, dt, hr, min : longint) : boolean;
    end;
/////////////////////////////////
  const
       event_maxmesslen = 100; // use only this unit
       event_pmaxmesslen : byte = event_maxmesslen; // all use

       gorg1_year           = 'gorg1_year';
       gorg1_month          = 'gorg1_month';
       gorg1_day            = 'gorg1_day';
       gorg1_hour           = 'gorg1_hour';
       gorg1_minute         = 'gorg1_minute';
       gorg1_action         = 'gorg1_action';
       gorg1_period         = 'gorg1_period';
       gorg1_duration       = 'gorg1_duration';
       gorg1_cycle          = 'gorg1_cycle';
       gorg1_category       = 'gorg1_category';
       gorg1_filename       = 'gorg1_filename';
       gorg1_message        = 'gorg1_message';
       gorg1_showmessage    = 'gorg1_showmessage';
       gorg1_deleteafteruse = 'gorg1_deleteafteruse';
       gorg1_realtime       = 'gorg1_realtime';
       gorg1_disable        = 'gorg1_disable';
       gorg1_week           = 'gorg1_week';
       gorg1_influence      = 'gorg1_influence';

type
    MyEvent  = packed object(MyDT)
    number   : word;                     // number of object
    wd       : byte;                     // weekdays
    action   : byte;                     // action
    period   : byte;                     // periodicity
    duration : dword;                    // duration
    cycle    : dword;                    // cycle
    cat      : byte;                     // class event
    mess     : string[event_maxmesslen]; // message
    filn     : string[8];                // file name
    remove   : bytebool;                 // remove after using
    realtime : bytebool;                 // real time only
    disable  : bytebool;                 // off
    display  : bytebool;                 // display message
    power    : bytebool;                 // power on
    influence : bytebool;                // influence on people plan
    r_word1, r_word2, r_word3 : word;    // reserved words
    r_byte1, r_byte2, r_byte3, r_byte4,
    r_byte5, r_byte6, r_byte7, r_byte8,
    r_byte9, r_byte10 : byte;            // reserved bytes
    r_bool   : bytebool;                 // -||- bytebool
    public
    procedure Reset;
    function SelfDataStarshe(m : MyEvent) : boolean;
    function SelfTimeStarshe(m : MyEvent) : boolean;
    function SelfDataAndTimeStarshe(m : MyEvent) : boolean;
    function SelfDataRavno(m : MyEvent) : boolean;
    function SelfTimeRavno(m : MyEvent) : boolean;
    function SelfDataAndTimeRavno(m : MyEvent) : boolean;
    function SelfDataStarsheNoYear(m : MyEvent) : boolean;
    function SelfDataAndTimeStarsheNoYear(m : MyEvent) : boolean;
    function SelfDataRavnoNoYear(m : MyEvent) : boolean;
    function SelfDataAndTimeRavnoNoYear(m : MyEvent) : boolean;
    function PlusMinute : MyEvent;
    function PlusHour   : MyEvent;
    function PlusDay    : MyEvent;
    function PlusMonth  : MyEvent;
    function MinusMinute : MyEvent;
    function MinusHour   : MyEvent;
    function MinusDay    : MyEvent;
    function MinusMonth  : MyEvent;
    function Activate(m : MyEvent; InitTrueRtmFalse, Jubilee : boolean) : boolean;
    function ActivateInDay(m : MyEvent) : boolean;
    function ActivateIn12p(m : MyEvent) : boolean;
    function Ex : boolean;

    function ExportString : string;
    function ImportString(s : string) : boolean;
    end;
/////////////////////////////////
    MyStat   = packed object(MyDT)
    swminute : byte;
    public
     procedure GetCurrentTime;
     function  Mev    : MyEvent;
    end;

function vg(y : longint) : boolean; register;
function fdnd(y: longint; m: TMonth; d: TDay) : TWeekDayRu; register;    

implementation

function MyDate.weekday; begin result := fdnd(year, month, day); end;

function  MyDT.GetHrMn : word; begin result := hour * 60 + minute end;
procedure MyDT.SetHrMn(Value : word); begin hour := Value div 60; minute := Value mod 60; end;

function vg;
begin
result := (((y and 3) = 0) and (((y mod 100) <> 0))) or ((y mod 400) = 0);
end;

function fdnd;
var
  Era, Yoe, Doy, Doe, civ : longint;
begin
if M <= 2 then Dec(Y);
if Y >= 0 then Era := Y div 400
          else Era := (Y - 399) div 400;
Yoe := Y - Era * 400;
if M > 2 then Doy := -3
         else Doy := 9;
Doy := (153 * (M + Doy) + 2) div 5 + D - 1;
Doe := Yoe * 365 + Yoe shr 2 - Yoe div 100 + Doy;
civ := Era * 146097 + Doe - 719468;
if civ >= -4 then Doe := (civ + 4) mod 7
else Doe := (civ + 5) mod 7 + 6;
if Doe = 0 then Doe := 7;
result := Doe;
end;

procedure MyStat.GetCurrentTime;
var t : TSystemTime; begin GetLocalTime(t);
year := t.wYear; month := t.wMonth; day := t.wDay;
hour := t.wHour; minute := t.wMinute;
end;

// function MyStat.BitDnd; begin result := 1 shl weekday - 1;end;
function MyStat.Mev;
begin
                 result.Reset;
 result.year    := year;
 result.month   := month;
 result.day     := day;
 result.hour    := hour;
 result.minute  := minute;
end;

procedure MyEvent.Reset;
begin
number := 0;
wd := 0;
action := 0;
period := 0;
duration := 0;
cycle := 2;
mess := '';
filn := '';
remove := true;
realtime := false;
disable := false;
display := false;
power := false;
cat := 0;
influence := false;
// ex := false;
hour := 0;
minute := 0;
year := 0;
month := 0;
day := 0;
// show := false;
end;

function MyEvent.Ex; begin result := number > 0; end;

function MyEvent.SelfDataStarshe(m : MyEvent) : boolean;
begin
  result := (m.year > year) or
   ((m.year = year) and (m.month > month)) or
    ((m.year = year) and (m.month = month) and (m.day > day));
end;

function MyEvent.SelfTimeStarshe(m : MyEvent) : boolean; begin result := (m.hour > hour) or ((m.hour = hour) and (m.minute > minute)); end;

function MyEvent.SelfDataAndTimeStarshe(m : MyEvent) : boolean;
begin
  result := (m.year > year) or
   ((m.year = year) and (m.month > month)) or
    ((m.year = year) and (m.month = month) and (m.day > day)) or
     ((m.year = year) and (m.month = month) and (m.day = day) and (m.hour > hour)) or
      ((m.year = year) and (m.month = month) and (m.day = day) and (m.hour = hour) and (m.minute > minute));
end;

function MyEvent.SelfDataRavno(m : MyEvent) : boolean; begin result := (m.year = year) and (m.month = month) and (m.day = day); end;

function MyEvent.SelfTimeRavno(m : MyEvent) : boolean; begin result := (m.hour = hour) and (m.minute = minute); end;

function MyEvent.SelfDataAndTimeRavno(m : MyEvent) : boolean; begin result := (m.year = year) and (m.month = month) and (m.day = day) and (m.hour = hour) and (m.minute = minute); end;

function MyEvent.SelfDataStarsheNoYear(m : MyEvent) : boolean;
begin
  result := (m.month > month) or
   (m.month = month) and (m.day > day);
end;

function MyEvent.SelfDataAndTimeStarsheNoYear(m : MyEvent) : boolean;
begin
  result := (m.month > month) or
   (m.month = month) and (m.day > day) or
    (m.month = month) and (m.day = day) and (m.hour > hour) or
     (m.month = month) and (m.day = day) and (m.hour = hour) and (m.minute > minute);
end;

function MyEvent.SelfDataRavnoNoYear(m : MyEvent) : boolean; begin result := (m.month = month) and (m.day = day); end;

function MyEvent.SelfDataAndTimeRavnoNoYear(m : MyEvent) : boolean; begin result := (m.month = month) and (m.day = day) and (m.hour = hour) and (m.minute = minute); end;

function MyEvent.PlusMinute : MyEvent;
  var
    b : byte;
begin
  result := self;
  inc(result.minute);
 if result.minute = 60 then begin
    result.minute := 0;
    inc(result.hour);
   if result.hour = 24 then begin
      result.hour := 0;
      inc(result.day);
      b := monlen[result.month];
      if (result.month = 2) and vg(result.year) then b := 29;
     if result.day > b then begin
        result.day := 1;
        inc(result.month);
       if result.month > 12 then begin
          result.month := 1;
          inc(result.year);
       end; {end if > 12}
     end; {end if > b}
   end; {end if = 24}
 end; {end if = 60}
end;

function MyEvent.PlusHour   : MyEvent;
  var
    b : byte;
begin
  result := self;
    inc(result.hour);
   if result.hour = 24 then begin
      result.hour := 0;
      inc(result.day);
      b := monlen[result.month];
      if (result.month = 2) and vg(result.year) then b := 29;
     if result.day > b then begin
        result.day := 1;
        inc(result.month);
       if result.month > 12 then begin
          result.month := 1;
          inc(result.year);
       end; {end if > 12}
     end; {end if > b}
   end; {end if = 24}
end;

function MyEvent.PlusDay    : MyEvent;
  var
    b : byte;
begin
  result := self;
      inc(result.day);
      b := monlen[result.month];
      if (result.month = 2) and vg(result.year) then b := 29;
     if result.day > b then begin
        result.day := 1;
        inc(result.month);
       if result.month > 12 then begin
          result.month := 1;
          inc(result.year);
       end; {end if > 12}
     end; {end if > b}
end;

function MyEvent.PlusMonth  : MyEvent;
begin
  result := self;
        inc(result.month);
       if result.month > 12 then begin
          result.month := 1;
          inc(result.year);
       end; {end if > 12}
end;

function MyEvent.MinusMinute : MyEvent;
  var
    b : byte;
begin
  result := self;
  if result.minute = 0 then begin
     result.minute := 59;
     if result.hour = 0 then begin
        result.hour := 23;
        dec(result.day);
       if result.day = 0 then begin
          dec(result.month);
         if result.month = 0 then begin
            result.month := 12;
            dec(result.year);
         end; {end if result.month = 0}
       b := monlen[result.month];
       if (result.month = 2) and vg(result.year) then b := 29;
       result.day := b;
       end; {end if result.day = 0}
     end else dec(result.hour); {end if hour = 0}
  end else dec(result.minute); {end if minute = 0}
end;

function MyEvent.MinusHour   : MyEvent;
  var
    b : byte;
begin
  result := self;
     if result.hour = 0 then begin
        result.hour := 23;
        dec(result.day);
       if result.day = 0 then begin
          dec(result.month);
         if result.month = 0 then begin
            result.month := 12;
            dec(result.year);
         end; {end if result.month = 0}
       b := monlen[result.month];
       if (result.month = 2) and vg(result.year) then b := 29;
       result.day := b;
       end; {end if result.day = 0}
     end else dec(result.hour); {end if hour = 0}
end;

function MyEvent.MinusDay    : MyEvent;
  var
    b : byte;
begin
  result := self;
        dec(result.day);
       if result.day = 0 then begin
          dec(result.month);
         if result.month = 0 then begin
            result.month := 12;
            dec(result.year);
         end; {end if result.month = 0}
       b := monlen[result.month];
       if (result.month = 2) and vg(result.year) then b := 29;
       result.day := b;
       end; {end if result.day = 0}
end;

function MyEvent.MinusMonth  : MyEvent;
begin
     dec(result.month);
        if result.month = 0 then begin
           result.month := 12;
           dec(result.year);
        end; {end if result.month = 0}
end;

function MyEvent.Activate;
  var
    cnt : dword; tmp : MyEvent;
begin cnt := 0;  result := false;
if not self.disable and (self.number <> 0) then begin
   case self.period of
      0: result := SelfDataAndTimeRavno(m); // one
      1: result := m.minute = self.minute; // hourly
      2: result := SelfTimeRavno(m); // daily
      3: result := ((self.wd and (1 shl (m.weekday - 1))) <> 0); // w  d
      4: result := self.day = m.day; // day of month
      5: result := ((m.day mod 2) = 0); // chot
      6: result := ((m.day mod 2) <> 0); // nechot
      7: result := SelfDataAndTimeRavnoNoYear(m); // eer
      8: result := SelfDataAndTimeRavnoNoYear(m); // jubilee
      9: begin  // dni
         if m.SelfDataStarshe(self) then exit;
         tmp := self;
         while not tmp.SelfDataRavno(m) do begin
         tmp := tmp.PlusDay;
         inc(cnt);
         end; {wend}
         result := (cnt mod tmp.cycle) = 0;
      end;
     10: begin // chasy
         if (self.minute <> m.minute)
           or m.SelfDataAndTimeStarshe(self) then exit;
         tmp := self;
         while not tmp.SelfDataAndTimeRavno(m) do begin
     //   messagebox(0, PCHar(inttostr(tmp.hour) + ' : ' + inttostr(tmp.minute)), '', 0);
         tmp := tmp.PlusHour;
         inc(cnt);
         end; {wend}
         result := (cnt mod tmp.cycle) = 0;
      end;
   end; {end select}


 if InitTrueRtmFalse then begin
   case self.period of
   0: result := SelfDataAndTimeStarshe(m) and not realtime;  //  one
   2: result := SelfTimeStarshe(m) and not realtime; // daily
   3..6: result := SelfTimeStarshe(m) and result and not realtime;
   7: result := SelfDataRavnoNoYear(m) and SelfTimeStarshe(m) and not realtime;  // Y
   8: begin // j
     if Jubilee then begin
      result := m.SelfDataRavnoNoYear(self.MinusDay);
     end else begin
      result := (SelfDataRavnoNoYear(m) and SelfTimeStarshe(m)) and not realtime;
     end; {end if}
   end;
   9: result := SelfTimeStarshe(m) and result and not realtime;
   end; {end select}
 end else begin
   case self.period of
     3..6: if result then result := SelfTimeRavno(m);
     9   : if result then result := SelfTimeRavno(m);
   end; {end select}
 end; {end if}
end; {end if}
// if result then dint(4);
end;

function MyEvent.ActivateInDay(m : MyEvent) : boolean;
  var
    f : dword;
    a : MyEvent;
begin
  a := m; result := false;
  if (Ex and (not disable)) then
  for f := 0 to 1439 do begin
    a.HrMn := f;
    result := self.Activate(a, false, false);
   if result then break;
  end; {next f}
end;

function MyEvent.ActivateIn12p(m : MyEvent) : boolean;
begin result := false;
if self.period = 8 then result := m.SelfDataRavnoNoYear(self.MinusDay);
end;

function  MyDate.TryPutData(yr, mn, dt : longint) : boolean;
  var
    l : longint;
begin result := false;
result := (yr < 1) or (yr > 9000) or (mn > 12) or (mn < 1) or (dt < 1);
if result then exit;
l := monlen[mn];
if mn = 2 then if vg(yr) then l := 29;
if dt > l then result := true;
if result then exit;
year := yr;
month := mn;
day := dt;
end;
function  MyDT.TryPutTime(hr, min : longint) : boolean;
begin
 result := (hr < 0) or (hr > 23) or (min < 0) or (min > 59);
 if result then exit;
 hour := hr;
 minute := min;
end;
function  MyDT.TryPutDataAndTime(yr, mn, dt, hr, min : longint) : boolean;
begin result := TryPutTime(hr, min); if result then exit;
result := TryPutData(yr, mn, dt); end;

function MyEvent.ExportString : string;
begin
 result :=
 gorg1_influence + ':' + inttostr(BooleanToLongint(influence)) + #9 +
 gorg1_disable + ':' + inttostr(BooleanToLongint(disable)) + #9 +
 gorg1_realtime + ':' + inttostr(BooleanToLongint(realtime)) + #9 +
 gorg1_deleteafteruse + ':' + inttostr(BooleanToLongint(remove)) + #9 +
 gorg1_showmessage + ':' + inttostr(BooleanToLongint(display)) + #9 +
 gorg1_week + ':' + inttostr(wd) + #9 +
 gorg1_message + ':' + mess + #9 +
 gorg1_filename + ':' + filn + #9 +
 gorg1_category + ':' + inttostr(cat) + #9 +
 gorg1_cycle + ':' + inttostr(cycle) + #9 +
 gorg1_duration + ':' + inttostr(duration) + #9 +
 gorg1_period + ':' + inttostr(period) + #9 +
 gorg1_action + ':' + inttostr(action) + #9 +
 gorg1_minute + ':' + inttostr(minute) + #9 +
 gorg1_hour + ':' + inttostr(hour) + #9 +
 gorg1_day + ':' + inttostr(day) + #9 +
 gorg1_month + ':' + inttostr(month) + #9 +
 gorg1_year + ':' + inttostr(year){ + #9}
 ;
end;

function StrToTwoStr(Var s, sl, sr : string; br : char) : boolean;
  var
    f, l, fnd : longint;
begin result := false; fnd := 0;  l := length(s);
if l < 1 then begin result := true; exit; end;

for f := 1 to l do
 if s[f] = br then begin
   fnd := f;
   break;
 end; {end if}

if (fnd > 1) and (fnd <= l) then begin
 sl := copy(s, 1, fnd - 1);
 if fnd <> l then sr := copy(s, fnd + 1, l - fnd) else sr := '';
end else result := true; {end if}
end;

function MyEvent.ImportString(s : string) : boolean;
  var
    f, max, l, m1, m2, tm, tmmin, tmhour, tmdt, tmmon, tmyr : longint;
    tmp, strl, strr                                         : string;
begin strr := ''; strl := strr;
result := false; m1 := 0; m2 := 0; tmp := '';
    l := length(s);
if  l < 1 then begin result := true; exit; end;
reset;
 for f := 1 to l do begin
  if (s[f] = #9) or (f = l) then begin

   m2    := f;
   if (f = l) and (s[f] <> #9) then inc(m2);
   if m2 > (m1 + 1) then tmp := copy(s, m1 + 1, m2 - m1 - 1);
   m1    := m2;
// . . . . . . . . . . . . . . . . . . . . . . . .
   if not StrToTwoStr(tmp, strl, strr, ':') then begin

//            MessageBox(0, PCHar(strl), PCHar(strr), 0);

      if strl = gorg1_influence then begin
         influence := LongintToBoolean(StrToIntDef(strr, 0));
         continue;
      end; {end if}
      if strl = gorg1_disable then begin
         disable := LongintToBoolean(StrToIntDef(strr, 0));
         continue;
      end; {end if}
      if strl = gorg1_realtime then begin
         realtime := LongintToBoolean(StrToIntDef(strr, 0));
         continue;
      end; {end if}
      if strl = gorg1_deleteafteruse then begin
         remove := LongintToBoolean(StrToIntDef(strr, 0));
         continue;
      end; {end if}
      if strl = gorg1_showmessage then begin
         display := LongintToBoolean(StrToIntDef(strr, 0));
         continue;
      end; {end if}
      if strl = gorg1_week then begin
         tm := strtointdef(strr, $FFFFFFFF);
         if (0 > tm) or (127 < tm) then continue;
         wd := tm;              continue;
      end; {end if}
      if strl = gorg1_message then begin
         mess := strr;          continue;
      end; {end if}
      if strl = gorg1_filename then begin
         filn := strr;          continue;
      end; {end if}
      if strl = gorg1_category then begin
         tm := strtointdef(strr, $FFFFFFFF);
         if (0 > tm) or (cat_max < tm) then continue;
         cat := tm;             continue;
      end; {end if}
      if strl = gorg1_cycle then begin
         tm := strtointdef(strr, $FFFFFFFF);
         if (2 > tm) or (cik_max < tm) then continue;
         cycle := tm;           continue;
      end; {end if}
      if strl = gorg1_duration then begin
         tm := strtointdef(strr, $FFFFFFFF);
         if (0 > tm) or (50000 < tm) then continue;
         duration := tm;        continue;
      end; {end if}
      if strl = gorg1_period then begin
         tm := strtointdef(strr, $FFFFFFFF);
         if (0 > tm) or (period_max < tm) then continue;
         period := tm;          continue;
      end; {end if}
      if strl = gorg1_action then begin
         tm := strtointdef(strr, $FFFFFFFF);
         if (0 > tm) or (action_max < tm) then continue;
         action := tm;          continue;
      end; {end if}

      if strl = gorg1_minute then begin
        tmmin := strtointdef(strr, $FFFFFFFF);
        continue;
      end; {end if}
      if strl = gorg1_hour then begin
        tmhour := strtointdef(strr, $FFFFFFFF);
        continue;
      end; {end if}
      if strl = gorg1_day then begin
        tmdt := strtointdef(strr, $FFFFFFFF);
        continue;
      end; {end if}
      if strl = gorg1_month then begin
        tmmon := strtointdef(strr, $FFFFFFFF);
        continue;
      end; {end if}
      if strl = gorg1_year then begin
        tmyr :=  strtointdef(strr, $FFFFFFFF);
        continue;
      end; {end if}
   end; {end if}
// . . . . . . . . . . . . . . . . . . . . . . . .
  end; {end if}
 end; {next f}

 result := TryPutDataAndTime(tmyr,tmmon,tmdt,tmhour,tmmin);
end;

end.
