unit application;

interface

uses
    Windows,
    Messages,
    MyForms,
    MyMnWin,
    MyDlgAl,
    MyEE,
    MyConst,
    MyUtils,
    MyThread,
    algor,
    dbg,
    spkpl,
    commctrl,
    MyParams,
    MySetup;

 const colr_my : dword = 14803425; // my color !
       colr_rd : dword = 210; // red color !
       colr_db : dword = 7208960;  // dark blue color !
//       colr_yl : dword = 13172735;
//       colr_yl : dword = 14483455;
       colr_lyl : dword = 15794175;
       colr_yl : dword = 9895935;
//       colr_yl : dword = 65535;  // yellow color !
       colr_bl : dword = 16711680; // blue color

       colr_black : dword = 0;
       colr_white : dword = $FFFFFF;

 const tfn     : string = ('gorg.tun'); // tun file name
       stfn    : string = ('gorgsys.tun'); // win depedent tun file name
       u_dir   : string = ('userdata\'); // direct. for user data
       s_dir   : string = ('sounds\');  // direct. for sounds
       m_dir   : string = ('melodys\'); // direct. for musics
       b_dir   : string = ('batchs\'); // direct. for batch files
       z_dir   : string = ('iconslib\'); // direct. znach libr files
       h_dir   : string = ('help\'); // help files dir
       f_dir   : string = ('flash\'); // flash files dir

       wfn     : string = ('gorg.rwo'); // work file name
       fl_fn   : string = ('flash.txt'); // flash log file name
       fl_tfn  : string = ('tflash.txt'); // temporary flash log file name
       flhl_fn : string = ('flash.sav'); // flash hot list file name
       hm_fn   : string = ('gorg.sav'); // hot list file name
       nbp_fn  : string = ('peoples.txt'); // people notebook
       nbo_fn  : string = ('orgnztns.txt'); // organizations notebook
       icn_fn  : string = ('icons.dll');
       fmtc_fn : string = ('format_clock_panel.txt');

{ const mm1     : cardinal = WM_USER + 1;
       mm2     : cardinal = WM_USER + 2;}

type
    MyHotKey = packed record
    active   : bytebool;
    key      : byte;
    ctrl     : bytebool;
    shift    : bytebool;
    alt      : bytebool;
    number   : word;
    end;

type
    TSelRegStr = array[0..2] of string[255];

type
    TTun = packed object
    nobag               : string[4];
    fmute, fnoact       : bytebool;
    al_dlg_mem_action   : byte;
    sync_mus, sync_snd  : bytebool;
    HotKeys             : array[0..max_hot_keys] of MyHotKey;
    book_lv_view        : byte;
    reg_str             : string[255];
    engtrue_hour_fmt    : bytebool;
    engtrue_calend_fmt  : bytebool;
    flash_accmulate     : bytebool;
    protected
         procedure   SetMute(Value : bytebool);
         procedure   SetNoAct(Value : bytebool);
    private
    public
         procedure   WorkTunFile(SaveTrue : boolean);
         property    Mute : bytebool read fmute write SetMute;
         property    NoAct : bytebool read fnoact write SetNoAct;
         procedure   ResetHotKeys;
    end;
type
    TSysTun = object
    main_left, main_top : integer;
    ee_left, ee_top, ee_width, ee_height : integer;
    ee_maximize : bytebool;
    book_left, book_top, book_width, book_height : integer;
    book_maximize : bytebool;
    f_force_reboot, f_force_off, f_pwr_off : bytebool;
    main_fixation : bytebool;
    flash_left, flash_top, flash_width, flash_height : SmallInt;
    flash_maximize : bytebool;
    siz_clock      : SmallInt;  // width of clock panel    
    protected
         procedure   SetFixation(Value : bytebool);
    private
    public
         procedure   WorkSysTunFile(SaveTrue : boolean);
         property    Fixation : bytebool read main_fixation write SetFixation;
    end;

type
    TGt  = class(TThread)

    protected
         function    ThreadProcedure: DWord; override;
    end;


    const max_event  = 1000;
          pmax_event : word = max_event; // for use in all units

          max_his    = 300;
          pmax_his   : word = max_his;   // for use in all units

type
    MyOrg = object
    nobag : string[4];
    w     : array[1..max_event] of MyEvent;
    hst   : array[1..max_his] of string[255];
    protected

    private

    public
      procedure ShowAlarmDialog(a : word);
      procedure ShowMsg;
      procedure ShowEE(a : word);
      procedure Add;
      procedure DeleteOld;
//      procedure PrepareHistory;
      procedure AddHistory(s : string);
      procedure SelfReset;
      procedure ResetHistory;
      function  Save(num : word; hwnd : THandle) : boolean;
      function  SaveImport(m : MyEvent; hwnd : THandle) : boolean;
      function  Delete(n : dword) : boolean;
      procedure Initial;
      procedure WorkGorgFile(SaveTrue : boolean);
      function  Count : longint;
    end;

type
    TApp = Object
    hb_my          : THandle;  // handle my brush 225 225 225
    sc_h, sc_w     : integer;  // screen size
    hinstance      : THandle;  // application hinstance
    hwnd           : THandle;  // application hwnd
    nt             : boolean;  // if windows nt
    hfirstmenu     : THandle;  // handle first menu
    hmi_clock, hmi_help, hmi_opt, hmi_today, hmi_eedit, hmi_flash, hmi_mute,
    hmi_track, hmi_notebook, hmi_masks, hmi_noact, hmi_tools, hmi_nomove,
    hmi_pluspeople, hmi_plus_org
                   : THandle;  // handle menu bitmap

    hi_buran, hi_face, hi_notebook, hi_house, hi_exclamation,
    hi_question, hi_calendar, hi_clipboard
                   : THandle;
    path, winpath  : string;   // application path, windows path
    tun            : TTun;     // user depedent options
    stun           : TSysTun;  // system depedent options
    terminated     : boolean;  // need exit program
    processfree    : boolean;  // process free
    fNeedDlt       : boolean;  // event editor want delete events
    fNeedDltOld    : boolean;  // mesaage window want delete old events
    fNeedReboot    : boolean;  // reboot computer
    fNeedOFF       : boolean;  // off computer
    fNeedExpImp    : boolean;  // export - import events
     f_resetorg    : boolean;  // for -||-||-
     f_savetrue    : boolean;  // for -||-||-
     f_ExpImpStr   : string;   // for -||-||-
    fNeedDelSndFil : boolean;  // delete non used sound files 
    stat           : MyStat;   // current data and time
    org            : MyOrg;    // work space
    orgtodaycount  : dword;    // count of events in current day
    fmt_clock      : string;   // format of clock

    protected

    private
    public
          procedure   Create;
          procedure   Free;
          function    FilErr(I : integer; s : string; fhalt : boolean) : boolean;
          property    HBRUSH_MY : THandle read hb_my default 0;
//          procedure   EndSession;
          procedure   ShowFlash;
//          procedure   ShowHintWindow;
          procedure   ShowExitWindows(cofftrue : boolean);
          procedure   ShowSetup;
          procedure   ShowBook(act : byte);
          procedure   ShowHelp(act : longint);
          procedure   SetEventsCount;
          procedure   GetMusicLibNames;
          procedure   RegisterHotKeys;
          procedure   UnRegisterHotKeys;
          function    FileImpExp(fn : string; savetrue, rst : boolean) : boolean;
          procedure   MailToAutor;
          procedure   JumpToHomePage;
          procedure   DelSndFiles;
          procedure   Md;
          procedure   Install;
          function    CheckRegStr(s : string) : boolean;
    end;

var
   app : TApp;
   hDesktopWindow : THandle;
   gt  : TThread;
   hb_rd, hb_db, hb_yl, hb_lyl : THandle;
   hf_my, hf_1, hf_2, hf_sy, hf_clock : THandle;
   obj : MyEvent;

   efMn, efAld, efMsw, efEE, efFlash, {efHw,} efExit,
   efSetup, efBook, efDlgPeople, efDlgOrg, efHelp : boolean;

   hAlarmDialog, hMesWin, hEE, hFlash, hHw, hExit,
   hSetup, hBook, hDlgPeople, hDlgOrg, hHelp : THandle;

          procedure  Beep;
          function   MyRectToTRect(r : MyRect) : TRect;
          function   TRectToMyRect(r : TRect) : MyRect;
          function   inttofix2str(i : integer) : string;
          function   VkToStr(b : word) : string;
          function   GetLocalHour(EngTrue : boolean; h : longint) : string;
//          function SwitchToThisWindow(hwnd : THandle) : THandle; stdcall; external 'User32.dll';

implementation
 uses      msgwin,  actions, flsh, {hin,} winoff, usetup, uhelp, noteb;

function GetWinPath : string;
  var a : array[0..MAX_PATH + 255] of char; p : PCHar;
begin  p := @a;
  GetWindowsDirectory(p, GetWindowsDirectory(p, MAX_PATH));
  result := String(p) + '\';
end;

function inttofix2str(i : integer) : string;
begin result := inttostr(i);
if 10 > i then result := '0' + result; end; {end fix}

function MyRectToTRect;
begin
 result.Left   := r.left;
 result.Top    := r.top;
 result.Right  := r.left + r.width;
 result.Bottom := r.top + r.height;
end;

function TRectToMyRect;
begin
 result.left   := r.Left;
 result.top    := r.Top;
 result.width  := r.Right - r.Left;
 result.height := r.Bottom - r.Top;
end;

procedure TApp.Create;
begin terminated := false; processfree := false;

          efAld := false; efMsw := false; efEE := false; {efHw := false;}
          efExit := false; efMn := false; efBook := false;

hinstance := GetModuleHandle(nil);
hDesktopWindow := GetDesktopWindow;

   hb_my := CreateSolidBrush(colr_my);
   hb_rd := CreateSolidBrush(colr_rd);
   hb_db := CreateSolidBrush(colr_db);
   hb_yl := CreateSolidBrush(colr_yl);
   hb_lyl := CreateSolidBrush(colr_lyl);

md; // make folder's

//   dint(rgb(0, 0, 255));
             //        h  w  e  o  wg    ital           underline       so              cs               op
hf_my := CreateFont(-14, 0, 0, 0, 800, Integer(false), Integer(false), Integer(false), DEFAULT_CHARSET, OUT_DEFAULT_PRECIS , CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH or FF_MODERN, 'Courier New'{'MS Sans Serif'});
 //  hf_1 := CreateFont(-15, 0, 0, 0, 700, Integer(true), Integer(false), Integer(false), DEFAULT_CHARSET, OUT_DEFAULT_PRECIS , CLIP_DEFAULT_PRECIS, {PROOF_QUALITY}DRAFT_QUALITY, DEFAULT_PITCH or FF_DONTCARE, 'Comic Sans MS');
 //  hf_2 := CreateFont(-12, 0, 0, 0, 700, Integer(true), Integer(false), Integer(false), DEFAULT_CHARSET, OUT_DEFAULT_PRECIS , CLIP_DEFAULT_PRECIS, {PROOF_QUALITY}DRAFT_QUALITY, DEFAULT_PITCH or FF_DONTCARE, 'Arial');
 //  hf_sy := CreateFont(-15, 0, 0, 0, 800, Integer(false), Integer(false), Integer(false), DEFAULT_CHARSET, OUT_DEFAULT_PRECIS , CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH or FF_SWISS, '');
hf_clock := CreateFont(-16, 0, 0, 0, 800, Integer(false), Integer(false), Integer(false), DEFAULT_CHARSET, OUT_DEFAULT_PRECIS , CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH or FF_MODERN, 'Courier New');

{menu}
 hfirstmenu := CreatePopupMenu;
 hmi_clock := LoadBitmap(hinstance, 'MITEMCLOCK');
// hmi_help  := LoadBitmap(hinstance, 'MITEMQUESTION');
 hmi_flash  := LoadBitmap(hinstance, 'MITEMFLASH');
 hmi_mute  := LoadBitmap(hinstance, 'MITEMMUTE');
 hmi_track  := LoadBitmap(hinstance, 'MITEMTRACK');
 hmi_today  := LoadBitmap(hinstance, 'MITEMSALE');
 hmi_notebook  := LoadBitmap(hinstance, 'MITEMNOTEBOOK');
 hmi_masks  := LoadBitmap(hinstance, 'MITEMMASKS');
 hmi_noact  := LoadBitmap(hinstance, 'MITEMNOACT');
 hmi_tools  := LoadBitmap(hinstance, 'MITEMTOOL');

 hmi_nomove      := LoadBitmap(hinstance, 'MITEMFIXATION');
 hmi_pluspeople  := LoadBitmap(hinstance, 'MITEMMASK');
 hmi_plus_org    := LoadBitmap(hinstance, 'MITEMFIRM');

 AppendMenu(hfirstmenu, MF_BITMAP, 100, PCHar(Longint(hmi_mute)));
 AppendMenu(hfirstmenu, MF_BITMAP, 101, PCHar(Longint(hmi_noact)));
AppendMenu(hfirstmenu, MF_BITMAP, 109, PCHar(Longint(hmi_nomove)));
 AppendMenu(hfirstmenu, MF_BITMAP{ or MF_CHECKED}, 107, PCHar(Longint(hmi_track)));

 AppendMenu(hfirstmenu, MF_MENUBARBREAK or MF_BITMAP, 106, PCHar(Longint(hmi_masks)));
 AppendMenu(hfirstmenu, MF_BITMAP, 103, PCHar(Longint(hmi_today)));
 AppendMenu(hfirstmenu, MF_BITMAP, 104, PCHar(Longint(hmi_notebook)));
 AppendMenu(hfirstmenu, MF_BITMAP, 108, PCHar(Longint(hmi_tools)));

 AppendMenu(hfirstmenu, MF_MENUBARBREAK or MF_BITMAP, 105, PCHar(Longint(hmi_flash)));
AppendMenu(hfirstmenu, MF_BITMAP, 110, PCHar(Longint(hmi_pluspeople)));
AppendMenu(hfirstmenu, MF_BITMAP, 111, PCHar(Longint(hmi_plus_org)));
 AppendMenu(hfirstmenu, MF_BITMAP, 102, PCHar(Longint(hmi_clock)));

{end menu}

{load icons}
  hi_buran       := LoadIcon(hinstance, MAKEINTRESOURCE(1));
  hi_face        := LoadIcon(hinstance, MAKEINTRESOURCE(2));
  hi_notebook    := LoadIcon(hinstance, MAKEINTRESOURCE(3));
  hi_house       := LoadIcon(hinstance, MAKEINTRESOURCE(5));
  hi_exclamation := LoadIcon(0, IDI_EXCLAMATION);
  hi_question    := LoadIcon(0, IDI_QUESTION);
  hi_calendar    := LoadIcon(hinstance, MAKEINTRESOURCE(6));
  hi_clipboard   := LoadIcon(hinstance, MAKEINTRESOURCE(4));
{end load}

sc_h := GetSystemMetrics(SM_CYSCREEN{SM_CYFULLSCREEN});
sc_w := GetSystemMetrics(SM_CXSCREEN{SM_CXFULLSCREEN});

GetMusicLibNames;

   tun.WorkTunFile(false);
   stun.WorkSysTunFile(false);

   if tun.fmute then begin
   tun.SetNoAct(tun.noact);
   tun.SetMute(true);
   end else begin
   tun.SetNoAct(tun.noact);
   tun.SetMute(false);
   end; {end if}

   stun.Fixation := stun.Fixation;

main := MyMain.Create(0);

   hwnd := main.Hwnd;

RegisterHotKeys;

Gt := TGt.Create;

   ResumeThread(gt.ThrHandle);

end;

procedure TApp.Free;
  var
    msg : TMsg;
begin
if processfree then exit;
processfree := true;
org.WorkGorgFile(true);
stun.WorkSysTunFile(true);
tun.WorkTunFile(true);
StopSpk;

 DeleteObject(hb_lyl);
 DeleteObject(hb_yl);
 DeleteObject(hb_my);
 DeleteObject(hb_rd);
 DeleteObject(hb_db);

 DeleteObject(hf_clock);
 DeleteObject(hf_my);

 DeleteObject(hmi_clock);
// DeleteObject(hmi_help);
 DeleteObject(hmi_flash);
 DeleteObject(hmi_mute);
 DeleteObject(hmi_track);
 DeleteObject(hmi_today);
 DeleteObject(hmi_notebook);
 DeleteObject(hmi_masks);
 DeleteObject(hmi_noact);
 DeleteObject(hmi_tools);
 DeleteObject(hmi_nomove);
 DeleteObject(hmi_pluspeople);
 DeleteObject(hmi_plus_org);
 DestroyMenu(hfirstmenu);

 DestroyIcon(hi_buran);
 DestroyIcon(hi_face);
 DestroyIcon(hi_notebook);
 DestroyIcon(hi_house);
 DestroyIcon(hi_exclamation);
 DestroyIcon(hi_calendar);
 DestroyIcon(hi_clipboard);
 DestroyIcon(hi_question);

 if fNeedReboot then
  EndWindowsF(nt, false, stun.f_force_reboot, true)
     else
 if fNeedOFF    then
  EndWindowsF(nt, true, stun.f_force_off, stun.f_pwr_off);

//  beep;
  halt;
end;

procedure Beep; begin MessageBeep(0) end;

procedure TTun.WorkTunFile;
var fp : file;
procedure Fr;
begin
 fmute := false;
 al_dlg_mem_action := 0;
 sync_mus          := false;
 sync_snd          := false;
 ResetHotKeys;
 book_lv_view      := 0;
 reg_str           := '';
 engtrue_hour_fmt    := false;  // for eng true !!!
 engtrue_calend_fmt  := false;
 flash_accmulate := false;
 exit;
end;
begin

SetFileAttributes(PCHar(tfn), FILE_ATTRIBUTE_NORMAL);
assignfile(fp, tfn);

if savetrue then begin

//

{$I-}
 rewrite(fp, 1);
{$I+} app.FilErr(IOResult, '[Rewrite Tun File]', false);

{$I-}
 blockwrite(fp, self, SizeOf(self));
{$I+} app.FilErr(IOResult, '[Write Tun File]', false);

end else begin

{$I-}
 reset(fp, 1);
{$I+} if IOResult <> 0 then begin fr; exit; end;

{$I-}
 blockread(fp, self, SizeOf(self));
{$I+} if app.FilErr(IOResult, '[Read Tun File]', false) then fr;

end; {end if}

{$I-}
 closefile(fp);
{$I+} app.FilErr(IOResult, '[Close SysTun File]', false);

end;  {work tun file}
//////////////////////////////////////////////////////////
procedure TSysTun.WorkSysTunFile;
var fp : file;
procedure Fr;
begin
 main_left       := 0;
 main_top        := 0;
 ee_left         := 0;
 ee_top          := 0;
 ee_width        := ee_w;
 ee_height       := ee_h;
 ee_maximize     := false;
 f_force_reboot  := false;
 f_force_off     := false;
 f_pwr_off       := true;
 book_left       := 0;
 book_top        := 0;
 book_width      := book_w;
 book_height     := book_h;
 book_maximize   := false;
 main_fixation   := false;
 flash_left      := 0;
 flash_top       := 0;
 flash_width     := 474;
 flash_height    := 350;
 flash_maximize  := false;
 siz_clock       := main_w;
end;
begin

SetFileAttributes(PCHar(stfn), FILE_ATTRIBUTE_NORMAL);
assignfile(fp, stfn);

if savetrue then begin

   main_left := main.Fleft;
   main_top  := main.Ftop;

{$I-}
 rewrite(fp, 1);
{$I+} app.FilErr(IOResult, '[Rewrite SysTun File]', false);

{$I-}
 blockwrite(fp, self, SizeOf(self));
{$I+} app.FilErr(IOResult, '[Write SysTun File]', false);

end else begin

{$I-}
 reset(fp, 1);
{$I+} if IOResult <> 0 then begin fr; exit; end;

{$I-}
 blockread(fp, self, SizeOf(self));
{$I+} if app.FilErr(IOResult, '[Read SysTun File]', false) then fr;

end; {end if}

{$I-}
 closefile(fp);
{$I+} app.FilErr(IOResult, '[Close SysTun File]', false);

end;  {work sys tun file}

procedure   MyOrg.WorkGorgFile(SaveTrue : boolean);
  var fp : file;
begin
SetFileAttributes(PCHar(wfn), FILE_ATTRIBUTE_NORMAL);
assignfile(fp, wfn);

if savetrue then begin
{$I-}
 rewrite(fp, 1);
{$I+} app.FilErr(IOResult, '[Rewrite Work File]', false);

{$I-}
 blockwrite(fp, self, SizeOf(self));
{$I+} app.FilErr(IOResult, '[Write Work File]', false);

end else begin
 resethistory;
{$I-}
 reset(fp, 1);
{$I+} if IOResult <> 0 then begin
 exit;
 end; {if iores <> 0}
{$I-}
 blockread(fp, self, SizeOf(self));
{$I+} if app.FilErr(IOResult, '[Read Work File]', false) then selfreset;
end; {end if}
{$I-}
 closefile(fp);
{$I+} app.FilErr(IOResult, '[Close Work File]', false);
end; {work work file}

procedure TTun.SetMute;
begin fmute := value;
if fmute then begin
   CheckMenuItem(app.hfirstmenu, 100, MF_BYCOMMAND or MF_CHECKED);
   StopSnd;
   end else CheckMenuItem(app.hfirstmenu, 100, MF_BYCOMMAND or MF_UNCHECKED);
SendMessage(app.hwnd, WM_PAINT, 0, 0);
end;
procedure TTun.SetNoact;
begin fnoact := value;
if fnoact then begin
   CheckMenuItem(app.hfirstmenu, 101, MF_BYCOMMAND or MF_CHECKED);
   SetMute(true);  end else begin
   CheckMenuItem(app.hfirstmenu, 101, MF_BYCOMMAND or MF_UNCHECKED);
   SetMute(false); end;

SendMessage(app.hwnd, WM_PAINT, 0, 0);
end;

function TApp.FilErr;
begin result := i <> 0;
 if not result then exit;
 MessageBox(hwnd, PCHar(err_file + s), PCHar(app_name), 16);
 if fhalt then halt;
end;

procedure MyOrg.Initial;  {*1}
  var f : word; isstr : boolean;
begin

      isstr := false;
    for f := 1 to MAX_EVENT do begin
      if (app.org.w[f].Ex)  and not app.org.w[f].disable
      then begin

      if app.org.w[f].activate(app.stat.Mev, true, false) then begin
        if app.org.w[f].display then begin
         app.org.AddHistory(app.org.w[f].mess);
         isstr := true;
        end; {end if display}
      run(app.org.w[f], false);

      if (app.org.w[f].period = 0)
         and app.org.w[f].remove then app.org.Delete(f);

      end; {end if activate}

if app.org.w[f].period = 8 then begin
      if app.org.w[f].activate(app.stat.Mev, true, true) then begin
        if app.org.w[f].display then begin
         app.org.AddHistory(mess_jubilee + app.org.w[f].mess);
         isstr := true;
        end; {end if}
      run(app.org.w[f], false);
      end; {end if activate}
end; {end if period 8}

      end; {end if exists and enable}

    end; {next f}

    if isstr then  PostMessage(app.hwnd, WM_EUREKA, 0, 0);

    app.SetEventsCount;
end;

function TGt.ThreadProcedure;
  var f : word; isstr, isd : boolean;
  procedure Init12p;
    var f : word;
  begin
      for f := 1 to MAX_EVENT do begin
        if (app.org.w[f].Ex)  and not app.org.w[f].disable
        and app.org.w[f].activatein12p(app.stat.Mev)
        then begin
          run(app.org.w[f], false);
          if app.org.w[f].display then begin
            app.org.AddHistory(app.org.w[f].mess);  isstr := true;
          end; {end if}
        end; {end if}
      end; {next f}
    isd := true;
  end;
begin
app.stat.swminute := 60;  app.fNeedDlt := false; app.fNeedDltOld := false;
app.fNeedReboot := false; app.fNeedOFF := false; app.fNeedExpImp := false;
app.fNeedDelSndFil := false;
SetThreadPriority(ThrHandle, THREAD_PRIORITY_TIME_CRITICAL);
//THREAD_PRIORITY_HIGHEST
GetRebootAccess(app.nt);
 app.stat.GetCurrentTime;
app.org.WorkGorgFile(false);
app.org.Initial;

//if not app.CheckRegStr(app.tun.reg_str) then SendMessage(app.hwnd, WM_SHOWSETUP, 0, 0);

while not app.terminated do begin
if efMn then SendMessage(app.hwnd, WM_PAINT, 0, 0);

//           PostMessage(app.hwnd, WM_NULL, 0, 0);
//...........................................................
if (app.stat.swminute <> 60) and (app.stat.swminute <> app.stat.minute) then app.stat.swminute := 60;
if app.stat.swminute = 60 then begin
//....................................[]

      isstr := false; isd := false;

    if (app.stat.hour = 0) and (app.stat.minute = 0) then begin Init12p; end;

    for f := 1 to MAX_EVENT do begin
      if (app.org.w[f].Ex)  and not app.org.w[f].disable
      and app.org.w[f].activate(app.stat.Mev, false, false)
      then begin
        run(app.org.w[f], false);
        if app.org.w[f].display then begin
          app.org.AddHistory(app.org.w[f].mess);  isstr := true;
        end; {end if}
      if (app.org.w[f].period = 0)
         and app.org.w[f].remove then begin
                                       app.org.Delete(f); isd := true;
                                      end;
      end; {end if}
    end; {next f}

    if isstr then  PostMessage(app.hwnd, WM_EUREKA, 0, 0);
    if isd   then  app.SetEventsCount;

//....................................[]
app.stat.swminute := app.stat.minute;
end; {end if}
//...........................................................

    if app.fNeedDlt then begin
     SendMessage(EvEdit.hwnd, WM_DLT, 0, 0);
     app.fNeedDlt := false;
    end; {end if}

    if app.fNeedDltOld then begin
     app.org.DeleteOld;
     app.fNeedDltOld := false;
    end; {end if}

    if app.fNeedReboot or app.fNeedOFF then PostMessage(app.hwnd, WM_INITEXITWINDOWS, 2, 0);

    if efExit then PostMessage(hexit, WM_EUREKA, 0, 0);

    if app.fNeedExpImp then begin
    if efEE and not efAld then if app.FileImpExp(app.f_ExpImpStr, app.f_savetrue, app.f_resetorg) then MessageBox(app.hwnd, import_err, PCHar(app_name), bit6 or bit5);
    app.fNeedExpImp  := false;
    end; {end if}

    if app.fNeedDelSndFil then begin
    app.DelSndFiles;
    app.fNeedDelSndFil := false;
    end; {end if}

//...........................................................
 sleep(1000);
 app.stat.GetCurrentTime;
end;

 app.Free;
 result := 0;
end;

procedure MyOrg.ShowMsg;
begin
if efMsw then meswin.Close;
 MesWin := MyMesWin.Create; hMesWin := MesWin.hwnd;
 SetWindowPos(hMesWin, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
 SetForegroundWindow(hMesWin);
 ResumeThread(dt.ThrHandle);
end;

procedure MyOrg.ShowAlarmDialog;
begin
if efAld then begin
 if isIconic(hAlarmDialog) then ShowWindow(hAlarmDialog, SW_SHOWNORMAL);
 BringWindowToTop(hAlarmDialog); SetForegroundWindow(hAlarmDialog); exit; end;
AlarmDlg := MyAlarmDlg.Create(a); hAlarmDialog := AlarmDlg.hwnd;
BringWindowToTop(hAlarmDialog);
SetForegroundWindow(hAlarmDialog);
end;

procedure MyOrg.ShowEE;
begin
if efEE then begin
 if isIconic(hEE) then ShowWindow(hEE, SW_SHOWNORMAL);
 BringWindowToTop(hEE); SendMessage(hee, WM_EUREKA, a, 0);  SetForegroundWindow(hEE); exit; end;
EvEdit := MyEvEdit.Create(a); hEE := EvEdit.hwnd;
BringWindowToTop(hEE);
 SetForegroundWindow(hEE);
end;

procedure TApp.ShowFlash;
begin
if efFlash then begin
 if isIconic(hFlash) then ShowWindow(hFlash, SW_SHOWNORMAL);
 BringWindowToTop(hFlash);
 flash.Show;
 exit; end;
Flash := MyFlash.Create; hFlash := Flash.hwnd;
BringWindowToTop(hFlash);
end;

{procedure TApp.ShowHintWindow;
begin
if efHw or app.tun.NoAct then begin exit; end;
hintwindow := MyHintWindow.Create; hHw := hintwindow.hwnd;
end;}

procedure TApp.ShowSetup;
begin
if efSetup then begin
 if isIconic(hSetup) then ShowWindow(hSetup, SW_SHOWNORMAL);
end else begin SetupWindow := MySetupWindow.Create; hSetup := SetupWindow.hwnd; end;
BringWindowToTop(hSetup);
SetForegroundWindow(hSetup);
end;

procedure TApp.ShowExitWindows;
begin
if efExit then begin exit; end;
EndWindows := MyEndWin.Create(hwnd, cofftrue); hExit := EndWindows.hwnd;
BringWindowToTop(hSetup);
SetForegroundWindow(EndWindows.hbut);
end;

procedure TApp.ShowBook;
begin
if efBook then begin
 if isIconic(hBook) then ShowWindow(hBook, SW_SHOWNORMAL);
 PostMessage(hBook, WM_EUREKA, act, 0);
end else begin
NoteBook := MyNoteBook.Create(act); hBook := NoteBook.Hwnd;
end; {end if}
BringWindowToTop(hBook);
SetForegroundWindow(hBook);
end;

procedure   TApp.ShowHelp(act : longint);
begin
if efHelp then begin
 if isIconic(hHelp) then ShowWindow(hHelp, SW_SHOWNORMAL);
end else begin
 HelpWindow := MyHelpWindow.Create; hHelp := HelpWindow.Hwnd;
end; {end if}
PostMessage(hHelp, WM_EUREKA, 0, act);
BringWindowToTop(hHelp);
SetForegroundWindow(hHelp);
end;

procedure MyOrg.Add; begin ShowAlarmDialog(0); end;

{procedure MyOrg.PrepareHistory;
  var f   : word; begin for f := max_his downto 1 do hst[f][1] := ' '; end;}

procedure MyOrg.AddHistory;
  var f   : word; tmp : string;
begin for f := max_his downto 2 do hst[f] := hst[f - 1];
hst[1] := {'> ' + }inttostr(app.stat.year) + ' / ' + mon_name[app.stat.month] + ' / ' + inttofix2str(app.stat.day) + ' - ' + GetLocalHour(app.tun.engtrue_hour_fmt, app.stat.hour) + ':' + inttofix2str(app.stat.minute) + '    ' + s; end;

procedure MyOrg.SelfReset; var f : word;
begin for f := 1 to MAX_EVENT do w[f].number := 0; end;

procedure MyOrg.ResetHistory; var f : word;
begin for f := 1 to max_his do hst[f] := ''; end;

function MyOrg.Save;
label l_exit;
  var
    frn  : dword;
    f    : word;
    ifis : boolean;
 begin   result := false;

// dint(obj.number);
  if obj.number <> 0 then begin
    w[obj.number] := obj;
    goto l_exit;
  end; {end if}

  ifis := false;
  for f := 1 to MAX_EVENT do if w[f].number = 0 then begin frn := f; ifis := true; break; end;
  if ifis then begin
    if (obj.period = 0) and (obj.SelfDataAndTimeStarshe(app.stat.Mev) or obj.SelfDataAndTimeRavno(app.stat.Mev)) then begin
     if MessageBox(hwnd, PCHar(app_msg_evold), PCHar(app_name), 4 or 48) = IDNO then
     begin result := true; goto l_exit; end; {end if}
    end; {end if}
//   MessageBox(hwnd, PCHar(inttostr(frn)), '', 0);
   w[frn] := obj;
   w[frn].number := frn;
  end else begin
   MessageBox(hwnd, PCHar(app_msg_lgr + '(max ' + inttostr(MAX_EVENT) + ')'), PCHar(app_name), 16);
   result := true;
  end; {end if}

l_exit:
  if not result then app.SetEventsCount;
end;

function  MyOrg.SaveImport(m : MyEvent; hwnd : THandle) : boolean;
  var
    frn  : dword;
    f    : word;
    ifis : boolean;
begin      result := false;
  ifis := false;
  for f := 1 to MAX_EVENT do if w[f].number = 0 then begin frn := f; ifis := true; break; end;
  if ifis then begin
   w[frn] := m;
   w[frn].number := frn;
  end else begin
   MessageBox(hwnd, PCHar(app_msg_lgr + '(max ' + inttostr(MAX_EVENT) + ')'), PCHar(app_name), 16);
   result := true;
  end; {end if}
//  if not result then app.SetEventsCount;
end;

function  MyOrg.Delete;
begin result := false;
 if (efAld and (w[n].number = alarmdlg.num)) then begin result := true; exit; end;
 w[n].number := 0;
end;

procedure MyOrg.DeleteOld;
  var
    f : dword;
begin
 for f := 1 to MAX_EVENT do begin
  if (w[f].ex and (w[f].period = 0) and w[f].remove
     and (w[f].SelfDataAndTimeRavno(app.stat.Mev) or w[f].SelfDataAndTimeStarshe(app.stat.Mev))) then begin
       app.org.Delete(f);
  end; {end if}
 end; {next f}
  if efEE then PostMessage(hEE, WM_EUREKA, 0, 0);
  app.SetEventsCount;
end;

procedure TApp.SetEventsCount; var  f : dword; begin orgtodaycount := 0;
  for f := 1 to MAX_EVENT do begin if org.w[f].period <> 1 then if org.w[f].activateinday(app.stat.mev) then begin inc(orgtodaycount); end; {end if} end; {next f}
end;

procedure TApp.GetMusicLibNames;
  var
    f : word;
    GetMusicName : TGetMusicName;
    h : THandle;
begin
h := LoadLibrary(PCHar(app.path + 'music.dll'));
 @GetMusicName := GetProcAddress(h, 'GetMusicName');
 if @GetMusicName = nil then exit;
    for f := 0 to 9 do begin
     action_name1[f] := String(GetMusicName(f));
    end; {next f}
FreeLibrary(h);
end;

procedure TTun.ResetHotKeys;
  var
    f : word;
begin
 for f := 0 to max_hot_keys do begin
 HotKeys[f].active := false;
 HotKeys[f].key    := 32;
 HotKeys[f].ctrl   := false;
 HotKeys[f].shift  := false;
 HotKeys[f].alt    := false;
 HotKeys[f].number := f;
 end; {next f}
end;

procedure   TApp.RegisterHotKeys;
  var
    f : word;
    u : UInt;
begin
   for f := 0 to max_hot_keys do begin
   if tun.HotKeys[f].active then begin
    u := 0;
    if tun.HotKeys[f].ctrl then  u := u or MOD_CONTROL;
    if tun.HotKeys[f].shift then u := u or MOD_SHIFT;
    if tun.HotKeys[f].alt then   u := u or MOD_ALT;
    tun.HotKeys[f].active := RegisterHotKey(app.hwnd, f, u, tun.HotKeys[f].key);
    if not tun.HotKeys[f].active then MessageBox(app.hwnd, PCHar(err_not_reg_hot_key + hot_key_action_namws[f]), PCHar(app_name), 0);
   end; {end if}
   end; {next f}
end;

procedure   TApp.UnRegisterHotKeys;
  var
    f : word;
begin
   for f := 0 to max_hot_keys do begin
   UnregisterHotKey(app.hwnd, f);
   end; {next f}
end;

function VkToStr(b : word) : string;
begin
case b of
0:   result := '0'; 1:   result := 'mouse lbutton';
2:   result := 'mouse rbutton'; 3:   result := 'cancel';
4:   result := 'mouse mbutton'; 5:   result := '5';
6:   result := '6'; 7:   result := '7';
8:   result := 'back'; 9:   result := 'tab';
10:  result := '10'; 11:  result := '11';
12:  result := 'clear'; 13:  result := 'return';
14:  result := '14'; 15:  result := '15';
16:  result := 'shift'; 17:  result := 'control';
18:  result := 'menu'; 19:  result := 'pause';
20:  result := 'capital'; 21:  result := 'kana';
22:  result := '22'; 23:  result := 'junja';
24:  result := 'final'; 25:  result := 'hanja';
26:  result := '26'; 27:  result := 'escape';
28:  result := 'convert'; 29:  result := 'nonconvert';
30:  result := 'accept'; 31:  result := 'modechange';
32:  result := 'space'; 33:  result := 'prior';
34:  result := 'next';  35:  result := 'end';
36:  result := 'home';  37:  result := 'left';
38:  result := 'up';    39:  result := 'right';
40:  result := 'down';  41:  result := 'select';
42:  result := 'print'; 43:  result := 'execute';
44:  result := 'snapshot'; 45:  result := 'insert';
46:  result := 'delete';   47:  result := 'help';
48..57:  result := 'd' + chr(b); 58    :  result := '58';
59    :  result := '59';   60    :  result := '60';
61    :  result := '61';   62    :  result := '62';
63    :  result := '63';   64    :  result := '64';
65..90:  result := chr(b); 91:  result := 'lwin';
92:  result := 'rwin';     93:  result := 'apps';
94:  result := '94';       95:  result := '95';
96:  result := 'numpad0';  97:  result := 'numpad1';
98:  result := 'numpad2';  99:  result := 'numpad3';
100: result := 'numpad4';  101: result := 'numpad5';
102: result := 'numpad6';  103: result := 'numpad7';
104: result := 'numpad8';  105: result := 'numpad9';
106: result := 'multiply'; 107: result := 'add';
108: result := 'separator';  109: result := 'subtract';
110: result := 'decimal';    111: result := 'divide';
112: result := 'f1';         113: result := 'f2';
114: result := 'f3';         115: result := 'f4';
116: result := 'f5';         117: result := 'f6';
118: result := 'f7';         119: result := 'f8';
120: result := 'f9';         121: result := 'f10';
122: result := 'f11';        123: result := 'f12';
124: result := 'f13';        125: result := 'f14';
126: result := 'f15';        127: result := 'f16';
128: result := 'f17';        129: result := 'f18';
130: result := 'f19';        131: result := 'f20';
132: result := 'f21';        133: result := 'f22';
134: result := 'f23';        135: result := 'f24';
136: result := '136';        137: result := '137';
138: result := '138';        139: result := '139';
140: result := '140';        141: result := '141';
142: result := '142';        143: result := '143';
144: result := 'numlock';    145: result := 'scroll';
146: result := '146';        147: result := '147';
148: result := '148';        149: result := '149';
150: result := '150';        151: result := '151';
152: result := '152';        153: result := '153';
154: result := '154';        155: result := '155';
156: result := '156';        157: result := '158';
159: result := '159';        160: result := 'lshift';
161: result := 'rshift';     162: result := 'lcontrol';
163: result := 'rcontrol';   164: result := 'lmenu';
165: result := 'rmenu';      166..191: result := inttostr(b);
192: result := '~';          193..228: result := inttostr(b);
229: result := 'processkey'; 230..245: result := inttostr(b);
246: result := 'attn';       247: result := 'crsel';
248: result := 'exsel';      249: result := 'ereof';
250: result := 'play';       251: result := 'zoom';
252: result := 'noname';     253: result := 'pa1';
254: result := 'oem_clear';  255: result := '255';
end; {end select}
end;

procedure TSysTun.SetFixation;
begin main_fixation := value;
if main_fixation then begin
   CheckMenuItem(app.hfirstmenu, 109, MF_BYCOMMAND or MF_CHECKED);
   end else begin
   CheckMenuItem(app.hfirstmenu, 109, MF_BYCOMMAND or MF_UNCHECKED);
   end;
// SendMessage(app.hwnd, WM_PAINT, 0, 0);
end;

function  TApp.FileImpExp(fn : string; savetrue, rst : boolean) : boolean;
  var
    fp : TextFile;
     s : string;
     r : MyEvent;
     f : longint;
     p : TLVItem;
begin result := false;
FileSetAttr(fn, FaArchive);  AssignFile (fp, fn);

if savetrue then begin
{$I-}
rewrite(fp);
{$I+}  if IOResult <> 0 then begin result := true; exit; end;

             if rst then begin // all / sel
      if efEE then
for f := 0 to EvEdit.ListView.GetItemsCount - 1 do begin
if EvEdit.ListView.isItemSelected(f) then begin
   p.mask :=       LVIF_PARAM;
   p.iItem :=      f;
   p.iSubItem :=   0;
   SendMessage(EvEdit.ListView.hwnd, LVM_GETITEM, 0, Longint(@p));

 if not app.org.w[p.lParam].ex then continue;
 s := app.org.w[p.lParam].ExportString;
      if s = '' then continue;

{$I-}
writeln(fp, s);
{$I+} if IOResult <> 0 then begin result := true; exit; end;

end; {end if}
end; {next f}

             end else begin // all / sel

for f := 1 to max_event do begin
 if not app.org.w[f].ex then continue;
 s := app.org.w[f].ExportString;
      if s = '' then continue;
{$I-}
writeln(fp, s);
{$I+} if IOResult <> 0 then begin result := true; exit; end;
end; {next f}

             end; {end if}  // all / sel

end else begin // sav / ld
{$I-}
 reset(fp);
{$I+}  if IOResult <> 0 then begin
 {$I-}
  rewrite(fp);
  reset(fp);
 {$I+}  if IOResult <> 0 then begin result := true; exit; end;
end; {end if}

if rst then app.org.SelfReset;

while not EOF(fp) do begin
{$I-}
readln(fp, s);
{$I+} if IOResult <> 0 then begin result := true; exit; end;
if s = '' then continue;

if r.ImportString(s)
   then result := true else if app.org.SaveImport(r, hwnd) then begin result := true; break; end;
end; {wend}

   if efEE then PostMessage(hEE, WM_EUREKA, 0, 0);

end; {end if}
{$I-}
closefile(fp);
{$I+} if IOResult <> 0 then result := true;

   app.SetEventsCount;
end;

function  MyOrg.Count : longint; var f : longint; begin result := 0;
for f := 1 to max_event do if app.org.w[f].ex then inc(result); end;

procedure   TApp.MailToAutor;
begin
    if Shell(PCHar(h_dir + 'autor.url'), '', SW_SHOWNORMAL) then
    Shell(PCHar(app_mail + String(tun.reg_str)), '', SW_SHOWNORMAL);
end;
procedure   TApp.JumpToHomePage;
begin
    if Shell(PCHar(h_dir + 'homep.url'), '', SW_SHOWNORMAL) then
    Shell(PCHar(app_www), '', SW_SHOWNORMAL);
end;

procedure   TApp.DelSndFiles;
  var
    f, l        : longint;
    r           : TSearchRec;
    attr, found : integer;
    fnd         : boolean;
    pat_h       : string;
    p1, p2      : string;
    buf         : array[0..MAX_PATH] of char;
begin
Attr := faArchive + faHidden + faSysFile;
pat_h := s_dir + '*.wav';

found := FindFirst(pat_h, attr, r);
     while Found = 0 do begin
fnd := true;
for f := 1 to max_event do begin

if app.org.w[f].ex then begin

p1 := String(CharUpper(PCHar(String(app.org.w[f].filn + '.wav'))));
l := length(r.Name);
 if l > 12 then begin
   GetShortPathName(PCHar(s_dir + r.Name), buf, length(s_dir + r.Name));
   p2 := ExtractFileName(String(CharUpper(buf)));
 end else begin
   p2 := String(CharUpper(PCHar(r.Name)));
 end;

if (app.org.w[f].action = 13) and (p1 = p2) then begin
 fnd := false;
 break;
end; {end if}

end; {end if}
end; {next f}

 if fnd then  DeleteFile(PCHar(s_dir + r.Name));
     Found := FindNext(r);
     end; {wend}
FindClose(r);
end;

procedure   TApp.Md;
begin
CreateDir(application.u_dir);
CreateDir(application.s_dir);
CreateDir(application.m_dir);
CreateDir(application.b_dir);
CreateDir(application.z_dir);
CreateDir(application.h_dir);
CreateDir(application.f_dir);
end;

procedure   TApp.Install;
begin
autorun(true);
end;

function   GetLocalHour(EngTrue : boolean; h : longint) : string;
begin
if EngTrue then begin
  if h > 11 then begin
            if h = 12 then result := am_hour_pm[true] + '12'
            else result := am_hour_pm[true] + inttostr(h - 12);
  end else       begin
            if h = 0 then result := am_hour_pm[false] + '12'
            else result := am_hour_pm[false] + inttostr(h);
                 end; {end if}
end else result := inttofix2str(h);
end;

function    DivRegStr(s : string) : TSelRegStr;
  var
    f : longint;
begin result[0] := ''; result[1] := ''; result[2] := '';
for f := 1 to 24 do begin
if (f mod 2 = 0) then begin
  if f > 12 then begin
    result[2] := result[2] + s[f];
  end else begin
    result[1] := result[1] + s[f];
  end; {end if}
end else begin
  result[0] := result[0] + s[f];
end; {end if}
end; {next f}
end;
function    TApp.CheckRegStr(s : string) : boolean;
  var
     st        : TSelRegStr;
     f, t1, t2 : longint;
begin result := false; if length(s) <> 24 then exit;
st := DivRegStr(s);

t1 := 0; t2 := t1;
for f := 1 to 6 do t1 := t1 + StrToIntDef(st[1][f], 999999);
for f := 1 to 6 do t2 := t2 + StrToIntDef(st[2][f], 999999);

if t1 = 0 then exit;

result := (st[0] = reg_string) and (t1 = t2);
end;

initialization

app.nt := WindowsNT;
app.winpath := GetWinPath;
app.path := DivFullPath(paramstr(0), true);

tfn := app.path + tfn;
stfn := app.winpath + stfn;

u_dir := app.path + u_dir; s_dir := app.path + s_dir;
m_dir := app.path + m_dir; b_dir := app.path + b_dir;
z_dir := app.path + z_dir; h_dir := app.path + h_dir;
f_dir := u_dir + f_dir;

wfn        := u_dir + wfn;
hm_fn      := u_dir + hm_fn;
flhl_fn    := u_dir + flhl_fn;
fl_fn      := u_dir + fl_fn;
fl_tfn     := u_dir + fl_tfn;
nbp_fn     := u_dir + nbp_fn;
nbo_fn     := u_dir + nbo_fn;
icn_fn     := app.path  + icn_fn;

end.
