unit balgor;

interface

        uses windows, myutils, dbg;

             const max_book = 1000; max_peop_mem = 35; max_org_mem = 18;
                   const_book_p_fam1 = 26; const_book_p_fam2 = 27;
                   const_book_p_gr1 = 31; const_book_p_gr2 = 32;
                   const_book_p_sex = 30; const_book_o_gr1 = 15;
                   const_book_o_gr2 = 16;

                   const_book_p_www   = 22;
                   const_book_p_mail  = 23;
                   const_book_o_www   = 10;
                   const_book_o_mail  = 11;
                   const_book_drj     = 33;

type
     TPeopleRecord = object
     a             : array[0..max_peop_mem] of string; // members
     ii            : longint;                          // image index
     ex            : boolean;                          // exist
     public
     procedure     reset;
     function      ExportString : string;
     function      ImportString(s : string; MaxII : longint) : boolean;
     end;

type
     TOrgRecord = object
     a          : array[0..max_org_mem] of string;  // members
     ii         : longint;                          // image index
     ex         : boolean;                          // exist
     public
     procedure  reset;
     function   ExportString : string;                                                
     function   ImportString(s : string; MaxII : longint) : boolean;
     end;

type
     TBoook      = object
     pnb         : array[0..max_book] of TPeopleRecord;
     onb         : array[0..max_book] of TOrgRecord;
     public

     procedure ResetPnb;
     procedure ResetOnb;
     procedure ResetAll;
     function  GetFreePNb : dword;
     function  GetFreeONb : dword;
     function  InsertP(p : TPeopleRecord) : boolean;
     function  InsertO(p : TOrgRecord) : boolean;
     function  FilePnb(fn : string; savetrue, rst : boolean; max_ii : longint) : boolean;
     function  FileOnb(fn : string; savetrue, rst : boolean; max_ii : longint) : boolean;
     function  GetPCount : longint;
     function  GetOCount : longint;
     end;

implementation

procedure TPeopleRecord.reset; var f : longint; begin
 for f := 0 to max_peop_mem do begin a[f] := ''; ii := 0; ex := false; end;
end;
procedure TOrgRecord.reset; var f : longint; begin
 for f := 0 to max_org_mem do begin a[f] := ''; ii := 0; ex := false; end;
end;

procedure TBoook.ResetPnb;
var f : longint; begin for f := 0 to max_book do pnb[f].reset; end;
procedure TBoook.ResetOnb;
var f : longint; begin for f := 0 to max_book do onb[f].reset; end;

procedure TBoook.ResetAll; begin ResetPnb; ResetOnb; end;

function  TBoook.GetFreePNb : dword; var f : longint;
begin result := $FFFFFFFF;
  for f := 0 to max_book do if not pnb[f].ex then begin result := f; break; end;
end;
function  TBoook.GetFreeONb : dword; var f : longint;
begin result := $FFFFFFFF;
  for f := 0 to max_book do if not onb[f].ex then begin result := f; break; end;
end;
function  TPeopleRecord.ExportString;
  var
    f : longint;
begin result := '';
result := inttostr(ii) + #9;
  for f := 0 to max_peop_mem do if f < max_peop_mem then
                       result := result + a[f] + #9
                       else result := result + a[f];
end;
function  TPeopleRecord.ImportString;
  var
    f, max, l, m1, m2, count, tm : longint;
    tmp       : string;
begin result := false; m1 := 0; m2 := 0; tmp := ''; count := 0;
    l := length(s);
if  l < 1 then begin result := true; exit; end;
reset; ex := true;
 for f := 1 to l do begin
  if (s[f] = #9) or (f = l) then begin

   m2    := f;
   if (f = l) and (s[f] <> #9) then inc(m2);
   if m2 > (m1 + 1) then tmp := copy(s, m1 + 1, m2 - m1 - 1);
   m1    := m2;
// . . . . . . . . . . . . . . . . . . . . . . . .
   case count of
   0:   begin tm := strtointdef(tmp, $FFFFFFFF);
        if tm = $FFFFFFFF then begin result := true; exit; end;
        if (tm > maxii) or (tm < 0) then tm := 0;    ii := tm;
   end;
   else
        a[count - 1] := tmp;
   end; {end select}
   tmp := '';
   if count > max_peop_mem then break; inc(count);
// . . . . . . . . . . . . . . . . . . . . . . . .
  end; {end if}
 end; {next f}
end;

function  TOrgRecord.ExportString;
  var
    f : longint;
begin result := '';
result := inttostr(ii) + #9;
  for f := 0 to max_org_mem do if f < max_org_mem then
                       result := result + a[f] + #9
                       else result := result + a[f];
end;
function  TOrgRecord.ImportString;
  var
    f, max, l, m1, m2, count, tm : longint;
    tmp       : string;
begin result := false; m1 := 0; m2 := 0; tmp := ''; count := 0;
    l := length(s);
if  l < 1 then begin result := true; exit; end;
reset; ex := true;
 for f := 1 to l do begin
  if (s[f] = #9) or (f = l) then begin

   m2    := f;
   if (f = l) and (s[f] <> #9) then inc(m2);
   if m2 > (m1 + 1) then tmp := copy(s, m1 + 1, m2 - m1 - 1);
   m1    := m2;

// . . . . . . . . . . . . . . . . . . . . . . . .
   case count of
   0:   begin tm := strtointdef(tmp, $FFFFFFFF);
        if tm = $FFFFFFFF then begin result := true; exit; end;
        if (tm > maxii) or (tm < 0) then tm := 0;    ii := tm;
   end;
   else
        a[count - 1] := tmp;

   end; {end select}
   tmp := '';
   if count > max_org_mem then break; inc(count);
// . . . . . . . . . . . . . . . . . . . . . . . .
  end; {end if}
 end; {next f}
end;

function  TBoook.InsertP(p : TPeopleRecord) : boolean;
  var
    l : longint;
begin result := false;
l := GetFreePNb;
if l = $FFFFFFFF then begin result := true; exit; end;
pnb[l] := p;
end;

function  TBoook.InsertO(p : TOrgRecord) : boolean;
  var
    l : longint;
begin result := false;
l := GetFreeONb;
if l = $FFFFFFFF then begin result := true; exit; end;
onb[l] := p;
end;

function  TBoook.FilePnb(fn : string; savetrue, rst : boolean; max_ii : longint) : boolean;
  var
    fp : TextFile;
     s : string;
     r : TPeopleRecord;
     f : longint;
begin result := false;
FileSetAttr(fn, FaArchive);  AssignFile (fp, fn);

if savetrue then begin
{$I-}
rewrite(fp);
{$I+}  if IOResult <> 0 then begin result := true; exit; end;

for f := 0 to max_book do begin

 if not pnb[f].ex then continue;
 s := pnb[f].ExportString;
      if s = '' then continue;

{$I-}
writeln(fp, s);
{$I+} if IOResult <> 0 then begin result := true; exit; end;
end; {next f}

end else begin
{$I-}
 reset(fp);
{$I+}  if IOResult <> 0 then begin
 {$I-}
  rewrite(fp);
  reset(fp);
 {$I+}  if IOResult <> 0 then begin result := true; exit; end;
end; {end if}

if rst then ResetPnb;

while not EOF(fp) do begin
{$I-}
readln(fp, s);
{$I+} if IOResult <> 0 then begin result := true; exit; end;

if not r.ImportString(s, max_ii)
   then if InsertP(r) then begin result := true; break; end;

end; {wend}

end; {end if}
{$I-}
closefile(fp);
{$I+} if IOResult <> 0 then result := true;
end;

function  TBoook.FileOnb(fn : string; savetrue, rst : boolean; max_ii : longint) : boolean;
  var
    fp : TextFile;
     s : string;
     r : TOrgRecord;
     f : longint;
begin result := false;
FileSetAttr(fn, FaArchive);  AssignFile (fp, fn);

if savetrue then begin
{$I-}
rewrite(fp);
{$I+}  if IOResult <> 0 then begin result := true; exit; end;

for f := 0 to max_book do begin

 if not onb[f].ex then continue;
 s := onb[f].ExportString;
      if s = '' then continue;

{$I-}
writeln(fp, s);
{$I+} if IOResult <> 0 then begin result := true; exit; end;
end; {next f}

end else begin
{$I-}
 reset(fp);
{$I+}  if IOResult <> 0 then begin
 {$I-}
  rewrite(fp);
  reset(fp);
 {$I+}  if IOResult <> 0 then begin result := true; exit; end;
end; {end if}

if rst then ResetOnb;

while not EOF(fp) do begin
{$I-}
readln(fp, s);
{$I+} if IOResult <> 0 then begin result := true; exit; end;
if s = '' then continue;

if r.ImportString(s, max_ii)
   then result := true else if InsertO(r) then begin result := true; break; end;
end; {wend}

end; {end if}
{$I-}
closefile(fp);
{$I+} if IOResult <> 0 then result := true;
end;

function  TBoook.GetPCount : longint; var f : longint;
begin result := 0; for f := 0 to max_book do if pnb[f].ex then inc(result); end;

function  TBoook.GetOCount : longint; var f : longint;
begin result := 0; for f := 0 to max_book do if onb[f].ex then inc(result); end;

end.
