unit flsh;

interface
          uses windows, messages, MyForms, MyFButt, myutils, dbg, myconst, application, actions, algor, myrectrl, richedit, mystring, spkpl;

         const fl_h = 350{374}; fl_w = 474; qd_count = 7; combobox_w = 175{147}; combobox_t = 80; edit_l = 200{172};

{$R menufl.res}

type
      MyFlash = class(TLiteWindow)
      hedit, hcombo,
      hcheck        : THandle;
      ftab          : Boolean;
      qd            : array[0..qd_count] of MyQuad;
      Re            : TRichEdit;
      str_divider   : string;
      protected
                 procedure OnLstCol(var Msg:  TMessage); message      WM_CTLCOLORLISTBOX;
                 procedure OnEditCol(var Msg:  TMessage); message     WM_CTLCOLOREDIT;
                 procedure OnStCol(var Msg:  TMessage); message       WM_CTLCOLORSTATIC;
                 procedure OnSize(Var Msg : TWMSize); message         WM_SIZE;
                 procedure OnMove(Var Msg : TWMMove); message         WM_MOVE;
                 procedure OnGMM(Var Msg : TMessage); message         WM_GETMINMAXINFO;
                 procedure OnClose(Var Msg : TMessage); message       WM_CLOSE;
                 procedure OnActivate(var Msg: TMessage); message     WM_ACTIVATE;
                 procedure OnLMouseUp(Var Msg: TMessage); message     WM_LBUTTONUP;
                 procedure OnCommand(Var Msg: TWMCommand); message    WM_COMMAND;
                 procedure WindowProcedure(var Msg : TMessage); override;
                 procedure CPos;
                 procedure SetStrDivider;
      private

      public
      constructor Create;
      procedure   Close;
      procedure   Full; override;
      procedure   Aftercreate; override;
      procedure   FullQuad;
      procedure   Tab(a : boolean);
      procedure   Show;
      procedure   HotList(SaveTrue : boolean);
      procedure   ShowFile;
      procedure   Act(w : word);
      procedure   Ok;
      procedure   Save;

      procedure   SetAccmulate(b : boolean);
      procedure   ShowDir;
      end;

  var
    Flash : MyFlash;

    process_show : boolean;

implementation

constructor MyFlash.Create;
begin
   inherited Create(hdesktopwindow);
   efFlash := true;
   process_show := false;
end;
procedure MyFlash.OnClose; begin close; end;
procedure MyFlash.Close; begin  efFlash := false; destroy; end;

procedure MyFlash.Full;
  var
    capsiz : integer;
begin inherited;
capsiz := GetSystemMetrics(SM_CYCAPTION);
 WindowClassEx.hInstance := app.hinstance;
 WindowClassEx.hbrBackground := CreateSolidBrush(colr_my);
 WindowClassEx.hIconSm := 0; WindowClassEx.cbSize := SizeOf(WindowClassEx);
self.FLeft := app.stun.flash_left; self.FTop  := app.stun.flash_top;
self.FWidth := app.stun.flash_width; self.FHeight := app.stun.flash_height; 
// self.FWidth  := fl_w; self.FHeight := fl_h + capsiz;
// self.Ftop    := app.sc_h div 2 - self.FHeight div 2;
// self.Fleft   := app.sc_w div 2 - self.FWidth  div 2;
FStyle := {WS_VISIBLE or} WS_SYSMENU or WS_MINIMIZEBOX or WS_SIZEBOX or WS_MAXIMIZEBOX;
// if app.stun.flash_maximize then FStyle := FStyle + WS_MAXIMIZE;
FExStyle := WS_EX_APPWINDOW;
FCaption := PCHar(flash_caption);
WindowClassEx.hIcon := app.hi_clipboard;
end;

procedure MyFlash.FullQuad;
begin
qd[1].r.left   := 1; qd[1].r.top    := 84; qd[1].r.width  := 10; qd[1].r.height := 15; qd[1].enable   := true;
qd[1].a        := 100; // hotlist
qd[2].r.left   := 100; qd[2].r.top    := 35; qd[2].r.width  := 28; qd[2].r.height := 30; qd[2].enable   := true;
qd[2].a        := 103; // close
qd[3].r.left   := 43; qd[3].r.top    := 35; qd[3].r.width  := 28; qd[3].r.height := 30; qd[3].enable   := true;
qd[3].a        := 106; // show dir
qd[4].r.left   := 74; qd[4].r.top    := 35; qd[4].r.width  := 28; qd[4].r.height := 30; qd[4].enable   := true;
qd[4].a        := 102; // show file
qd[5].r.left   := 128; qd[5].r.top    := 35; qd[5].r.width  := 28; qd[5].r.height := 30; qd[5].enable   := true;
qd[5].a        := 101; // help
qd[6].r.left   := 15; qd[6].r.top    := 35; qd[6].r.width  := 28; qd[6].r.height := 30; qd[6].enable   := true;
qd[6].a        := 105; // save
qd[7].r.left   := 155; qd[7].r.top    := 35; qd[7].r.width  := 28; qd[7].r.height := 30; qd[7].enable   := true;
qd[7].a        := 104; // ok
end;

procedure MyFlash.Aftercreate;
begin

if app.stun.flash_maximize then ShowWindow(hwnd, SW_SHOWMAXIMIZED) else ShowWindow(hwnd, SW_SHOWNORMAL);

Re := TRichEdit.Create(hwnd, app.hinstance, edit_l, 0, 448, 250,
WS_VISIBLE or WS_CHILD or ES_SAVESEL or ES_MULTILINE or
ES_AUTOHSCROLL or ES_AUTOVSCROLL or ES_NOHIDESEL or
WS_VSCROLL or WS_HSCROLL or ES_DISABLENOSCROLL
or ES_SELECTIONBAR or ES_SUNKEN,
0, 0);

hedit := Re.Hwnd; // EEditCreate(hwnd, app.hinstance, '', 10, 12, 448, 70{80}, 0, true, true, false, 0);
         SendMessage(hedit, EM_SETBKGNDCOLOR, 0, colr_lyl);
         SendMessage(hedit, EM_EXLIMITTEXT, 0, $FFFFFFF);

//SendMessage(hedit, EM_SETEVENTMASK, 0,
//ENM_CHANGE{ or ENM_CORRECTTEXT or ENM_DROPFILES or ENM_KEYEVENTS or
//ENM_SELCHANGE});

hcombo := ComboBox.Create(hwnd, app.hinstance, '', 12{110}, combobox_t{105}, combobox_w{370}{340}{348}, 204, true, false, false, false, false, true, 0);

SendMessage(hcombo, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));

hcheck := CheckButton.Create(hwnd, app.hinstance, fl_accumulate, 12, 4, 144, 22, false, false);

// fAccmulate := false;
CheckButton.Check[hcheck] := app.tun.flash_accmulate;

EBmpCreate(hwnd, app.hinstance, 'MENUFLASH', 12, 31, true);
//EBmpCreate(hwnd, app.hinstance, 'MD', 10, 312{top}, false);
// EBmpCreate(hwnd, app.hinstance, 'RT', 453, 295{top}, false);  EBmpCreate(hwnd, app.hinstance, 'LT', 0, 295{top}, false);
// EBmpCreate(hwnd, app.hinstance, 'OKBUTTON', 400, 312{top}, false); EBmpCreate(hwnd, app.hinstance, 'CANCELBUTTON', 320, 312{top}, false);
// EBmpCreate(hwnd, app.hinstance, 'QBUTTON', 44, 312{top}, false); EBmpCreate(hwnd, app.hinstance, 'GLAZANABARE', 120, 311{top}, false);
EBmpCreate(hwnd, app.hinstance, 'ASTER', 5, 85{top}, false);
// EBmpCreate(hwnd, app.hinstance, 'BARH', 10, 4{top}, false);
// EBmpCreate(hwnd, app.hinstance, 'BARH', 10, 88{top}, false);

cpos;

FullQuad;

HotList(false);

SetStrDivider;

show;
tab(false);
end;

procedure MyFlash.OnEditCol;  {WM_CTLCOLOREDIT}
begin
msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
{SelectObject(msg.WParam, hf_2);}
if msg.LParam = hedit then begin
SetTextColor(msg.WParam, colr_rd);
end else begin
SetTextColor(msg.WParam, colr_bl);
end; {end if}
SetBkColor(msg.WParam, colr_lyl{my});
msg.Result := hb_lyl{my};
end;

procedure MyFlash.OnLstCol;
begin
msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
SetTextColor(msg.WParam, colr_bl);
// SetBkColor(msg.WParam, colr_lyl{my});
// msg.Result := hb_lyl{my};
end;

procedure MyFlash.OnActivate; {WM_ACTIVATE}
begin
if (LoWord(msg.WParam) = WA_ACTIVE){ or (LoWord(msg.WParam) = WA_CLICKACTIVE)} then begin
tab(ftab);
end; {end if}
end;
procedure MyFlash.Tab;
begin
  ftab := a;
  if ftab then SetFocus(hedit) else SetFocus(hcombo);
end;

procedure MyFlash.WindowProcedure(var Msg : TMessage);
  var
    d : TDecodeKey; ctrl, shift : boolean;
begin

case msg.Msg of
     WM_KEYDOWN: begin
      d := DecodeKey(msg.WParam, msg.LParam);

      ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
      shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;

           msg.result := 0;
      case d.virt of
       VK_RETURN : begin
//       if ctrl then ok(false) else ok(true);
       if ctrl then msg.result := 1; end;
       VK_ESCAPE : begin close; msg.Result := 1; end;
       VK_F1     : begin msg.Result := 1; end;
       VK_TAB    : if ctrl then begin
                   tab(not ftab);
                   msg.Result := 1;
                   end;
      end; {end select}

     end;

     WM_KEYUP: begin

      d := DecodeKey(msg.WParam, msg.LParam);
      ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
      shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;

      case d.virt of
      VK_F2: HotList(true);
      VK_F3: ShowFile;
      VK_RETURN : begin
       if ctrl then begin ok; msg.result := 1;
               end else msg.result := 0;
                  end;
      VK_F1     : act(101); // app.ShowHelp(7);
      VK_F4     : SetAccmulate(not app.tun.flash_accmulate);
      VK_F5     : act(105); // save
      VK_F9     : ShowDir;
      else
          msg.result := 0;
      end; {end select}
               end;
else
    Dispatch(msg);
end; {end select}
end;

procedure MyFlash.Show;
  var
       s : string;

begin if process_show then exit; process_show := true;
// ShowWindow(hwnd, SW_SHOW);
if SendMessage(hedit, EM_CANPASTE, CF_TEXT, 0) <> 0 then begin
if app.tun.flash_accmulate then begin
    if GetWindowTextLength(Re.Hwnd) > 0 then begin
    s := Re.Text + str_divider;
    Re.Text := '';
    SendMessage(hedit, EM_PASTESPECIAL, CF_TEXT, 0);
    Re.Text := s + Re.Text;
       if not app.tun.fmute then SpeakerBeepSync(1000, 10, app.nt);
    end else begin SendMessage(hedit, EM_PASTESPECIAL, CF_TEXT, 0); SetForegroundWindow(hwnd); end; {end if}
end else begin
    Re.Text := '';
    SetForegroundWindow(hwnd);
    SendMessage(hedit, EM_PASTESPECIAL, CF_TEXT, 0);
    Tab(false);
end; {end if accmulate}
end else if not app.tun.fmute then beep; {end if can paste}
process_show := false; end;

procedure MyFlash.HotList;
  var
    s : string;
begin
if savetrue then begin
s := ComboBox.Text[hcombo];
if s = '' then exit;
ComboBox.Insert(hcombo, 0, s);
if ComboBox.FileSave(hcombo, flhl_fn, true, false, 100) then halt;
ComboBox.FileLoad(hcombo, flhl_fn, false, 100);
ComboBox.Text[hcombo] := s;
end else begin
ComboBox.FileLoad(hcombo, flhl_fn, false, 100);
end; {end if}
end;

procedure MyFlash.ShowFile; begin ShellExecute(hwnd, 'open', PCHar(fl_fn), '', u_dir, SW_SHOW{NORMAL}); end;
procedure MyFlash.ShowDir;  begin ShellExecute(hwnd, 'explore'{'open'}, PCHar(f_dir), '', f_dir, SW_SHOW{NORMAL}); end;

procedure MyFlash.OnLMouseUp;
 var
   h, v : integer;
   f    : dword;

 function chpok(a : MyQuad) : boolean;
 begin result := ((a.r.left <= h) and (a.r.left + a.r.width >= h)) and
 ((a.r.top <= v) and (a.r.height + a.r.top >= v)); end;

 procedure vc(a : MyQuad); var dc, hreg : THandle; r : TRect;
 begin  dc := GetDC(hwnd);
  r := MyRectToTRect(a.r);
  hreg :=  CreateRoundRectRgn(r.Left, r.top, r.Right, r.Bottom, 15, 15);
  SelectObject(dc, hreg);
   InvertRgn(dc, hreg);
     Sleep(110);
   InvertRgn(dc, hreg);
  DeleteObject(hreg);
  ReleaseDC(hwnd, dc);
 end;
{WM_LBUTTONUP}
begin
h :=  LOWORD(msg.LParam); v  := HIWORD(msg.LParam);

for f := 0 to qd_count do begin
if chpok(qd[f]) and qd[f].enable then begin
 vc(qd[f]);
 act(qd[f].a);
 break;
end; {end if}
end; {next f}
end;
procedure MyFlash.Act;
begin
case w of
100: HotList(true);
101: app.ShowHelp(7);
102: ShowFile;
103: close;
104: ok;
105: save;
106: ShowDir;
end; {end select}
end;

procedure MyFlash.ok;
var
  fp1      : TextFile; // exists
  fp2      : File;     // tempopary
  s        : string;
  l        : LongInt;
  pt       : Pointer;
   procedure wr; //(st : string);
   begin
    s := s + #13#10;
    l := Length(s);
    pt := PCHar(s);
    {$I-}
     BlockWrite(fp2, pt^, l);
    {$I+}  app.FilErr(IOResult, '[Flash Write Temp File]', false);
   end;

   procedure stc;
     var
       f : dword;
       tmp : string;
   begin
     l := Length(s); tmp := ' ';
     for f := 1 to l do begin
       if s[f] <> #10 then
        tmp := tmp + s[f] else tmp := tmp + s[f] + ' ';
     end; {next f}
     s := tmp;
   end;

begin  if (GetWindowTextLength(hedit) = 0) and (GetWindowTextLength(hcombo) = 0) then exit;
s := '';
SetFileAttributes(PChar(fl_fn), FILE_ATTRIBUTE_ARCHIVE); SetFileAttributes(PChar(fl_tfn), FILE_ATTRIBUTE_ARCHIVE);
assignfile(fp1, fl_fn); assignfile(fp2, fl_tfn);


{$I-}
reset(fp1);
{$I+} if IOResult <> 0 then begin
{$I-}
rewrite(fp1);
reset(fp1);    // for "Read Only access" (no error)
{$I+}  app.FilErr(IOResult, '[Flash Reset Work File]', false);
end; {end if}

{$I-}
rewrite(fp2, 1);
{$I+}  app.FilErr(IOResult, '[Flash Rewrite Temp File]', false);

     l := GetWindowTextLength(hcombo) + 1;
     GetMem(pt, l);
     GetWindowText(hcombo, pt, l);
     s := String(PCHar(pt));
     FreeMem(pt, l);

     s := '=' + inttostr(app.stat.year) + '/'
       + inttofix2str(app.stat.month) + '/'
       + inttofix2str(app.stat.day) + ' - '
       + inttofix2str(app.stat.hour) + ':'
       + inttofix2str(app.stat.minute) + '    > '
       + s;

 wr;

     l := GetWindowTextLength(hedit) + 1;
     GetMem(pt, l);
     GetWindowText(hedit, pt, l);
     s := String(PCHar(pt));
     FreeMem(pt, l);

     stc;

 wr;

while not EOF(fp1) do begin
{$I-}
readln(fp1, s);
{$I+}  app.FilErr(IOResult, '[Flash Read Work File]', false);

 wr;

end; {wend}

{$I-}
closefile(fp1);
{$I+}  app.FilErr(IOResult, '[Flash Close Work File]', false);
{$I-}
closefile(fp2);
{$I+}  app.FilErr(IOResult, '[Flash Close Temp File]', false);

if not DeleteFile(PCHar(fl_fn)) then app.FilErr(1, '[Flash Delete Work File]', false);
if not MoveFile(PCHar(fl_tfn), PCHar(fl_fn)) then app.FilErr(1, '[Flash Move File]', false);

close;
end;



procedure MyFlash.OnStCol;
label lb_end;
begin
SelectObject(msg.WParam, hf_my);
{if (msg.LParam = htime) or (msg.LParam = hyear) then begin
SetBkColor(msg.WParam, colr_my);
SetTextColor(msg.WParam, colr_bl);
goto lb_end;
end; {end if}

//{-!-} SelectObject(msg.WParam, hf_2);
 SetBkColor(msg.WParam, colr_my);
 SetTextColor(msg.WParam, colr_bl);

lb_end:
msg.Result := app.HBRUSH_MY;
end;

procedure   MyFlash.SetAccmulate(b : boolean);
begin
app.tun.flash_accmulate := b;
CheckButton.Check[hcheck] := app.tun.flash_accmulate;
end;

procedure MyFlash.OnCommand;
begin
if msg.Ctl = 0 then exit;

if msg.Ctl = hcheck then SetAccmulate(not app.tun.flash_accmulate);

//case msg.NotifyCode of
//     CBN_SELCHANGE  : begin
//     if msg.Ctl = hper then SetPeriod(ComboBox.Select[hper], false, true);
//     if msg.Ctl = htype then if not CheckButton.Check[hdisp] then SetDisplay(true);
//     if msg.Ctl = hcik  then SetCycle(ComboBox.Select[hcik] + 2, false);
//     if msg.Ctl = hdescript  then SetCat(ComboBox.Select[hdescript], false);
//     if msg.Ctl = hkal then begin
//        if ListBox.Select[hkal] < offset then
//        begin
//        ListBox.Select[hkal] := offset;
//        obj.day := 1;
//        end else obj.day := ListBox.Select[hkal] - offset + 1;
//
// //           dint(obj.day);
//                            end;
//     if msg.Ctl = hmonlist then begin
//     // beep;
//     obj.month := ListBox.Select[hmonlist] + 1;
//     kalset;
//     ListBox.Select[hkal] := offset;
//     obj.day := 1;
//                                end;
//     if msg.Ctl = self.hact then begin
//     SetAction(ComboBox.Select[hact], false);
//     end; {end if}
//     if msg.Ctl = hlistwd then MemWD;
//
//     if (msg.Ctl = hdr10000) or (msg.Ctl = hdr1000)
//     or (msg.Ctl = hdr100) or (msg.Ctl = hdr10)
//     or (msg.Ctl = hdr1) then begin
//     GetDuration;
//     end; {end if}
//
//     if msg.Ctl = hfil then begin
//      if ListBox.Select[hfil] > -1 then
//      obj.filn := ListBox.GetItemText(hfil, ListBox.Select[hfil]) else
//       obj.filn := '';
//     end;
//                      end;
//
//     CBN_EDITCHANGE : begin
//     if msg.Ctl = htype then if GetWindowTextLength(htype) = 0 then SetDisplay(false) else if not CheckButton.Check[hdisp] then SetDisplay(true);
//                      end;
//
//     LBN_DBLCLK     : begin
//     if msg.Ctl = hfil  then CallEdit;
//                      end;
//end; {end select}
end;

procedure MyFlash.Save;
  var
       fp : Text;
       fn : string;
begin

fn := ComboBox.Text[hcombo];
if NeatAndTestFileName(fn) then begin MessageBox(hwnd, PCHar(cmn_str_bad_symbols_in_file_name), PCHar(app_name), MB_OK or MB_ICONSTOP); exit; end;
fn := f_dir + fn + '.txt';

FileSetAttr(fn, faArchive);
AssignFile(fp, fn);

if FileExists(fn) then case MessageBox(hwnd, PCHar(flash_quest1), PCHar(flash_caption), MB_YESNOCANCEL or MB_ICONWARNING or MB_DEFBUTTON2) of
IDCANCEL:  exit;
IDYES:     begin
{$I-}
  ReWrite(fp);
{$I+} if app.FilErr(IOResult, 'Flash Text File [ReWrite1]', false) then exit;
           end;
IDNO:      begin
{$I-}
  Append(fp);
{$I+} if app.FilErr(IOResult, 'Flash Text File [Append]', false) then exit;
{$I-}
  if app.tun.flash_accmulate then Write(fp, str_divider) else WriteLn(fp);
{$I+} app.FilErr(IOResult, 'Flash Text File [Write Divider]', false);
           end;
end {end select} else begin
{$I-}
  ReWrite(fp);
{$I+} if app.FilErr(IOResult, 'Flash Text File [ReWrite2]', false) then exit;
end; {end if}

{$I-}
  Write(fp, Re.Text);
{$I+} app.FilErr(IOResult, 'Flash Text File [Write]', false);

{$I-}
  CloseFile(fp);
{$I+} app.FilErr(IOResult, 'Flash Text File [Close]', false);
close;
end;


procedure MyFlash.OnSize;
begin
 msg.Result := DefWindowProc(hwnd, msg.msg, TMessage(msg).WParam, TMessage(msg).LParam);
 cpos;
end;

procedure MyFlash.OnMove;
begin
 msg.Result := DefWindowProc(hwnd, msg.msg, TMessage(msg).WParam, TMessage(msg).LParam);
 cpos;
end;

procedure MyFlash.CPos;
begin
 MemPosChange;
 app.stun.flash_maximize := isZoomed(hwnd);

if (not app.stun.flash_maximize) and (not isIconic(hwnd)) then begin
 app.stun.flash_width := FWidth;
 app.stun.flash_height := FHeight;
 app.stun.flash_top := FTop;
 app.stun.flash_left := FLeft;
end; {end if}

SetWindowPos(hcombo, hcombo, 0, 0, combobox_w, FCHeight - 15 - combobox_t, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOZORDER);
SetWindowPos(hedit, hedit, 0, 0, FCWidth - 1 - edit_l, FCHeight - 1, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOZORDER);

end;

procedure MyFlash.OnGMM; {WM_GETMINMAXINFO}
  var
    p : PMINMAXINFO;
begin
p := Pointer(msg.LParam);
  p^.ptMinTrackSize.x := 300;
  p^.ptMinTrackSize.y := 140;
msg.Result := 0;
end;

procedure MyFlash.SetStrDivider;
  var
       fn : string;
       fp : file;
       p  : pointer;
       fs, old_file_mode : Longint;
begin
str_divider := #13#10#13#10;
fn := application.u_dir + 'flash_str_divider.txt';
if not(FileExists(fn)) then exit;
old_file_mode := FileMode; FileMode := 0; p := nil;
AssignFile(fp, fn);
{$I-}
ReSet(fp, 1);
{$I+} if IOResult = 0 then begin
fs := FileSize(fp);
GetMem(p, fs);
{$I-}
BlockRead(fp, p^, fs);
{$I+} if IOResult = 0 then begin
str_divider := String(PCHar(p)); SetLength(str_divider, fs);
end; {end if BlockRead Ok}
{$I-}
CloseFile(fp);
{$I+} IOResult;
end; {end if ReSet Ok}
if p <> nil then FreeMem(p);
FileMode := old_file_mode;
end;

end.
