unit msgwin;

interface

uses algor, myfbutt, mythread, myforms, myconst, application, myutils, windows, messages, dbg, actions;

     const
          mdlg_w = 555;
          mdlg_h = 320;

type
    TDt  = class(TThread)
    term : boolean;
    protected
         function    ThreadProcedure: DWord; override;
    end;


    const max_event = 1000;
          pmax_event : word = max_event; // for use in all units

type
    MyMesWin = class(TLiteWindow)

    fimagen : boolean;
    hmsglist,
    himg
     : THandle;
    qd, qc, qh      : MyQuad;
    protected
       procedure    OnClose(Var Msg : TMessage); message WM_CLOSE;
       procedure    OnLbu(Var Msg : TMessage); message WM_LBUTTONDOWN;
       procedure    OnEUREKA(Var Msg : TMessage); message WM_EUREKA;
       procedure    SetImageN(Value : boolean);
       procedure    WindowProcedure(var Msg : TMessage); override;       
    private
    public

    constructor Create;
    procedure   Full; override;
    procedure   AfterCreate; override;
    procedure   Close;
    property    imagen : boolean read fimagen write SetImageN default true;
    function chpok(left, top : integer) : boolean;
    procedure ok;
    end;

  var
    MesWin : MyMesWin;
    Dt     : TDT;

implementation

function MyMesWin.chpok(left, top : integer) : boolean;
 procedure vc(a : MyQuad); var dc, hreg : THandle; r : TRect;
 begin  dc := GetDC(hwnd);
  r := MyRectToTRect(a.r);
  hreg :=  CreateRoundRectRgn(r.Left, r.top, r.Right, r.Bottom, 15, 15);
  SelectObject(dc, hreg);
   InvertRgn(dc, hreg);
     Sleep(110);
   InvertRgn(dc, hreg);
  DeleteObject(hreg);
  ReleaseDC(hwnd, dc);
 end;
begin result := ((qd.r.left <= left) and (qd.r.left + qd.r.width >= left)) and
((qd.r.top <= top) and (qd.r.height + qd.r.top >= top));

if result then begin
 vc(qd);
 ok;
 exit;
end; {end if}

result := ((qc.r.left <= left) and (qc.r.left + qc.r.width >= left)) and
((qc.r.top <= top) and (qc.r.height + qc.r.top >= top));

if result then begin
 vc(qc);
 close;
 exit;
end; {end if}

result := ((qh.r.left <= left) and (qh.r.left + qh.r.width >= left)) and
((qh.r.top <= top) and (qh.r.height + qh.r.top >= top));

if result then begin
 vc(qh);
        app.ShowHelp(3);
 exit;
end; {end if}

end;

constructor MyMesWin.create; begin efMsw := true; inherited create(hDesktopWindow); end;

procedure MyMesWin.Full;
  var
    capsiz : integer;
begin inherited;
capsiz := GetSystemMetrics(SM_CYCAPTION);
 WindowClassEx.hInstance := app.hinstance;
 WindowClassEx.hbrBackground := CreateSolidBrush(colr_my);
 WindowClassEx.cbSize := SizeOf(WindowClassEx);
FWidth  := mdlg_w;  FHeight := mdlg_h + capsiz;
Ftop    := app.sc_h div 2 - FHeight div 2;
Fleft   := app.sc_w div 2 - FWidth  div 2;
FStyle := WS_VISIBLE or {WS_ICONIC or} WS_SYSMENU or WS_MINIMIZEBOX;
FExStyle := WS_EX_APPWINDOW; FCaption := PCHar(msw_capt_capt);
WindowClassEx.hIcon := app.hi_exclamation;
end;

procedure MyMesWin.AfterCreate;
  var
    f     : dword;
begin
  hmsglist := ListBox.Create(hwnd, app.hinstance, '', 10, 10, 440, 304, false, false, false, true, false, false, true);
              SendMessage(hmsglist, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));
              SendMessage(hmsglist, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));

     for f := 1 to pmax_his do begin
       if app.org.hst[f] <> '' then begin
        ListBox.Add(hmsglist, app.org.hst[f]);
       end; {end if}
     end; {next f}
         SendMessage(hmsglist, LB_SETHORIZONTALEXTENT, 2400, 0);
  himg := 0;
  EBmpCreate(hwnd, app.hinstance, 'OKBTN', 460, 280, false);
  EBmpCreate(hwnd, app.hinstance, 'CNBTN', 460, 250, false);
  EBmpCreate(hwnd, app.hinstance, 'HLBTN', 460, 10, false);
//      app.org.PrepareHistory;
  dt := TDt.Create;
  ResumeThread(dt.ThrHandle);
qd.r.left := 459; qd.r.top := 279; qd.r.width := 81; qd.r.height := 28;
qc.r.left := 459; qc.r.top := 250; qc.r.width := 81; qc.r.height := 20;
qh.r.left := 459; qh.r.top := 10; qh.r.width := 81; qh.r.height := 20;
SetFocus(hmsglist);
end;

procedure MyMesWin.OnClose; begin close; end;
procedure MyMesWin.Close;
begin
// DeleteObject(WindowClassEx.hbrBackground);
 StopSnd;
 efMsw := false;
 dt.term := true;
 TerminateThread(dt.ThrHandle, 0);
 DestroyWindow(MesWin.himg); MesWin.himg := 0;
 destroy;
end;

procedure MyMesWin.OnLbu;
begin     chpok(LOWORD(msg.lparam),HIWORD(msg.lparam));
     msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam); end;

procedure MyMesWin.SetImageN(Value : boolean);
begin
fimagen := value;
if himg <> 0 then DestroyWindow(himg);
 if fimagen then
  himg := EBmpCreate(hwnd, app.hinstance, 'AB1'{'ASTERBIG'}, 461, 93{top}, false)
 else
  himg := EBmpCreate(hwnd, app.hinstance, 'AB2', 462, 93{top}, false);
//  UpdateWindow(hwnd);
end;

function TDt.ThreadProcedure: DWord;
begin
 term := false;
 SetThreadPriority(ThrHandle, THREAD_PRIORITY_LOWEST);
 while not term do begin
   sleep(400);
     FlashWindow(MesWin.hwnd, true);
     SendMessage(MesWin.hwnd, WM_EUREKA, 0, 0);
// if (efExit and (not isIconic(MesWin.hwnd))) then SetForegroundWindow(EndWindows.hbut) else SetForegroundWindow(hMesWin);
 end; {wend}
   FlashWindow(MesWin.hwnd, false);
 ExitThread(0); self.Destroy;
end;

procedure MyMesWin.OnEUREKA; begin MesWin.imagen := not MesWin.imagen; end;

procedure MyMesWin.ok;
begin
   app.org.ResetHistory; //ListBox.Clear(hmsglist);
   app.fNeedDltOld := true;  close;
end;

procedure MyMesWin.WindowProcedure(var Msg : TMessage);
  var d : TDecodeKey; ctrl, shift : boolean;
begin
case msg.Msg of
     WM_KEYDOWN: begin
      d := DecodeKey(msg.WParam, msg.LParam);
       ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
       shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;
      case d.virt of
       VK_RETURN : msg.result := 1;
       VK_ESCAPE : msg.Result := 1;
       9         : msg.result := 1;
      else
          msg.result := 0;
      end; {end select}

     end;
     WM_KEYUP: begin
      d := DecodeKey(msg.WParam, msg.LParam);
       ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
       shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;
      case d.virt of
           8         : if ctrl then close;
           9         : SetFocus(hmsglist);
           VK_RETURN : if ctrl then ok;
           VK_F1     : app.ShowHelp(3);
      else
          msg.result := 0;
      end; {end select d.virt}
     end; {ku}
else
    Dispatch(msg);
end; {end select msg.msg}
end;

end.
