unit MyCC;

interface

uses  windows, messages, myutils, commctrl, dbg;


type
    MyTreeView = object


    public

       function  BaseCreate(hwnd, happ: THandle; left, top, width, height: integer
                 ) : THandle;
    end;
    TTreeView = class(TObject)
    fhwnd, fhapp                 : THandle;

    protected

    private

    public
    function   CreateWnd(hwnd, happ : THandle;
    left, top, width, height : integer;
    Lines, RootLines, Buttons, AlwShowSel, YesEditLab : boolean) : THandle;
    function   AssociateImageList(hil : THandle; NormalTrueStateFalse : boolean) : boolean;
    function   JustInsertItem(HParent : Longint;
    PosleTrue, y_img, y_selimg, y_txt, bold : boolean;
    txt : string; param : dword;
    nii, sii : dword
    ) : longint;

    procedure  SetIndent(i : longint);
    procedure  ExpandItem(OneCollaps2Collapsandreset3Expand4Toggle : byte; hitem : longint);
    end;

type
    TListView = class(TObject)
    fleft, ftop, fwidth, fheight : integer;

    protected
     function  GetColumnText(i : longint) : string;
     procedure SetColumnText(i : longint; Value : string);
     function  GetViewType : byte;
     procedure SetViewType(Value : byte);
    private
    fhwnd, fhapp, fhmenu         : THandle;
    public
     property  hwnd : THandle read fhwnd;
     function  Crt(hwnd, happ: THandle; left, top, width, height: integer;
               st, est : dword; hmenu : THandle; param : Pointer) : THandle;
     function  CrtTxtTbl(hwnd, happ: THandle; left, top, width, height: integer) : THandle;
     function  InsertColumn(i, isi, width : longint; s : string) : longint;
     procedure Clear;
     function  TxtTblInsertItem(iindex, siindex : dword; s : string; param : dword) : longint;
     function  InsertItem(iindex, siindex, imageindex : longint; s : string; param : dword) : longint;
     function  InsertTextCallbackItem(iindex, siindex, imageindex : longint; param : dword; yesimg : boolean) : longint;
     function  GetItemsCount : longint;
     function  GetSelectedCount : longint;
     function  GetFocusedItemIndex : longint;
     function  GetFocusedItem(i : longint) : TLVItem;
     procedure SetFutureItemsCount(i : longint);
 {     procedure SelectItem(Value : boolean; i : longint);}
     function  isItemSelected(i : longint) : boolean;
     procedure SelectAll;
     procedure AssociateImageList(hil : THandle; NormalTrueSmallFalse : boolean);
     property  ColumnText[i : longint] : string read GetColumnText write SetColumnText;
     property  ViewType : byte read GetViewType write SetViewType;
     procedure SetFocusedItem(i : longint; scrolltoitem : boolean);
    end;

type
     TMultiPage = class(TObject)
     fhwnd : THandle;

     protected
     function  GetCurSel : longint;
     procedure SetCurSel(Value : longint);
     private

     public
     function  ECreate(hwnd, happ: THandle; left, top, width, height: integer): THandle;
     function  InsertTextItem(ii : longint; s : string) : longint;
     property  Sel : longint read GetCurSel write SetCurSel;
     end;

type
     TImageList = class(TObject)
     fhwnd, fhapp                 : THandle;

     protected

     private

     public
     constructor Create(happ : THandle; cx, cy, cInitial, cGrow : integer; flags : uint);
     function    AddFromResouce(s : string) : boolean;
     function    AddBitmapHandle(h : THandle) : boolean;
     function    Count : longint;
     destructor  Destroy;
     end;

  var
    TreeView : MyTreeView;

implementation

function TListView.Crt(hwnd, happ: THandle; left, top, width, height: integer;
              st, est : dword; hmenu : THandle; param : Pointer) : THandle;
begin {est: WS_EX_CLIENTEDGE} {st: LVS_AUTOARRANGE or WS_CHILD or WS_VISIBLE or LVS_REPORT} {LVS_EX_ONECLICKACTIVATE gluki v 2000}
  result := CreateWindowEx(
  est, WC_LISTVIEW, '', st, left, top, width, height,
  hwnd, hmenu, happ, param);
  fhwnd := result; fhapp := happ; fhmenu := hmenu;
  fleft := left; ftop := top; fwidth := width; fheight := height;
end;
function TListView.CrtTxtTbl(hwnd, happ: THandle; left, top, width, height: integer) : THandle;
begin result := CreateWindowEx(WS_EX_CLIENTEDGE, WC_LISTVIEW, '',
  LVS_AUTOARRANGE or WS_CHILD or WS_VISIBLE or LVS_REPORT or
  LVS_SHOWSELALWAYS,
  left, top, width, height, hwnd, 0, happ, nil); fhwnd := result;
  fhapp := happ; fhmenu := 0; fleft := left; ftop := top;
  fwidth := width; fheight := height;
end;
procedure TListView.Clear; begin ListView_DeleteAllItems(fhwnd); end;

function  TListView.TxtTblInsertItem(iindex, siindex : dword; s : string; param : dword) : longint;
  var
    l : TLVItem;
begin
   l.iSubItem := siindex;
   l.iItem := iindex;
   l.lParam := param;
   l.cchTextMax := 0;
   l.pszText := PCHar(s);
   l.state := 0;
   l.stateMask := 0;
   l.iImage := 0;
   l.mask := LVIF_TEXT or LVIF_PARAM or LVIF_DI_SETITEM;
  if siindex > 0 then
  result := SendMessage(fhwnd, LVM_SETITEMTEXT, iindex, Longint(@l))
  else
  result := SendMessage(fhwnd, LVM_INSERTITEM, 0, Longint(@l));
{if siindex <> 10 then exit;
  l.iSubItem := 10;
  SendMessage(fhwnd, LVM_INSERTITEM, iindex, Longint(@l));
 MessageBox(0, l.pszText, '', 0);}
end;
function  TListView.InsertItem(iindex, siindex, imageindex : longint; s : string; param : dword) : longint;
  var
    l : TLVItem;
begin
   l.iSubItem := siindex;
   l.iItem := iindex;
   l.lParam := param;
   l.cchTextMax := 0;
   l.pszText := PCHar(s);
   l.state := 0;
   l.stateMask := 0;
   l.iImage := imageindex;
   l.mask := LVIF_TEXT or LVIF_PARAM or LVIF_DI_SETITEM or LVIF_IMAGE;
  if siindex > 0 then
  result := SendMessage(fhwnd, LVM_SETITEMTEXT, iindex, Longint(@l))
  else
  result := SendMessage(fhwnd, LVM_INSERTITEM, 0, Longint(@l));
end;

function  TListView.InsertTextCallbackItem(iindex, siindex, imageindex : longint; param : dword; yesimg : boolean) : longint;
  var
    l : TLVItem;
begin
   l.iSubItem := siindex;            l.iItem := iindex;
   l.lParam := param;                l.cchTextMax := 0;
   l.pszText := LPSTR_TEXTCALLBACK;  l.state := 0;
   l.stateMask := 0;                 l.iImage := imageindex;
   l.mask := LVIF_TEXT or LVIF_PARAM;
   if yesimg then l.mask := l.mask or LVIF_IMAGE;
  if siindex > 0 then
  result := SendMessage(fhwnd, LVM_SETITEMTEXT, iindex, Longint(@l))
  else
  result := SendMessage(fhwnd, LVM_INSERTITEM, 0, Longint(@l));
end;

function  TListView.GetItemsCount : longint; begin result := SendMessage(fhwnd, LVM_GETITEMCOUNT, 0, 0); end;
function  TListView.GetSelectedCount : longint; begin result := SendMessage(fhwnd, LVM_GETSELECTEDCOUNT, 0, 0); end;
function  TListView.GetFocusedItemIndex : longint;
  var     l, f : longint;
begin l := GetItemsCount; result := -1;
if l > 0 then
  for f := 0 to l - 1 do begin
     if (SendMessage(fhwnd, LVM_GETITEMSTATE, f, LVIS_FOCUSED) <> 0) then begin
       result := f; break;
     end; {end if}
  end; {next f}
end;
function  TListView.GetFocusedItem(i : longint) : TLVItem;
begin
result.iItem := i;
result.iSubItem := 0;
result.mask := LVIF_PARAM;
SendMessage(fhwnd, LVM_GETITEM, 0, (longint(@result)));
end;
function  TListView.isItemSelected(i : longint) : boolean;
begin result := ListView_GetItemState(fhwnd, i, LVIS_SELECTED) <> 0; end;
{procedure TListView.SelectItem(Value : boolean; i : longint);
begin
end;}
procedure TListView.SetFutureItemsCount(i : longint); begin SendMessage(fhwnd, LVM_INSERTITEM, i, 0); end;

procedure TListView.AssociateImageList(hil : THandle; NormalTrueSmallFalse : boolean);
  var  tmp : dword;
begin  if NormalTrueSmallFalse then tmp := LVSIL_NORMAL  else tmp := LVSIL_SMALL;
SendMessage(fhwnd, LVM_SETIMAGELIST, tmp, Longint(hil)); end;

function TListView.InsertColumn(i, isi, width : longint; s : string) : longint;
  var
    LC  : TLVColumn;
begin
 lc.mask       := LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH;
 lc.fmt        := 0;
 lc.cx         := width;
 lc.pszText    := PCHar(s);
 lc.cchTextMax := 0;
 lc.iSubItem   := isi;
 result        := SendMessage(fhwnd, LVM_INSERTCOLUMN, i, Longint(@lc));
// commctrl.lvs_ex
end;

function  TListView.GetColumnText(i : longint) : string;
  var
    lc : TLVColumn;
begin result := '';
 lc.mask     := LVCF_TEXT;
 if Boolean(SendMessage(fhwnd, LVM_GETCOLUMN, i, Longint(@lc))) then
    result      := String(PCHar(lc.pszText));
end;
procedure TListView.SetColumnText(i : longint; Value : string);
  var
    lc : TLVColumn;
begin
 lc.mask     := LVCF_TEXT;
 lc.pszText  := PCHar(value);
 SendMessage(fhwnd, LVM_SETCOLUMN, i, Longint(@lc));
end;
function  TListView.GetViewType : byte;
  var
    tmp : longint;
begin result := 0;
tmp := GetWindowLong(hwnd, GWL_STYLE) and not LVS_TYPEMASK;
if  (tmp and LVS_ICON) <> 0 then result := 0;
if  (tmp and LVS_SMALLICON) <> 0 then result := 1;
if  (tmp and LVS_LIST) <> 0 then result := 2;
if  (tmp and LVS_REPORT) <> 0 then result := 3;
end;
procedure TListView.SetViewType(Value : byte);
  var
    tmp : longint;
begin tmp := 0;
case Value of
0:   tmp := LVS_ICON;
1:   tmp := LVS_SMALLICON;
2:   tmp := LVS_LIST;
3:   tmp := LVS_REPORT;
end; {end select}
SetWindowLong(hwnd, GWL_STYLE, (GetWindowLong(hwnd, GWL_STYLE) and not LVS_TYPEMASK) or tmp);
end;

procedure TListView.SetFocusedItem(i : longint; scrolltoitem : boolean);
begin
ListView_SetItemState(fhwnd, i, LVIS_FOCUSED or LVIS_SELECTED, $FFFFFFFF);
if scrolltoitem then ListView_EnsureVisible(fhwnd, i, false);
end;

procedure TListView.SelectAll;
  var
    f, lvcount : dword;
begin
  lvcount := GetItemsCount;
 if lvcount > 0 then
  for f := 0 to lvcount - 1 do begin
    ListView_SetItemState(hwnd, f, LVIS_SELECTED, $FFFFFFFF)
  end; {next f}
end;

// . . . . . . . . . . . . . . . . . . . . . . . . . . . .

function TMultiPage.ECreate(hwnd, happ: THandle; left, top, width, height: integer): THandle;
begin
result := CreateWindowEx(
0,
WC_TABCONTROL,
'',
{TCS_MULTILINE or}{TCS_BUTTONS or TCS_FOCUSONBUTTONDOWN or }WS_CHILD or WS_VISIBLE,
left, top, width, height, hwnd, 0, happ, nil
); fhwnd := result;
end;

function TMultiPage.InsertTextItem(ii : longint; s : string) : longint;
  var
    p : TTCitem;
begin
p.mask        := TCIF_TEXT;
p.lpReserved1 := 0;
p.lpReserved2 := 0;
p.pszText     := PCHar(s);
p.cchTextMax  := 0;
p.iImage      := 0;
p.lParam      := 0;
SendMessage(fhwnd, TCM_INSERTITEM, 0, Longint(@p));
end;

function  TMultiPage.GetCurSel : longint;
begin result := SendMessage(fhwnd, TCM_GETCURSEL, 0, 0); end;
procedure TMultiPage.SetCurSel(Value : longint);
begin SendMessage(fhwnd, TCM_SETCURSEL, Value, 0); end;

// . . . . . . . . . . . . . . . . . . . . . . . . . . . .

function MyTreeView.BaseCreate;
begin result := CreateWindowEx(
WS_EX_CLIENTEDGE,
WC_TREEVIEW,
'',
TVS_HASLINES or TVS_LINESATROOT or TVS_HASBUTTONS or TVS_SHOWSELALWAYS or WS_CHILD or WS_VISIBLE,
left, top, width, height, hwnd, 0, happ, nil
);end;

function  TTreeView.CreateWnd(hwnd, happ : THandle;
left, top, width, height : integer;
Lines, RootLines, Buttons, AlwShowSel, YesEditLab : boolean) : THandle;
  var
    tmp : dword;
begin
tmp := WS_CHILD or WS_VISIBLE;
if Lines then tmp := tmp or TVS_HASLINES;
if RootLines then tmp := tmp or TVS_LINESATROOT;
if Buttons then tmp := tmp or TVS_HASBUTTONS;
if AlwShowSel then tmp := tmp or TVS_SHOWSELALWAYS;
result := CreateWindowEx(
 WS_EX_CLIENTEDGE,
 WC_TREEVIEW,
 '',
 tmp,
 left, top, width, height, hwnd, 0, happ, nil
);
fhwnd := result;
fhapp := happ;
end;

function  TTreeView.AssociateImageList(hil : THandle; NormalTrueStateFalse : boolean) : boolean;
  var
    tmp : dword;
begin
if NormalTrueStateFalse then tmp := TVSIL_NORMAL else tmp := TVSIL_STATE;
result := SendMessage(fhwnd, TVM_SETIMAGELIST, tmp, Longint(hil)) <> 0;
end;

function TTreeView.JustInsertItem(HParent : Longint;
PosleTrue, y_img, y_selimg, y_txt, bold : boolean;
txt : string; param : dword;
nii, sii : dword
) : longint;
  var
    li  : TTVItem;
    ili : TTVInsertstruct;

begin
   li.mask                  := TVIF_PARAM;
   if y_img    then li.mask := li.mask or TVIF_IMAGE;
   if y_selimg then li.mask := li.mask or TVIF_SELECTEDIMAGE;
   if y_txt    then li.mask := li.mask or TVIF_TEXT;
   li.hItem                 := HTreeItem(0);
   if bold then begin li.state := TVIS_BOLD; li.stateMask := TVIS_BOLD; li.mask := li.mask or TVIF_STATE;
   end else begin li.state := 0; li.stateMask := 0; end;
   li.pszText               := PCHar(txt);   li.cchTextMax            := 0;
   li.iImage                := nii;  li.iSelectedImage        := sii;
   li.cChildren             := 0;
   li.lParam                := param;

  ili.hParent               := HTreeItem(HParent);
  if PosleTrue then
  ili.hInsertAfter := TVI_LAST else ili.hInsertAfter := TVI_FIRST;
  ili.item                  := li;

  result := SendMessage(fhwnd, TVM_INSERTITEM, 0, Longint(@ili));
end;

procedure  TTreeView.SetIndent(i : longint); begin  SendMessage(fhwnd, TVM_SETINDENT, i, 0); end;

procedure  TTreeView.ExpandItem(OneCollaps2Collapsandreset3Expand4Toggle : byte; hitem : longint);
  var
    tmp : dword;
begin
case OneCollaps2Collapsandreset3Expand4Toggle of
1: tmp := TVE_COLLAPSE;
2: tmp := TVE_COLLAPSERESET or TVE_COLLAPSE;
3: tmp := TVE_EXPAND;
4: tmp := TVE_TOGGLE;
end; {end select}
   SendMessage(fhwnd, TVM_EXPAND, tmp, hitem);
end;

// . . . . . . . . . . . . . . . . . . . . . . . . . . . .

constructor TImageList.Create(happ : THandle; cx, cy, cInitial, cGrow : integer; flags : uint);
begin
inherited Create;
  fhwnd := ImageList_Create(cx, cy, flags, cinitial, cgrow);
  fhapp := happ;
end;

destructor  TImageList.Destroy;
begin ImageList_Destroy(fhwnd);
inherited;
end;

function    TImageList.AddFromResouce(s : string) : boolean;
  var
    h : THandle;
begin
h := LoadBitmap(fhapp, PCHar(s));
result := ImageList_Add(fhwnd, h, 0) = -1;
end;
function    TImageList.AddBitmapHandle(h : THandle) : boolean;
begin result := ImageList_Add(fhwnd, h, 0) = -1; end;

function    TImageList.Count : longint;
begin result := ImageList_GetImageCount(fhwnd); end;

initialization
   commctrl.InitCommonControls;

finalization

end.
