unit mypan;

interface
          uses windows, messages, myforms, myutils;

type
      MyPanel = class(TLiteWindow)
      ffl, fft, ffw, ffh : integer;
      ffhapp : THandle;
      ffvis  : boolean;
      ffcol, ffstcol  : dword;
      ffhstfont : THandle;
      protected
           procedure   OnCommand(Var Msg: TMessage); message WM_COMMAND;
           procedure   OnStCol(var Msg:  TMessage); message  WM_CTLCOLORSTATIC;
           procedure   OnLstCol(var Msg:  TMessage); message WM_CTLCOLORLISTBOX;
           procedure   OnBtnCol(var Msg:  TMessage); message WM_CTLCOLORBTN;
      private
      public
           constructor Create(hwnd, happ : THandle; lt, tp, wh, ht : integer; color : dword; vis : boolean);
           procedure   full; override;
           procedure   SetStaticColorAndFont(hstfont : THandle; stcolor : dword);
      end;

implementation

constructor MyPanel.Create;
begin
ffl  := lt;
fft  := tp;
ffw  := wh;
ffh  := ht;
ffhapp := happ;
ffvis := vis;
ffcol := color;
ffhstfont := 0;
inherited Create(hwnd);
end;

procedure MyPanel.full; {CreateWindow}
begin inherited;
self.FLeft := ffl; self.FTop  := fft;
self.FWidth := ffw; self.FHeight := ffh;
self.Caption := '';
self.FStyle   := WS_CHILD;
if ffvis then FStyle := FStyle or WS_VISIBLE;
self.FExStyle := WS_EX_OVERLAPPEDWINDOW; WindowClassEx.hInstance := ffhapp;
if ffcol <> 0 then
 WindowClassEx.hbrBackground := CreateSolidBrush(ffcol);
end;

procedure MyPanel.OnCommand;
begin
 msg.result := SendMessage(hwndparent, msg.Msg, msg.WParam, msg.LParam);
end;

procedure MyPanel.OnStCol;
begin
if ffhstfont <> 0 then begin
 SelectObject(msg.WParam, ffhstfont);
 SetBkColor(msg.WParam, ffcol);
 SetTextColor(msg.WParam, ffstcol);
 msg.Result := WindowClassEx.hbrBackground;
end else begin
 msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
end; {end if}
end;
procedure MyPanel.OnBtnCol(var Msg:  TMessage);
begin
if ffhstfont <> 0 then begin
 SelectObject(msg.WParam, ffhstfont);
 msg.Result := WindowClassEx.hbrBackground;
end else begin
 msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
end; {end if}
end;

procedure MyPanel.SetStaticColorAndFont(hstfont : THandle; stcolor : dword);
begin
ffstcol   := stcolor;
ffhstfont := hstfont;
end;

procedure MyPanel.OnLstCol(var Msg:  TMessage);
begin
 msg.result := SendMessage(hwndparent, msg.Msg, msg.WParam, msg.LParam);
end;

end.
