unit noteb;

interface
          uses windows, messages, myforms, MyCC, commctrl, myutils, dbg,
               application, balgor, myconst, dlgpeopl, dlgorg, cdialogs, actions;

           const
               book_w : integer = 550;
               book_h : integer = 420;
               book_tv_w : integer = 234{234};

type
     MyNoteBook = class(TLiteWindow)

         ListView         : TListView;
         TreeView         : TTreeView;
         ftab             : boolean;

         ListViewIl       : TImageList;
         ListViewIlS      : TImageList;
         lvilokloaded     : boolean;

         TreeViewIl       : TImageList;

         book             : TBoook;

         Fams             : array[0..MAX_BOOK * 2] of string;
         pgr              : array[0..MAX_BOOK * 2] of string;
         psx              : array[0..MAX_BOOK]     of string;
         ogr              : array[0..MAX_BOOK * 2] of string;

         H_PEOP_FAM, H_PEOP_GR, H_PEOP_SEX, H_ORG_GR :
                          longint;

     startaction          : byte;
     memkeysel            : dword;
     memclickstr          : string;

     fpeoptrue            : boolean;
     fview                : longint;
     find_str             : string;

     protected
         procedure   OnGMM  (Var Msg   : TMessage); message    WM_GETMINMAXINFO;
         procedure   OnSize(Var Msg : TWMSize); message        WM_SIZE;
         procedure   OnMove(Var Msg : TWMMove); message        WM_MOVE;
         procedure   OnNotify(Var Msg : TWMNotify); message    WM_NOTIFY;
         procedure   OnEUREKA(Var Msg : TMessage); message     WM_EUREKA;
         procedure   OnClose(Var Msg : TMessage); message      WM_CLOSE;
         procedure   SetTab(Value : boolean);
         procedure   WindowProcedure(var Msg : TMessage); override;
     private

     public
         function    MaxMems : longint;
         constructor Create(a : byte);
         procedure   full; override;
         procedure   aftercreate; override;
         procedure   CPos;

         procedure   LoadFamilys;
         procedure   LoadFirms;

         procedure   BookFileP(savetrue : boolean);
         procedure   BookFileO(savetrue : boolean);

         function    LoadLvIl : boolean;

         procedure   ClearColumnsName;
         procedure   LoadColumnNameForPeoples;
         procedure   LoadColumnNameForOrg;

         procedure   Act(n : longint; s : string);
         procedure   SetLVView(b : byte);
         procedure   SetView(v : longint; s : string; old : boolean);

         property    Tab : boolean read ftab write SetTab;
         procedure   Close;


         procedure   ShowDlgPeople(n : longint; newpeople : boolean);
         procedure   ShowDlgOrg(n : longint; neworg : boolean);
         function    NowPeople : boolean;
         function    NowOrg : boolean;
         procedure   DelPeople(n : longint);
         procedure   DelOrg(n : longint);
         procedure   Del;
         procedure   SaveAs;
         procedure   SaveSel;
         procedure   ChangeAll;
         procedure   PlusFile;
         procedure   MailTo;
         procedure   WWW;
         procedure   Info; 
     end;

  var
    NoteBook : MyNoteBook;

implementation

function    MyNoteBook.MaxMems : longint; begin if max_peop_mem > max_org_mem then result := max_peop_mem else result := max_org_mem; end;

constructor MyNoteBook.Create;
begin
efBook := true;
efDlgPeople := false;
startaction := a;
inherited Create(hDesktopWindow);
end;

procedure  MyNoteBook.full;
begin inherited;
FLeft    := app.stun.book_left; FTop  := app.stun.book_top;
FWidth   := app.stun.book_width; FHeight := app.stun.book_height;
Caption  := book_caption;
FStyle   := WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_SIZEBOX;
FExStyle := 0; WindowClassEx.hInstance := app.hinstance;
WindowClassEx.hIcon := app.hi_notebook;
end;

procedure  MyNoteBook.aftercreate; {*1}
  var
    a, f, ff, l0, DC : longint;

procedure Columns;
  var
    f, l : longint;
begin
l := MaxMems;
for f := 0 to l do begin
ListView.InsertColumn(f, ff, 100, '');
end; {next f}
end;
begin

ListViewIl   := TImageList.Create(app.hinstance, 32, 32, book_lvil_max, book_lvil_max, ILC_COLOR);
ListViewIlS  := TImageList.Create(app.hinstance, 16, 16, book_lvil_max, book_lvil_max, ILC_COLOR);
TreeViewIl   := TImageList.Create(app.hinstance, 12, 12, 7, 7, ILC_COLOR);

lvilokloaded := not LoadLvIl;

ListView     := TListView.Create;
ListView.Crt(hwnd, app.hinstance, book_tv_w, 0, 200, 300,
 LVS_ICON or LVS_AUTOARRANGE or LVS_SHAREIMAGELISTS or LVS_SHOWSELALWAYS or WS_CHILD,
WS_EX_OVERLAPPEDWINDOW, 0, nil);
SetLVView(app.tun.book_lv_view);

if lvilokloaded then begin
ListView.AssociateImageList(ListViewIl.fhwnd, true);
ListView.AssociateImageList(ListViewIlS.fhwnd, false);
end; {end if}

ListView_SetExtendedListViewStyle(ListView.hwnd, LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT);
Columns;    ShowWindow(ListView.hwnd, SW_SHOW);

TreeView         := TTreeView.Create;
TreeView.CreateWnd(hwnd, app.hinstance, 0, 0, book_tv_w, 300, true, true, true, true, true);

TreeViewIl.AddFromResouce('ARR001'); TreeViewIl.AddFromResouce('ARR002');
TreeViewIl.AddFromResouce('ARR003'); TreeViewIl.AddFromResouce('ROMB001');
TreeViewIl.AddFromResouce('ROMB002'); TreeViewIl.AddFromResouce('ROMB003');
TreeViewIl.AddFromResouce('CIR002');

for f := 0 to book_menu_root_max do begin
l0 := TreeView.JustInsertItem(0, true, true, false, true, false, book_menu_root[f], book_menu_root_act[f], 0, 0);
case f of
0: H_PEOP_FAM   := l0;
1: H_PEOP_GR    := l0;
2: H_PEOP_SEX   := l0;
3: H_ORG_GR     := l0;
4: for ff := 0 to book_menu_view_max do TreeView.JustInsertItem(l0, true, true, true, true, false, book_menu_view[ff], book_menu_view_act[ff], 2, 2);
5: for ff := 0 to book_menu_edit_max do TreeView.JustInsertItem(l0, true, true, true, true, false, book_menu_edit[ff], book_menu_edit_act[ff], 1, 1);
6: for ff := 0 to book_menu_file_max do TreeView.JustInsertItem(l0, true, true, true, true, false, book_menu_file[ff], book_menu_file_act[ff], 0, 0);
end; {end select}
   if f > 3 then TreeView.ExpandItem(3, l0);
end; {next f}

BookFileP(false); BookFileO(false);

if app.stun.book_maximize then ShowWindow(hwnd, SW_SHOWMAXIMIZED) else ShowWindow(hwnd, SW_SHOWNORMAL);
TreeView.AssociateImageList(TreeViewIl.fhwnd, true);
tab := true;

 PostMessage(hwnd, WM_EUREKA, startaction, 0);

{}
 DC := GetWindowDC(ListView.hwnd);
 SelectObject(DC, hf_clock);
 SetTextAlign(dc, TA_LEFT);
 TextOut(DC, 10, 25, PCHar(book_starthint), Length(book_starthint));
 ReleaseDC(ListView.hwnd, DC);
{}

end;

procedure  MyNoteBook.OnClose; begin close; end;
procedure  MyNoteBook.Close;
begin
    efBook := false;
    ListViewIl.Destroy;
    ListViewIlS.Destroy;
    TreeViewIl.Destroy;
    if efDlgPeople then PeopleDlg.Close;
    if efDlgOrg then OrgDlg.Close;
    destroy; end;
procedure  MyNoteBook.OnGMM; {WM_GETMINMAXINFO}
  var  p : PMINMAXINFO; begin p := Pointer(msg.LParam);
  p^.ptMinTrackSize.x := 400; p^.ptMinTrackSize.y := 250;
 msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, Integer(p));
end;
procedure  MyNoteBook.OnSize;{WM_SIZE} begin msg.Result := DefWindowProc(hwnd, msg.msg, TMessage(msg).WParam, TMessage(msg).LParam); cpos; end;
procedure  MyNoteBook.OnMove;{WM_MOVE} begin msg.Result := DefWindowProc(hwnd, msg.msg, TMessage(msg).WParam, TMessage(msg).LParam); cpos; end;

procedure MyNoteBook.OnNotify;  {WM_NOTIFY}
  var
    pntv  : PNmTreeView;
    tlvi  : TLVHitTestInfo;
    l     : TLVItem;
    tmp   : longint;
begin
 msg.Result := DefWindowProc(hwnd, msg.msg, TMessage(msg).WParam, TMessage(msg).LParam);
if msg.NMHdr.hwndFrom = TreeView.fhwnd then begin
  pntv := Pointer(TMessage(msg).LParam);
  case msg.NMHdr.code of

  TVN_SELCHANGED : begin
         try
             pntv^.itemNew.mask                := TVIF_TEXT or TVIF_PARAM;
             pntv^.itemNew.cchTextMax          := book_max_mems_len;
             GetMem(pntv^.itemNew.pszText, book_max_mems_len);
             SendMessage(TreeView.fhwnd, TVM_GETITEM, 0, Longint(@pntv^.itemNew));

     case pntv^.action of
     TVC_BYMOUSE    :  begin
     act(pntv^.itemNew.lParam, String(pntv^.itemNew.pszText));
     memkeysel := 0; memclickstr := '';
     PostMessage(TreeView.fhwnd, TVM_SELECTITEM, TVGN_CARET, Integer(0{hroot}));
     end;
     TVC_BYKEYBOARD :  begin
     memkeysel := pntv^.itemNew.lParam;
     memclickstr := String(pntv^.itemNew.pszText);
     end;
     end; {end select}
         finally FreeMem(pntv^.itemNew.pszText); end;
  end;

  NM_SETFOCUS :  begin
      PostMessage(TreeView.fhwnd, TVM_SELECTITEM, TVGN_CARET, Integer(0{hroot}));
      ftab       := true;
                 end;
  end; {end select}
end; {end if}

if msg.NMHdr.hwndFrom = ListView.hwnd then begin
   case msg.NMHdr.code of
//   LVN_COLUMNCLICK : beep;
   NM_CLICK        : begin
       if not(0 <> (GetAsyncKeyState(VK_CONTROL) and -32768)) then begin
       GetCursorPos(tlvi.pt);  ScreenToClient(ListView.hwnd, tlvi.pt);
       commctrl.ListView_HitTest(ListView.hwnd, tlvi);
        if (tlvi.iItem > -1) then begin
        l.mask := LVIF_PARAM;
        l.iItem := tlvi.iItem;
        l.iSubItem := 0;
        if commctrl.ListView_GetItem(ListView.hwnd, l) then
          if ((l.lParam and bit31) = 0) then ShowDlgPeople(l.lParam, false)
             else begin ShowDlgOrg(l.lParam xor bit31, false); end;

        end; {end if}
       end; {end if}
   end;
   NM_SETFOCUS : ftab := false;
   LVN_GETDISPINFO : begin
         PLvDispInfo(msg.NMHdr).item.mask := LVIF_TEXT or LVIF_DI_SETITEM;
         if (PLvDispInfo(msg.NMHdr).item.lParam and bit31) = 0 then begin
         PLvDispInfo(msg.NMHdr).item.pszText := PCHar(book.pnb[PLvDispInfo(msg.NMHdr).item.lParam].a[PLvDispInfo(msg.NMHdr).item.iSubItem]);
         end else begin  // depedent <> peopl - org
         tmp := PLvDispInfo(msg.NMHdr).item.iSubItem;
         if max_org_mem >= tmp then
          PLvDispInfo(msg.NMHdr).item.pszText := PCHar(book.onb[PLvDispInfo(msg.NMHdr).item.lParam xor bit31].a[tmp])
         else  PLvDispInfo(msg.NMHdr).item.pszText := '';
         end; {end if}
   end;
   end; {end select}
end; {end if}
end;

procedure MyNoteBook.WindowProcedure(var Msg : TMessage);
  var d : TDecodeKey; ctrl, shift : boolean;
      tmp   : longint; l : TLVItem;
begin
case msg.Msg of
     WM_KEYDOWN: begin
      d := DecodeKey(msg.WParam, msg.LParam);
       ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
       shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;
  //    msg.result := 1;
      case d.virt of
       9         : msg.result := 1;
       VK_RETURN : msg.result := 1;
       VK_ESCAPE : begin close; msg.Result := 1; end;
       65        : msg.result := 1;
    //   VK_DELETE : delete;
      else
          msg.result := 0;
      end; {end select}

     end;
     WM_ACTIVATE :  tab := tab;
     WM_KEYUP: begin
      d := DecodeKey(msg.WParam, msg.LParam);
       ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
       shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;
//      msg.Result := 1;
      case d.virt of
           9    : begin tab := not tab; msg.Result := 1; end;
           65   : begin ListView.SelectAll; msg.Result := 1; end;
           VK_DELETE : del;
           VK_RETURN : if not tab then begin
            tmp := ListView.GetFocusedItemIndex;
            if tmp > -1 then begin
            l := ListView.GetFocusedItem(tmp);
//            dint(l.lParam);
          if ((l.lParam and bit31) = 0) then ShowDlgPeople(l.lParam, false)
             else begin ShowDlgOrg(l.lParam xor bit31, false); end;
            msg.Result := 1;
                        end; {end if tmp>-1}
                                   end else begin
     act(memkeysel, memclickstr); memkeysel := 0; memclickstr := '';
     PostMessage(TreeView.fhwnd, TVM_SELECTITEM, TVGN_CARET, Integer(0));

                                   end; {end if tab}
//           VK_F1     : app.ShowHelp(4);
      else
          msg.result := 0;
      end; {end select d.virt}
     end; {ku}
else
    Dispatch(msg);
end; {end select msg.msg}
end;

procedure MyNoteBook.CPos;
begin MemPosChange;  app.stun.book_maximize := isZoomed(hwnd);
if (not app.stun.book_maximize) and (not isIconic(hwnd)) then begin
 app.stun.book_width := FWidth; app.stun.book_height := FHeight;
 app.stun.book_top := FTop;     app.stun.book_left := FLeft;
end; {end if}
 SetWindowPos(ListView.hwnd, ListView.hwnd, 0, 0, FCWidth - book_tv_w - 1, FCHeight - 1, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOZORDER);
 SetWindowPos(TreeView.fhwnd, ListView.hwnd, 0, 0, book_tv_w, FCHeight - 1, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOZORDER);
end;

procedure   MyNoteBook.ClearColumnsName;
  var       f, l : longint; lc   : TLVColumn;
begin   l := MaxMems;
for f := 0 to l do begin lc.mask := LVCF_TEXT; lc.pszText := '';
    SendMessage(ListView.hwnd, LVM_SETCOLUMN, f, Longint(@lc)); end; {next f} end;

procedure   MyNoteBook.LoadFamilys;
  var
    f, ff : longint;
    tmp   : string;
begin for f := 0 to MAX_BOOK do psx[f] := '';
for f := 0 to MAX_BOOK * 2 do begin fams[f] := ''; pgr[f] := ''; end;

for f := 0 to MAX_BOOK do begin
if not book.pnb[f].ex then continue;
fams[f]            := book.pnb[f].a[const_book_p_fam1];
fams[f + MAX_BOOK] := book.pnb[f].a[const_book_p_fam2];
pgr[f]             := book.pnb[f].a[const_book_p_gr1];
pgr[f + MAX_BOOK]  := book.pnb[f].a[const_book_p_gr2];
psx[f]             := book.pnb[f].a[const_book_p_sex];
end; {next f}

for f := 1 to MAX_BOOK * 2 do begin
tmp := AUpperCase(fams[f]);
  for ff := 0 to f - 1 do if FastAnsiTextCompare(fams[ff], tmp) then
     begin fams[ff] := ''; break; end;
end; {next f}

for f := 1 to MAX_BOOK * 2 do begin
tmp := AUpperCase(pgr[f]);
  for ff := 0 to f - 1 do if FastAnsiTextCompare(pgr[ff], tmp) then
     begin pgr[ff] := ''; break; end;
end; {next f}

for f := 1 to MAX_BOOK do begin
tmp := AUpperCase(psx[f]);
  for ff := 0 to f - 1 do if FastAnsiTextCompare(psx[ff], tmp) then
     begin psx[ff] := ''; break; end;
end; {next f}

TreeView.ExpandItem(2, H_PEOP_FAM);TreeView.ExpandItem(2, H_PEOP_GR);TreeView.ExpandItem(2, H_PEOP_SEX);
for f := 0 to max_book * 2 do if fams[f] <> '' then TreeView.JustInsertItem(H_PEOP_FAM, true, true, true, true, false, fams[f], 101, 5, 5);
for f := 0 to max_book * 2 do if  pgr[f] <> '' then TreeView.JustInsertItem(H_PEOP_GR, true, true, true, true, false, pgr[f], 102, 4, 4);
for f := 0 to max_book     do if  psx[f] <> '' then TreeView.JustInsertItem(H_PEOP_SEX, true, true, true, true, false, psx[f], 103, 6, 6);
end;

procedure   MyNoteBook.LoadFirms;
  var
    f, ff      : longint;
    tmp        : string;
begin for f := 0 to MAX_BOOK * 2 do ogr[f] := '';

for f := 0 to MAX_BOOK do begin
if not book.onb[f].ex then continue;
ogr[f] := book.onb[f].a[const_book_o_gr1];
ogr[f + MAX_BOOK] := book.onb[f].a[const_book_o_gr2];
end; {next f}

for f := 1 to MAX_BOOK * 2 do begin
tmp := AUpperCase(ogr[f]);
  for ff := 0 to f - 1 do if FastAnsiTextCompare(ogr[ff], tmp) then
     begin ogr[ff] := ''; break; end;
end; {next f}
TreeView.ExpandItem(2, H_ORG_GR); for f := 0 to max_book * 2 do if  ogr[f] <> '' then TreeView.JustInsertItem(H_ORG_GR, true, true, true, true, false, ogr[f], 111, 3, 3);
end;

procedure   MyNoteBook.BookFileP(savetrue : boolean);
begin
if savetrue then CopyFile(PCHar(nbp_fn), PCHar(u_dir + ExtractFileNameNoExt(nbp_fn) + '.bak'), false);
if savetrue then
 if book.FilePnb(nbp_fn, true, false, book_lvil_max)
  then MessageBox(hwnd, book_file_p_save_err, PCHar(app_name), 16);

 if book.FilePnb(nbp_fn, false, true, book_lvil_max)
  then MessageBox(hwnd, book_file_p_load_err, PCHar(app_name), 16) else LoadFamilys;
end;
procedure   MyNoteBook.BookFileO(savetrue : boolean);
begin
if savetrue then CopyFile(PCHar(nbo_fn), PCHar(u_dir + ExtractFileNameNoExt(nbo_fn) + '.bak'), false);
if savetrue then
 if book.FileOnb(nbo_fn, true, false, book_lvil_max)
  then MessageBox(hwnd, book_file_o_save_err, PCHar(app_name), 16);

 if book.FileOnb(nbo_fn, false, true, book_lvil_max)
  then MessageBox(hwnd, book_file_o_load_err, PCHar(app_name), 16) else LoadFirms;
end;

function    MyNoteBook.LoadLvIl : boolean;
label       eexx;
  var
    hl,    // hlib
    hb,    // hbitmap
    hbs,   // hsmallbitmap
    hzb,   // hzerobitmap
    hzbs   // hzerobitmapsmall
    : THandle;
    f, ss, sb   : longint;
begin  result := false;
hl := LoadLibrary(PCHar(icn_fn));

if hl = 0 then begin result := true; exit; end;

for f := 0 to book_lvil_max do begin
    hb := LoadBitmap(hl, PCHar(String('BTMP' + inttostr(f))));

          if f = 0 then begin
    if hb = 0 then begin result := true; goto eexx; end else hzb := hb;
    hzbs := CopyImage (hzb, IMAGE_BITMAP, 16, 16, 0);
    if hzbs = 0 then begin result := true; goto eexx; end;
          end; {end if}

    if hb = 0 then begin
          ListViewIl.AddBitmapHandle(hzb);
    hbs := CopyImage (hzb, IMAGE_BITMAP, 16, 16, 0);
    end else begin
          ListViewIl.AddBitmapHandle(hb);
    hbs := CopyImage (hb, IMAGE_BITMAP, 16, 16, 0);
    if f > 0 then    DeleteObject(hb);
    end; {end if}

    if hbs = 0 then begin
          ListViewIlS.AddBitmapHandle(hzbs);
    end else begin
          ListViewIlS.AddBitmapHandle(hbs);
          DeleteObject(hbs);
    end; {end if}

end; {next f}

sb := ListViewIl.Count;
ss := ListViewIlS.Count;
if (ss <> sb) or (ss = 0) then result := true;

eexx:
FreeLibrary(hl);
end;

procedure   MyNoteBook.LoadColumnNameForPeoples; var f : longint;
begin for f := 0 to max_peop_mem do ListView.ColumnText[f] := book_people_mem_names[f]; end;
procedure   MyNoteBook.LoadColumnNameForOrg; var f : longint;
begin for f := 0 to max_org_mem do ListView.ColumnText[f] := book_org_mem_names[f]; end;
procedure   MyNoteBook.SetTab(Value : boolean); begin ftab := value; if ftab then SetFocus(TreeView.fhwnd) else SetFocus(ListView.hwnd); end;

procedure   MyNoteBook.Act(n : longint; s : string);
begin
case n of
1           :  PostMessage(hwnd, WM_CLOSE, 0, 0);
4           :  begin app.ShowHelp(4); PostMessage(hhelp, WM_ACTIVATE, WA_CLICKACTIVE, 0); end;
100..300    :  SetView(n, s, false);
1000..1003  :  SetLVView(n - 1000);
1100        :  SendMessage(hwnd, WM_EUREKA, 1, 0);
1200        :  SendMessage(hwnd, WM_EUREKA, 2, 0);
1300        :  ListView.SelectAll;
1400        :  Del;
1500        :  www;
1600        :  mailto;

2100        :  ChangeAll;
2200        :  PlusFile;
2300        :  SaveAs;
2400        :  SaveSel;
2500        :  Info;
end; {end select}
end;

procedure   MyNoteBook.SetLVView(b : byte); var tmp : longint; begin tmp := 0;
app.tun.book_lv_view := b; ListView.ViewType := b; end;

procedure   MyNoteBook.SetView(v : longint; s : string; old : boolean);
  var
    f, cnt  : longint;
    tmp     : string;
    ok      : boolean;

procedure InsertPeople(p : TPeopleRecord; i, par : longint);
  var       f : longint; begin for f := 0 to max_peop_mem do
    ListView.InsertTextCallbackItem(i, f, p.ii, {p.a[f],} par, true); end;
procedure InsertOrg(p : TOrgRecord; i, par : longint);
  var     f : longint; begin for f := 0 to max_org_mem do
    ListView.InsertTextCallbackItem(i, f, p.ii, {p.a[f],} par, true); end;

begin cnt := 0; ShowWindow(hwnd, SW_HIDE);
if not old then begin
fview := v; fpeoptrue := (fview > 99) and (fview < 110); find_str := AUpperCase(s);
end; {end if}
ListView.Clear; ClearColumnsName;
 if fpeoptrue then LoadColumnNameForPeoples else LoadColumnNameForOrg;

for f := 0 to MAX_BOOK do begin
ok := false;
if fpeoptrue then begin if not book.pnb[f].ex then continue;
case fview of
100: ok := true;
101: ok := FastAnsiTextCompare(book.pnb[f].a[const_book_p_fam1], find_str) or FastAnsiTextCompare(book.pnb[f].a[const_book_p_fam2], find_str);
102: ok := FastAnsiTextCompare(book.pnb[f].a[const_book_p_gr1], find_str) or  FastAnsiTextCompare(book.pnb[f].a[const_book_p_gr2], find_str);
103: ok := FastAnsiTextCompare(book.pnb[f].a[const_book_p_sex], find_str);
end; {end select}
if ok then begin InsertPeople(book.pnb[f], cnt, f); inc(cnt) end;
end else begin if not book.onb[f].ex then continue;
case fview of
110: ok := true;
111: ok := FastAnsiTextCompare(book.onb[f].a[const_book_o_gr1], find_str) or FastAnsiTextCompare(book.onb[f].a[const_book_o_gr2], find_str);
end; {end select}
if ok then begin InsertOrg(book.onb[f], cnt, f or bit31); inc(cnt) end;
end; {end if}
end; {next f}

ShowWindow(hwnd, SW_SHOW);
end;

procedure   MyNoteBook.ShowDlgPeople(n : longint; newpeople : boolean);
begin
if efDlgPeople then begin
 if isIconic(hDlgPeople) then ShowWindow(hDlgPeople, SW_SHOWNORMAL);
 BringWindowToTop(hDlgPeople); SetForegroundWindow(hDlgPeople);
end else begin
PeopleDlg := MyPeopleDlg.Create(n, newpeople); hDlgPeople := PeopleDlg.hwnd;
BringWindowToTop(hDlgPeople);
 SetForegroundWindow(hDlgPeople);
end; {end if}
end;

procedure   MyNoteBook.ShowDlgOrg(n : longint; neworg : boolean);
begin
if efDlgOrg then begin
 if isIconic(hDlgOrg) then ShowWindow(hDlgOrg, SW_SHOWNORMAL);
 BringWindowToTop(hDlgOrg); SetForegroundWindow(hDlgOrg);
end else begin
OrgDlg := MyOrgDlg.Create(n, neworg); hDlgOrg := OrgDlg.hwnd;
BringWindowToTop(hDlgOrg);
 SetForegroundWindow(hDlgOrg);
end; {end if}
end;

function    MyNoteBook.NowPeople : boolean;
  var
    tm      : longint;
begin if efDlgPeople then begin ShowDlgPeople(tm, true); PostMessage(PeopleDlg.ListView.hwnd, WM_ACTIVATE, WA_CLICKACTIVE, 0); exit; end;
tm := book.GetFreePNb;
result := (tm = $FFFFFFFF);
if result then begin MessageBox(hwnd, PCHar(book_p_tobig + inttostr(max_book + 1)), PCHar(app_name), 16); exit; end;
book.pnb[tm].ex := true;
ShowDlgPeople(tm, true);
if efDlgPeople then PostMessage(PeopleDlg.ListView.hwnd, WM_ACTIVATE, WA_CLICKACTIVE, 0);
end;

function    MyNoteBook.NowOrg : boolean;
  var
    tm      : longint;
begin if efDlgOrg then begin ShowDlgOrg(tm, true); PostMessage(OrgDlg.ListView.hwnd, WM_ACTIVATE, WA_CLICKACTIVE, 0); exit; end;
tm := book.GetFreeONb;
result := (tm = $FFFFFFFF);
if result then begin MessageBox(hwnd, PCHar(book_o_tobig + inttostr(max_book + 1)), PCHar(app_name), 16); exit; end;
book.onb[tm].ex := true;
ShowDlgOrg(tm, true);
if efDlgOrg then PostMessage(OrgDlg.ListView.hwnd, WM_ACTIVATE, WA_CLICKACTIVE, 0);
end;

procedure   MyNoteBook.OnEUREKA(Var Msg : TMessage);
begin
case msg.WParam of
    1 : NowPeople;
    2 : NowOrg;

end; {end select}
end;

procedure   MyNoteBook.DelPeople(n : longint);
begin
   if efDlgPeople then if PeopleDlg.numb = n then exit;
   book.pnb[n].ex := false;
end;

procedure   MyNoteBook.DelOrg(n : longint);
begin
   if efDlgOrg then if OrgDlg.numb = n then exit;
   book.onb[n].ex := false;
end;

procedure   MyNoteBook.Del;
  var
    f, l, sc   : longint;
    p          : TLVItem;
    pc, oc     : boolean;
begin pc := false; oc := pc;
sc := ListView.GetSelectedCount;
if sc = 0 then exit;
if MessageBox(hwnd, PCHar(book_del_confirm + inttostr(sc)), PCHar(app_name), bit9 or bit6 or bit5 or bit3) <> ID_YES then exit;

l := ListView.GetItemsCount;
for f := 0 to l - 1 do begin
if ListView.isItemSelected(f) then begin
   p.mask :=       LVIF_PARAM;
   p.iItem :=      f;
   p.iSubItem :=   0;
   SendMessage(ListView.hwnd, LVM_GETITEM, 0, Longint(@p));
   if (p.lParam and bit31) = 0 then begin DelPeople(p.lParam); pc := true; end
                               else begin DelOrg(p.lParam xor bit31); oc := true; end;
end; {end if}
end; {next f}
   if pc then BookFileP(true);
   if oc then BookFileO(true);
   if pc or oc then SetView(0, '', true);
end;

procedure   MyNoteBook.SaveAs;
  var
    fd : MyFileDlg;
    peopletrue : boolean;
begin if efDlgPeople or efDlgOrg then exit;
case MessageBox(hwnd, book_savas_q, PCHar(app_name), bit1 or bit2 or bit6) of
ID_CANCEL : exit;
ID_YES    : PeopleTrue := true;
ID_NO     : PeopleTrue := false;
end; {end select}

fd := MyFileDlg.Create;
  if fd.GetFileName(hwnd, app.hinstance, 'Text Files (.TXT)'#0'*.txt'#0, 0, 'TXT', 'c:\', true, '')
                             then begin
     if PeopleTrue then begin
      if book.FilePnb(fd.FileName, true, false, book_lvil_max) then MessageBox(hwnd, PCHar(book_savas_err + fd.FileName), PCHar(app_name), bit5);
     end else begin
      if book.FileOnb(fd.FileName, true, false, book_lvil_max) then MessageBox(hwnd, PCHar(book_savas_err + fd.FileName), PCHar(app_name), bit5);
     end; {end if}
                             end; {end if}
          fd.Free;
end;

procedure   MyNoteBook.SaveSel;
label  eerr;
  var
    f       : longint;
    fd      : MyFileDlg;
    fp      : TextFile;
    es, s   : string;
    p_r     : TPeopleRecord;
    o_r     : TOrgRecord;
    p       : TLVItem;
begin if efDlgPeople or efDlgOrg then exit;
if 1 > ListView.GetSelectedCount then exit;
fd := MyFileDlg.Create;
if not fd.GetFileName(hwnd, app.hinstance, 'Text Files (.TXT)'#0'*.txt'#0, 0, 'TXT', 'c:\', true, '') then exit;

FileSetAttr(fd.FileName, FaArchive);  AssignFile (fp, fd.FileName);

es := '';
{$I-}
rewrite(fp);
{$I+}  if IOResult <> 0 then begin es := 'Error Rewrite Save Sel'; goto eerr; end;

for f := 0 to ListView.GetItemsCount - 1 do begin

if ListView.isItemSelected(f) then begin
   p.mask :=       LVIF_PARAM;
   p.iItem :=      f;
   p.iSubItem :=   0;
   SendMessage(ListView.hwnd, LVM_GETITEM, 0, Longint(@p));
   if (p.lParam and bit31) = 0 then s := book.pnb[p.lParam].ExportString
                               else s := book.onb[p.lParam xor bit31].ExportString;
end; {end if}

{$I-}
writeln(fp, s);
{$I+} if IOResult <> 0 then begin es := 'Error Write Save Sel'; goto eerr; end;

end; {next f}

eerr:
{$I-}
closefile(fp);
{$I+} if IOResult <> 0 then es := 'Error Close Save Sel';
if es <> '' then MessageBox(hwnd, PCHar(es), PCHar(app_name), 16);
end;

procedure   MyNoteBook.ChangeAll;
  var
    fd         : MyFileDlg;
    peopletrue : boolean;
begin if efDlgPeople or efDlgOrg then exit;
case MessageBox(hwnd, book_ch_q, PCHar(app_name), bit1 or bit2 or bit6) of
ID_CANCEL : exit;
ID_YES    : PeopleTrue := true;
ID_NO     : PeopleTrue := false;
end; {end select}
if MessageBox(hwnd, book_ch_w, PCHar(app_name), bit3 or bit5 or bit6) <> ID_YES then exit;
       fd := MyFileDlg.Create;
if not fd.GetFileName(hwnd, app.hinstance, 'Text Files (.TXT)'#0'*.txt'#0, 0, 'TXT', 'c:\', false, '') then exit;
              ShowWindow(hwnd, SW_HIDE);
if PeopleTrue then begin

if book.FilePnb(fd.FileName, false, true, book_lvil_max) then MessageBox(hwnd, PCHar(book_ch_err + fd.FileName), PCHar(app_name), bit5);
if book.FilePnb(nbp_fn, true, false, book_lvil_max) then MessageBox(hwnd, PCHar(book_sf_err + fd.FileName), PCHar(app_name), bit5);
 LoadFamilys;

end else begin

if book.FileOnb(fd.FileName, false, true, book_lvil_max)  then MessageBox(hwnd, PCHar(book_ch_err + fd.FileName), PCHar(app_name), bit5);
if book.FileOnb(nbo_fn, true, false, book_lvil_max)  then MessageBox(hwnd, PCHar(book_sf_err + fd.FileName), PCHar(app_name), bit5);
 LoadFirms;

end; {end if}
 SetView(0, '', true);
end;

procedure   MyNoteBook.PlusFile;
  var
    fd         : MyFileDlg;
    peopletrue : boolean;
begin if efDlgPeople or efDlgOrg then exit;
case MessageBox(hwnd, book_pl_q, PCHar(app_name), bit1 or bit2 or bit6) of
ID_CANCEL : exit;
ID_YES    : PeopleTrue := true;
ID_NO     : PeopleTrue := false;
end; {end select}
fd := MyFileDlg.Create;
if not fd.GetFileName(hwnd, app.hinstance, 'Text Files (.TXT)'#0'*.txt'#0, 0, 'TXT', 'c:\', false, '') then exit;
              ShowWindow(hwnd, SW_HIDE);
if PeopleTrue then begin

if book.FilePnb(fd.FileName, false, false, book_lvil_max) then MessageBox(hwnd, PCHar(book_opf_err + fd.FileName), PCHar(app_name), bit5);
if book.FilePnb(nbp_fn, true, false, book_lvil_max) then MessageBox(hwnd, PCHar(book_sf_err + fd.FileName), PCHar(app_name), bit5);
 LoadFamilys;

end else begin

if book.FileOnb(fd.FileName, false, false, book_lvil_max) then MessageBox(hwnd, PCHar(book_opf_err + fd.FileName), PCHar(app_name), bit5);
if book.FileOnb(nbo_fn, true, false, book_lvil_max) then MessageBox(hwnd, PCHar(book_sf_err + fd.FileName), PCHar(app_name), bit5);
 LoadFirms;

end; {end if}
 SetView(0, '', true);
end;

procedure   MyNoteBook.MailTo;
  var
    f : longint;
    p : TLVItem;
    s : string;
begin s := '';
    f := ListView.GetFocusedItemIndex;
    if f = -1 then exit;
    
    p := ListView.GetFocusedItem(f);

if (p.lParam and bit31) = 0 then begin
    s := book.pnb[p.lParam].a[const_book_p_mail];
end else begin
    s := book.onb[p.lParam xor bit31].a[const_book_o_mail];
end; {end if}
    if s = '' then exit;
    Shell(PCHar('mailto:' + s), '', SW_SHOWNORMAL);
    ShowWindow(hwnd, SW_MINIMIZE);
end;

procedure   MyNoteBook.WWW;
  var
    f : longint;
    p : TLVItem;
    s : string;
begin
    f := ListView.GetFocusedItemIndex;
    if f = -1 then exit;
    p := ListView.GetFocusedItem(f);

if (p.lParam and bit31) = 0 then begin
    s := book.pnb[p.lParam].a[const_book_p_www];
end else begin
    s := book.onb[p.lParam xor bit31].a[const_book_o_www];
end; {end if}
    if s = '' then exit;
    Shell(PCHar('http://' + s), '', SW_SHOWNORMAL);
    ShowWindow(hwnd, SW_MINIMIZE);    
end;

procedure   MyNoteBook.Info;
begin
  MessageBox(hwnd,
  PCHar(
  book_info_p +
  book_info_file +
  nbp_fn + #10 +
  book_info_recs +
  inttostr(book.GetPCount) + #10#10 +
  book_info_o +
  book_info_file +
  nbo_fn + #10 +
  book_info_recs +
  inttostr(book.GetOCount)
  )
  , book_info_capt, bit7);
end;

end.
